/* candidate-list.c generated by valac 0.56.17, the Vala compiler
 * generated from candidate-list.vala, do not modify */

/*
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libkkc/libkkc.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	KKC_CANDIDATE_LIST_0_PROPERTY,
	KKC_CANDIDATE_LIST_CURSOR_POS_PROPERTY,
	KKC_CANDIDATE_LIST_SIZE_PROPERTY,
	KKC_CANDIDATE_LIST_PAGE_START_PROPERTY,
	KKC_CANDIDATE_LIST_PAGE_SIZE_PROPERTY,
	KKC_CANDIDATE_LIST_ROUND_PROPERTY,
	KKC_CANDIDATE_LIST_PAGE_VISIBLE_PROPERTY,
	KKC_CANDIDATE_LIST_NUM_PROPERTIES
};
static GParamSpec* kkc_candidate_list_properties[KKC_CANDIDATE_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	KKC_CANDIDATE_LIST_POPULATED_SIGNAL,
	KKC_CANDIDATE_LIST_SELECTED_SIGNAL,
	KKC_CANDIDATE_LIST_NUM_SIGNALS
};
static guint kkc_candidate_list_signals[KKC_CANDIDATE_LIST_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KkcCandidateListPrivate {
	GeeArrayList* _candidates;
	gint _cursor_pos;
	GeeMap* seen;
	guint _page_start;
	guint _page_size;
	gboolean _round;
};

static gint KkcCandidateList_private_offset;
static gpointer kkc_candidate_list_parent_class = NULL;

VALA_EXTERN void kkc_candidate_list_clear (KkcCandidateList* self);
VALA_EXTERN gboolean kkc_candidate_list_contains (KkcCandidateList* self,
                                      KkcCandidate* candidate);
VALA_EXTERN gboolean kkc_candidate_list_add (KkcCandidateList* self,
                                 KkcCandidate* candidate);
VALA_EXTERN gboolean kkc_candidate_list_add_all (KkcCandidateList* self,
                                     KkcCandidateList* other);
VALA_EXTERN KkcCandidate** kkc_candidate_list_to_array (KkcCandidateList* self,
                                            gint* result_length1);
static guint kkc_candidate_list_get_page_start_cursor_pos (KkcCandidateList* self,
                                                    guint pos);
static gboolean kkc_candidate_list_real_next (KkcCandidateList* self);
static gboolean kkc_candidate_list_real_previous (KkcCandidateList* self);
static gboolean kkc_candidate_list_update_cursor_pos (KkcCandidateList* self,
                                               guint pos);
static gboolean kkc_candidate_list_cursor_move (KkcCandidateList* self,
                                         gint step);
static gboolean kkc_candidate_list_page_move (KkcCandidateList* self,
                                       gint step);
static void kkc_candidate_list_finalize (GObject * obj);
static GType kkc_candidate_list_get_type_once (void);
static void _vala_kkc_candidate_list_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_kkc_candidate_list_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
kkc_candidate_list_get_instance_private (KkcCandidateList* self)
{
	return G_STRUCT_MEMBER_P (self, KkcCandidateList_private_offset);
}

/**
         * Get the current candidate at the given index.
         *
         * @param index candidate position (-1 for the current cursor position)
         *
         * @return a Candidate
         */
KkcCandidate*
kkc_candidate_list_get (KkcCandidateList* self,
                        gint index)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	KkcCandidate* result;
#line 50 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "candidate-list.vala"
	if (index < 0) {
#line 52 "candidate-list.vala"
		index = self->priv->_cursor_pos;
#line 131 "candidate-list.c"
	}
#line 53 "candidate-list.vala"
	if (0 <= index) {
#line 135 "candidate-list.c"
		gint _tmp1_;
		gint _tmp2_;
#line 53 "candidate-list.vala"
		_tmp1_ = kkc_candidate_list_get_size (self);
#line 53 "candidate-list.vala"
		_tmp2_ = _tmp1_;
#line 53 "candidate-list.vala"
		_tmp0_ = index < _tmp2_;
#line 144 "candidate-list.c"
	} else {
#line 53 "candidate-list.vala"
		_tmp0_ = FALSE;
#line 148 "candidate-list.c"
	}
#line 53 "candidate-list.vala"
	_vala_assert (_tmp0_, "0 <= index && index < size");
#line 54 "candidate-list.vala"
	_tmp3_ = self->priv->_candidates;
#line 54 "candidate-list.vala"
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, index);
#line 54 "candidate-list.vala"
	result = (KkcCandidate*) _tmp4_;
#line 54 "candidate-list.vala"
	return result;
#line 160 "candidate-list.c"
}

void
kkc_candidate_list_clear (KkcCandidateList* self)
{
	gboolean is_populated = FALSE;
	gboolean is_cursor_changed = FALSE;
	GeeMap* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 68 "candidate-list.vala"
	g_return_if_fail (self != NULL);
#line 69 "candidate-list.vala"
	is_populated = FALSE;
#line 70 "candidate-list.vala"
	is_cursor_changed = FALSE;
#line 71 "candidate-list.vala"
	_tmp0_ = self->priv->seen;
#line 71 "candidate-list.vala"
	gee_map_clear (_tmp0_);
#line 72 "candidate-list.vala"
	_tmp1_ = self->priv->_candidates;
#line 72 "candidate-list.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 72 "candidate-list.vala"
	_tmp3_ = _tmp2_;
#line 72 "candidate-list.vala"
	if (_tmp3_ > 0) {
#line 190 "candidate-list.c"
		GeeArrayList* _tmp4_;
#line 73 "candidate-list.vala"
		_tmp4_ = self->priv->_candidates;
#line 73 "candidate-list.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp4_);
#line 74 "candidate-list.vala"
		is_populated = TRUE;
#line 198 "candidate-list.c"
	}
#line 76 "candidate-list.vala"
	if (self->priv->_cursor_pos >= 0) {
#line 77 "candidate-list.vala"
		self->priv->_cursor_pos = -1;
#line 78 "candidate-list.vala"
		is_cursor_changed = TRUE;
#line 206 "candidate-list.c"
	}
#line 84 "candidate-list.vala"
	if (is_populated) {
#line 85 "candidate-list.vala"
		g_signal_emit (self, kkc_candidate_list_signals[KKC_CANDIDATE_LIST_POPULATED_SIGNAL], 0);
#line 212 "candidate-list.c"
	}
#line 87 "candidate-list.vala"
	if (is_cursor_changed) {
#line 88 "candidate-list.vala"
		g_object_notify ((GObject*) self, "cursor-pos");
#line 218 "candidate-list.c"
	}
}

gboolean
kkc_candidate_list_contains (KkcCandidateList* self,
                             KkcCandidate* candidate)
{
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 92 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 92 "candidate-list.vala"
	g_return_val_if_fail (candidate != NULL, FALSE);
#line 93 "candidate-list.vala"
	_tmp0_ = self->priv->seen;
#line 93 "candidate-list.vala"
	_tmp1_ = kkc_candidate_get_output (candidate);
#line 93 "candidate-list.vala"
	_tmp2_ = _tmp1_;
#line 93 "candidate-list.vala"
	result = gee_map_contains (_tmp0_, _tmp2_);
#line 93 "candidate-list.vala"
	return result;
#line 244 "candidate-list.c"
}

gboolean
kkc_candidate_list_add (KkcCandidateList* self,
                        KkcCandidate* candidate)
{
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 96 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 96 "candidate-list.vala"
	g_return_val_if_fail (candidate != NULL, FALSE);
#line 97 "candidate-list.vala"
	_tmp0_ = self->priv->seen;
#line 97 "candidate-list.vala"
	_tmp1_ = kkc_candidate_get_output (candidate);
#line 97 "candidate-list.vala"
	_tmp2_ = _tmp1_;
#line 97 "candidate-list.vala"
	if (gee_map_contains (_tmp0_, _tmp2_)) {
#line 267 "candidate-list.c"
		KkcCandidate* c = NULL;
		GeeMap* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gpointer _tmp6_;
		gboolean _tmp7_ = FALSE;
		KkcCandidate* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 98 "candidate-list.vala"
		_tmp3_ = self->priv->seen;
#line 98 "candidate-list.vala"
		_tmp4_ = kkc_candidate_get_output (candidate);
#line 98 "candidate-list.vala"
		_tmp5_ = _tmp4_;
#line 98 "candidate-list.vala"
		_tmp6_ = gee_map_get (_tmp3_, _tmp5_);
#line 98 "candidate-list.vala"
		c = (KkcCandidate*) _tmp6_;
#line 101 "candidate-list.vala"
		_tmp8_ = c;
#line 101 "candidate-list.vala"
		_tmp9_ = kkc_candidate_get_annotation (_tmp8_);
#line 101 "candidate-list.vala"
		_tmp10_ = _tmp9_;
#line 101 "candidate-list.vala"
		if (_tmp10_ == NULL) {
#line 295 "candidate-list.c"
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 101 "candidate-list.vala"
			_tmp11_ = kkc_candidate_get_annotation (candidate);
#line 101 "candidate-list.vala"
			_tmp12_ = _tmp11_;
#line 101 "candidate-list.vala"
			_tmp7_ = _tmp12_ != NULL;
#line 304 "candidate-list.c"
		} else {
#line 101 "candidate-list.vala"
			_tmp7_ = FALSE;
#line 308 "candidate-list.c"
		}
#line 101 "candidate-list.vala"
		if (_tmp7_) {
#line 312 "candidate-list.c"
			KkcCandidate* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
#line 102 "candidate-list.vala"
			_tmp13_ = c;
#line 102 "candidate-list.vala"
			_tmp14_ = kkc_candidate_get_annotation (candidate);
#line 102 "candidate-list.vala"
			_tmp15_ = _tmp14_;
#line 102 "candidate-list.vala"
			kkc_candidate_set_annotation (_tmp13_, _tmp15_);
#line 324 "candidate-list.c"
		}
#line 103 "candidate-list.vala"
		result = FALSE;
#line 103 "candidate-list.vala"
		_g_object_unref0 (c);
#line 103 "candidate-list.vala"
		return result;
#line 332 "candidate-list.c"
	} else {
		GeeArrayList* _tmp16_;
		GeeMap* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
#line 105 "candidate-list.vala"
		_tmp16_ = self->priv->_candidates;
#line 105 "candidate-list.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, candidate);
#line 106 "candidate-list.vala"
		_tmp17_ = self->priv->seen;
#line 106 "candidate-list.vala"
		_tmp18_ = kkc_candidate_get_output (candidate);
#line 106 "candidate-list.vala"
		_tmp19_ = _tmp18_;
#line 106 "candidate-list.vala"
		gee_map_set (_tmp17_, _tmp19_, candidate);
#line 107 "candidate-list.vala"
		result = TRUE;
#line 107 "candidate-list.vala"
		return result;
#line 354 "candidate-list.c"
	}
}

gboolean
kkc_candidate_list_add_all (KkcCandidateList* self,
                            KkcCandidateList* other)
{
	gboolean retval = FALSE;
	gboolean result;
#line 111 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "candidate-list.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 112 "candidate-list.vala"
	retval = FALSE;
#line 370 "candidate-list.c"
	{
		GeeArrayList* _c_list = NULL;
		GeeArrayList* _tmp0_;
		gint _c_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _c_index = 0;
#line 113 "candidate-list.vala"
		_tmp0_ = other->priv->_candidates;
#line 113 "candidate-list.vala"
		_c_list = _tmp0_;
#line 113 "candidate-list.vala"
		_tmp1_ = _c_list;
#line 113 "candidate-list.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 113 "candidate-list.vala"
		_tmp3_ = _tmp2_;
#line 113 "candidate-list.vala"
		_c_size = _tmp3_;
#line 113 "candidate-list.vala"
		_c_index = -1;
#line 113 "candidate-list.vala"
		while (TRUE) {
#line 395 "candidate-list.c"
			gint _tmp4_;
			gint _tmp5_;
			KkcCandidate* c = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			KkcCandidate* _tmp8_;
#line 113 "candidate-list.vala"
			_c_index = _c_index + 1;
#line 113 "candidate-list.vala"
			_tmp4_ = _c_index;
#line 113 "candidate-list.vala"
			_tmp5_ = _c_size;
#line 113 "candidate-list.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 113 "candidate-list.vala"
				break;
#line 412 "candidate-list.c"
			}
#line 113 "candidate-list.vala"
			_tmp6_ = _c_list;
#line 113 "candidate-list.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _c_index);
#line 113 "candidate-list.vala"
			c = (KkcCandidate*) _tmp7_;
#line 114 "candidate-list.vala"
			_tmp8_ = c;
#line 114 "candidate-list.vala"
			if (kkc_candidate_list_add (self, _tmp8_)) {
#line 115 "candidate-list.vala"
				retval = TRUE;
#line 426 "candidate-list.c"
			}
#line 113 "candidate-list.vala"
			_g_object_unref0 (c);
#line 430 "candidate-list.c"
		}
	}
#line 117 "candidate-list.vala"
	result = retval;
#line 117 "candidate-list.vala"
	return result;
#line 437 "candidate-list.c"
}

KkcCandidate**
kkc_candidate_list_to_array (KkcCandidateList* self,
                             gint* result_length1)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_ = 0;
	gpointer* _tmp2_;
	KkcCandidate** _tmp3_;
	gint _tmp3__length1;
	KkcCandidate** result;
#line 120 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 121 "candidate-list.vala"
	_tmp0_ = self->priv->_candidates;
#line 121 "candidate-list.vala"
	_tmp2_ = gee_collection_to_array ((GeeCollection*) _tmp0_, &_tmp1_);
#line 121 "candidate-list.vala"
	_tmp3_ = _tmp2_;
#line 121 "candidate-list.vala"
	_tmp3__length1 = _tmp1_;
#line 121 "candidate-list.vala"
	if (result_length1) {
#line 121 "candidate-list.vala"
		*result_length1 = _tmp3__length1;
#line 464 "candidate-list.c"
	}
#line 121 "candidate-list.vala"
	result = _tmp3_;
#line 121 "candidate-list.vala"
	return result;
#line 470 "candidate-list.c"
}

static guint
kkc_candidate_list_get_page_start_cursor_pos (KkcCandidateList* self,
                                              guint pos)
{
	guint page_index = 0U;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint result;
#line 124 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 125 "candidate-list.vala"
	_tmp0_ = self->priv->_page_start;
#line 125 "candidate-list.vala"
	_tmp1_ = self->priv->_page_size;
#line 125 "candidate-list.vala"
	page_index = (pos - _tmp0_) / _tmp1_;
#line 126 "candidate-list.vala"
	_tmp2_ = self->priv->_page_size;
#line 126 "candidate-list.vala"
	_tmp3_ = self->priv->_page_start;
#line 126 "candidate-list.vala"
	result = (page_index * _tmp2_) + _tmp3_;
#line 126 "candidate-list.vala"
	return result;
#line 499 "candidate-list.c"
}

/**
         * Select a candidate in the current page.
         *
         * @param index_in_page cursor position in the page to select
         *
         * @return `true` if a candidate is selected, `false` otherwise
         */
gboolean
kkc_candidate_list_select_at (KkcCandidateList* self,
                              guint index_in_page)
{
	guint _tmp0_;
	guint page_offset = 0U;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 136 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 137 "candidate-list.vala"
	_tmp0_ = self->priv->_page_size;
#line 137 "candidate-list.vala"
	_vala_assert (index_in_page < _tmp0_, "index_in_page < page_size");
#line 138 "candidate-list.vala"
	_tmp1_ = kkc_candidate_list_get_cursor_pos (self);
#line 138 "candidate-list.vala"
	_tmp2_ = _tmp1_;
#line 138 "candidate-list.vala"
	page_offset = kkc_candidate_list_get_page_start_cursor_pos (self, (guint) _tmp2_);
#line 139 "candidate-list.vala"
	_tmp3_ = kkc_candidate_list_get_size (self);
#line 139 "candidate-list.vala"
	_tmp4_ = _tmp3_;
#line 139 "candidate-list.vala"
	if ((page_offset + index_in_page) < ((guint) _tmp4_)) {
#line 140 "candidate-list.vala"
		self->priv->_cursor_pos = (gint) (page_offset + index_in_page);
#line 141 "candidate-list.vala"
		g_object_notify ((GObject*) self, "cursor-pos");
#line 142 "candidate-list.vala"
		kkc_candidate_list_select (self);
#line 143 "candidate-list.vala"
		result = TRUE;
#line 143 "candidate-list.vala"
		return result;
#line 548 "candidate-list.c"
	}
#line 145 "candidate-list.vala"
	result = FALSE;
#line 145 "candidate-list.vala"
	return result;
#line 554 "candidate-list.c"
}

/**
         * Select the current candidate.
         */
void
kkc_candidate_list_select (KkcCandidateList* self)
{
	KkcCandidate* candidate = NULL;
	KkcCandidate* _tmp0_;
#line 151 "candidate-list.vala"
	g_return_if_fail (self != NULL);
#line 152 "candidate-list.vala"
	_tmp0_ = kkc_candidate_list_get (self, -1);
#line 152 "candidate-list.vala"
	candidate = _tmp0_;
#line 153 "candidate-list.vala"
	g_signal_emit (self, kkc_candidate_list_signals[KKC_CANDIDATE_LIST_SELECTED_SIGNAL], 0, candidate);
#line 151 "candidate-list.vala"
	_g_object_unref0 (candidate);
#line 575 "candidate-list.c"
}

/**
         * Create a new CandidateList.
         *
         * @param page_start starting index of pagination
         * @param page_size page size
         * @param round whether to loop over the candidate list
         *
         * @return a new CandidateList
         */
KkcCandidateList*
kkc_candidate_list_construct (GType object_type,
                              guint page_start,
                              guint page_size,
                              gboolean round)
{
	KkcCandidateList * self = NULL;
#line 165 "candidate-list.vala"
	self = (KkcCandidateList*) g_object_new (object_type, NULL);
#line 169 "candidate-list.vala"
	kkc_candidate_list_set_page_start (self, page_start);
#line 170 "candidate-list.vala"
	kkc_candidate_list_set_page_size (self, page_size);
#line 171 "candidate-list.vala"
	kkc_candidate_list_set_round (self, round);
#line 165 "candidate-list.vala"
	return self;
#line 604 "candidate-list.c"
}

KkcCandidateList*
kkc_candidate_list_new (guint page_start,
                        guint page_size,
                        gboolean round)
{
#line 165 "candidate-list.vala"
	return kkc_candidate_list_construct (KKC_TYPE_CANDIDATE_LIST, page_start, page_size, round);
#line 614 "candidate-list.c"
}

/**
         * Select the first candidate.
         *
         * @return `true` if cursor position has changed, `false` otherwise
         */
gboolean
kkc_candidate_list_first (KkcCandidateList* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 179 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 180 "candidate-list.vala"
	_tmp0_ = self->priv->_candidates;
#line 180 "candidate-list.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 180 "candidate-list.vala"
	_tmp2_ = _tmp1_;
#line 180 "candidate-list.vala"
	if (_tmp2_ > 0) {
#line 181 "candidate-list.vala"
		self->priv->_cursor_pos = 0;
#line 182 "candidate-list.vala"
		g_object_notify ((GObject*) self, "cursor-pos");
#line 183 "candidate-list.vala"
		result = TRUE;
#line 183 "candidate-list.vala"
		return result;
#line 647 "candidate-list.c"
	}
#line 185 "candidate-list.vala"
	result = FALSE;
#line 185 "candidate-list.vala"
	return result;
#line 653 "candidate-list.c"
}

/**
         * Move cursor forward.
         *
         * @return `true` if cursor position has changed, `false` otherwise
         */
static gboolean
kkc_candidate_list_real_next (KkcCandidateList* self)
{
	gint _tmp0_;
	gint _tmp1_;
	guint _tmp2_;
	gboolean result;
#line 194 "candidate-list.vala"
	_tmp0_ = kkc_candidate_list_get_cursor_pos (self);
#line 194 "candidate-list.vala"
	_tmp1_ = _tmp0_;
#line 194 "candidate-list.vala"
	_tmp2_ = self->priv->_page_start;
#line 194 "candidate-list.vala"
	if (((guint) _tmp1_) < _tmp2_) {
#line 195 "candidate-list.vala"
		result = kkc_candidate_list_cursor_down (self);
#line 195 "candidate-list.vala"
		return result;
#line 680 "candidate-list.c"
	} else {
#line 197 "candidate-list.vala"
		result = kkc_candidate_list_page_down (self);
#line 197 "candidate-list.vala"
		return result;
#line 686 "candidate-list.c"
	}
}

gboolean
kkc_candidate_list_next (KkcCandidateList* self)
{
	KkcCandidateListClass* _klass_;
#line 193 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 193 "candidate-list.vala"
	_klass_ = KKC_CANDIDATE_LIST_GET_CLASS (self);
#line 193 "candidate-list.vala"
	if (_klass_->next) {
#line 193 "candidate-list.vala"
		return _klass_->next (self);
#line 702 "candidate-list.c"
	}
#line 193 "candidate-list.vala"
	return FALSE;
#line 706 "candidate-list.c"
}

/**
         * Move cursor backward.
         *
         * @return `true` if cursor position has changed, `false` otherwise
         */
static gboolean
kkc_candidate_list_real_previous (KkcCandidateList* self)
{
	gint _tmp0_;
	gint _tmp1_;
	guint _tmp2_;
	gboolean result;
#line 207 "candidate-list.vala"
	_tmp0_ = kkc_candidate_list_get_cursor_pos (self);
#line 207 "candidate-list.vala"
	_tmp1_ = _tmp0_;
#line 207 "candidate-list.vala"
	_tmp2_ = self->priv->_page_start;
#line 207 "candidate-list.vala"
	if (((guint) _tmp1_) <= _tmp2_) {
#line 208 "candidate-list.vala"
		result = kkc_candidate_list_cursor_up (self);
#line 208 "candidate-list.vala"
		return result;
#line 733 "candidate-list.c"
	} else {
#line 210 "candidate-list.vala"
		result = kkc_candidate_list_page_up (self);
#line 210 "candidate-list.vala"
		return result;
#line 739 "candidate-list.c"
	}
}

gboolean
kkc_candidate_list_previous (KkcCandidateList* self)
{
	KkcCandidateListClass* _klass_;
#line 206 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 206 "candidate-list.vala"
	_klass_ = KKC_CANDIDATE_LIST_GET_CLASS (self);
#line 206 "candidate-list.vala"
	if (_klass_->previous) {
#line 206 "candidate-list.vala"
		return _klass_->previous (self);
#line 755 "candidate-list.c"
	}
#line 206 "candidate-list.vala"
	return FALSE;
#line 759 "candidate-list.c"
}

static gboolean
kkc_candidate_list_update_cursor_pos (KkcCandidateList* self,
                                      guint pos)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 214 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 215 "candidate-list.vala"
	if (((guint) 0) <= pos) {
#line 773 "candidate-list.c"
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 215 "candidate-list.vala"
		_tmp2_ = self->priv->_candidates;
#line 215 "candidate-list.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 215 "candidate-list.vala"
		_tmp4_ = _tmp3_;
#line 215 "candidate-list.vala"
		_tmp1_ = pos < ((guint) _tmp4_);
#line 785 "candidate-list.c"
	} else {
#line 215 "candidate-list.vala"
		_tmp1_ = FALSE;
#line 789 "candidate-list.c"
	}
#line 215 "candidate-list.vala"
	if (_tmp1_) {
#line 215 "candidate-list.vala"
		_tmp0_ = pos != ((guint) self->priv->_cursor_pos);
#line 795 "candidate-list.c"
	} else {
#line 215 "candidate-list.vala"
		_tmp0_ = FALSE;
#line 799 "candidate-list.c"
	}
#line 215 "candidate-list.vala"
	if (_tmp0_) {
#line 216 "candidate-list.vala"
		self->priv->_cursor_pos = (gint) pos;
#line 217 "candidate-list.vala"
		g_object_notify ((GObject*) self, "cursor-pos");
#line 218 "candidate-list.vala"
		result = TRUE;
#line 218 "candidate-list.vala"
		return result;
#line 811 "candidate-list.c"
	}
#line 220 "candidate-list.vala"
	result = FALSE;
#line 220 "candidate-list.vala"
	return result;
#line 817 "candidate-list.c"
}

static gboolean
kkc_candidate_list_cursor_move (KkcCandidateList* self,
                                gint step)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayList* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint start = 0;
	guint _tmp4_;
	gint total = 0;
	GeeArrayList* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	guint _tmp8_;
	gboolean _tmp9_;
	gboolean result;
#line 223 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "candidate-list.vala"
	_tmp1_ = self->priv->_candidates;
#line 224 "candidate-list.vala"
	_tmp2_ = gee_collection_get_is_empty ((GeeCollection*) _tmp1_);
#line 224 "candidate-list.vala"
	_tmp3_ = _tmp2_;
#line 224 "candidate-list.vala"
	if (_tmp3_) {
#line 224 "candidate-list.vala"
		_tmp0_ = TRUE;
#line 849 "candidate-list.c"
	} else {
#line 224 "candidate-list.vala"
		_tmp0_ = step == 0;
#line 853 "candidate-list.c"
	}
#line 224 "candidate-list.vala"
	if (_tmp0_) {
#line 225 "candidate-list.vala"
		result = FALSE;
#line 225 "candidate-list.vala"
		return result;
#line 861 "candidate-list.c"
	}
#line 227 "candidate-list.vala"
	_tmp4_ = self->priv->_page_start;
#line 227 "candidate-list.vala"
	start = self->priv->_cursor_pos - ((gint) _tmp4_);
#line 228 "candidate-list.vala"
	_tmp5_ = self->priv->_candidates;
#line 228 "candidate-list.vala"
	_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 228 "candidate-list.vala"
	_tmp7_ = _tmp6_;
#line 228 "candidate-list.vala"
	_tmp8_ = self->priv->_page_start;
#line 228 "candidate-list.vala"
	total = ((gint) _tmp7_) - ((gint) _tmp8_);
#line 230 "candidate-list.vala"
	_tmp9_ = self->priv->_round;
#line 230 "candidate-list.vala"
	if (_tmp9_) {
#line 881 "candidate-list.c"
		gint pos = 0;
		guint _tmp10_;
#line 231 "candidate-list.vala"
		pos = (start + step) % total;
#line 232 "candidate-list.vala"
		if (pos < 0) {
#line 233 "candidate-list.vala"
			pos += total;
#line 890 "candidate-list.c"
		}
#line 234 "candidate-list.vala"
		_tmp10_ = self->priv->_page_start;
#line 234 "candidate-list.vala"
		if (kkc_candidate_list_update_cursor_pos (self, pos + _tmp10_)) {
#line 235 "candidate-list.vala"
			result = TRUE;
#line 235 "candidate-list.vala"
			return result;
#line 900 "candidate-list.c"
		}
	} else {
		gint pos = 0;
		gboolean _tmp11_ = FALSE;
#line 237 "candidate-list.vala"
		pos = start + step;
#line 238 "candidate-list.vala"
		if (0 <= pos) {
#line 238 "candidate-list.vala"
			_tmp11_ = pos < total;
#line 911 "candidate-list.c"
		} else {
#line 238 "candidate-list.vala"
			_tmp11_ = FALSE;
#line 915 "candidate-list.c"
		}
#line 238 "candidate-list.vala"
		if (_tmp11_) {
#line 919 "candidate-list.c"
			guint _tmp12_;
#line 239 "candidate-list.vala"
			_tmp12_ = self->priv->_page_start;
#line 239 "candidate-list.vala"
			if (kkc_candidate_list_update_cursor_pos (self, pos + _tmp12_)) {
#line 240 "candidate-list.vala"
				result = TRUE;
#line 240 "candidate-list.vala"
				return result;
#line 929 "candidate-list.c"
			}
		}
	}
#line 244 "candidate-list.vala"
	result = FALSE;
#line 244 "candidate-list.vala"
	return result;
#line 937 "candidate-list.c"
}

/**
         * Move cursor to the previous candidate.
         *
         * @return `true` if cursor position has changed, `false` otherwise.
         */
gboolean
kkc_candidate_list_cursor_up (KkcCandidateList* self)
{
	guint _tmp0_;
	gboolean result;
#line 252 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 253 "candidate-list.vala"
	_tmp0_ = self->priv->_page_start;
#line 253 "candidate-list.vala"
	if (((guint) self->priv->_cursor_pos) >= _tmp0_) {
#line 254 "candidate-list.vala"
		result = kkc_candidate_list_cursor_move (self, -1);
#line 254 "candidate-list.vala"
		return result;
#line 960 "candidate-list.c"
	} else {
#line 255 "candidate-list.vala"
		if (kkc_candidate_list_update_cursor_pos (self, (guint) (self->priv->_cursor_pos - 1))) {
#line 256 "candidate-list.vala"
			result = TRUE;
#line 256 "candidate-list.vala"
			return result;
#line 968 "candidate-list.c"
		}
	}
#line 257 "candidate-list.vala"
	result = FALSE;
#line 257 "candidate-list.vala"
	return result;
#line 975 "candidate-list.c"
}

/**
         * Move cursor to the next candidate.
         *
         * @return `true` if cursor position has changed, `false` otherwise
         */
gboolean
kkc_candidate_list_cursor_down (KkcCandidateList* self)
{
	guint _tmp0_;
	gboolean result;
#line 265 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 266 "candidate-list.vala"
	_tmp0_ = self->priv->_page_start;
#line 266 "candidate-list.vala"
	if (((guint) self->priv->_cursor_pos) >= _tmp0_) {
#line 267 "candidate-list.vala"
		result = kkc_candidate_list_cursor_move (self, 1);
#line 267 "candidate-list.vala"
		return result;
#line 998 "candidate-list.c"
	} else {
#line 268 "candidate-list.vala"
		if (kkc_candidate_list_update_cursor_pos (self, (guint) (self->priv->_cursor_pos + 1))) {
#line 269 "candidate-list.vala"
			result = TRUE;
#line 269 "candidate-list.vala"
			return result;
#line 1006 "candidate-list.c"
		}
	}
#line 270 "candidate-list.vala"
	result = FALSE;
#line 270 "candidate-list.vala"
	return result;
#line 1013 "candidate-list.c"
}

static gboolean
kkc_candidate_list_page_move (KkcCandidateList* self,
                              gint step)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayList* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint start = 0;
	guint _tmp4_;
	gint total = 0;
	GeeArrayList* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	guint _tmp8_;
	gboolean _tmp9_;
	gboolean result;
#line 273 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 274 "candidate-list.vala"
	_tmp1_ = self->priv->_candidates;
#line 274 "candidate-list.vala"
	_tmp2_ = gee_collection_get_is_empty ((GeeCollection*) _tmp1_);
#line 274 "candidate-list.vala"
	_tmp3_ = _tmp2_;
#line 274 "candidate-list.vala"
	if (_tmp3_) {
#line 274 "candidate-list.vala"
		_tmp0_ = TRUE;
#line 1045 "candidate-list.c"
	} else {
#line 274 "candidate-list.vala"
		_tmp0_ = step == 0;
#line 1049 "candidate-list.c"
	}
#line 274 "candidate-list.vala"
	if (_tmp0_) {
#line 275 "candidate-list.vala"
		result = FALSE;
#line 275 "candidate-list.vala"
		return result;
#line 1057 "candidate-list.c"
	}
#line 277 "candidate-list.vala"
	_tmp4_ = self->priv->_page_start;
#line 277 "candidate-list.vala"
	start = self->priv->_cursor_pos - ((gint) _tmp4_);
#line 278 "candidate-list.vala"
	_tmp5_ = self->priv->_candidates;
#line 278 "candidate-list.vala"
	_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 278 "candidate-list.vala"
	_tmp7_ = _tmp6_;
#line 278 "candidate-list.vala"
	_tmp8_ = self->priv->_page_start;
#line 278 "candidate-list.vala"
	total = ((gint) _tmp7_) - ((gint) _tmp8_);
#line 280 "candidate-list.vala"
	_tmp9_ = self->priv->_round;
#line 280 "candidate-list.vala"
	if (_tmp9_) {
#line 1077 "candidate-list.c"
		gint pos = 0;
		guint _tmp10_;
		guint _tmp11_;
		GeeArrayList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 281 "candidate-list.vala"
		_tmp10_ = self->priv->_page_size;
#line 281 "candidate-list.vala"
		pos = (start + (((gint) _tmp10_) * step)) % total;
#line 282 "candidate-list.vala"
		if (pos < 0) {
#line 283 "candidate-list.vala"
			pos += total;
#line 1092 "candidate-list.c"
		}
#line 284 "candidate-list.vala"
		_tmp11_ = self->priv->_page_start;
#line 284 "candidate-list.vala"
		_tmp12_ = self->priv->_candidates;
#line 284 "candidate-list.vala"
		_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 284 "candidate-list.vala"
		_tmp14_ = _tmp13_;
#line 284 "candidate-list.vala"
		if ((pos + ((gint) _tmp11_)) < _tmp14_) {
#line 1104 "candidate-list.c"
			guint new_pos = 0U;
			guint _tmp15_;
#line 285 "candidate-list.vala"
			_tmp15_ = self->priv->_page_start;
#line 285 "candidate-list.vala"
			new_pos = kkc_candidate_list_get_page_start_cursor_pos (self, pos + _tmp15_);
#line 286 "candidate-list.vala"
			if (kkc_candidate_list_update_cursor_pos (self, new_pos)) {
#line 287 "candidate-list.vala"
				result = TRUE;
#line 287 "candidate-list.vala"
				return result;
#line 1117 "candidate-list.c"
			}
		}
	} else {
		gint pos = 0;
		guint _tmp16_;
		gboolean _tmp17_ = FALSE;
#line 290 "candidate-list.vala"
		_tmp16_ = self->priv->_page_size;
#line 290 "candidate-list.vala"
		pos = start + (((gint) _tmp16_) * step);
#line 291 "candidate-list.vala"
		if (0 <= pos) {
#line 291 "candidate-list.vala"
			_tmp17_ = pos < total;
#line 1132 "candidate-list.c"
		} else {
#line 291 "candidate-list.vala"
			_tmp17_ = FALSE;
#line 1136 "candidate-list.c"
		}
#line 291 "candidate-list.vala"
		if (_tmp17_) {
#line 1140 "candidate-list.c"
			guint new_pos = 0U;
			guint _tmp18_;
#line 292 "candidate-list.vala"
			_tmp18_ = self->priv->_page_start;
#line 292 "candidate-list.vala"
			new_pos = kkc_candidate_list_get_page_start_cursor_pos (self, pos + _tmp18_);
#line 293 "candidate-list.vala"
			if (kkc_candidate_list_update_cursor_pos (self, new_pos)) {
#line 294 "candidate-list.vala"
				result = TRUE;
#line 294 "candidate-list.vala"
				return result;
#line 1153 "candidate-list.c"
			}
		}
	}
#line 297 "candidate-list.vala"
	result = FALSE;
#line 297 "candidate-list.vala"
	return result;
#line 1161 "candidate-list.c"
}

/**
         * Move cursor to the previous page.
         *
         * @return `true` if cursor position has changed, `false` otherwise
         */
gboolean
kkc_candidate_list_page_up (KkcCandidateList* self)
{
	gboolean result;
#line 305 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 306 "candidate-list.vala"
	result = kkc_candidate_list_page_move (self, -1);
#line 306 "candidate-list.vala"
	return result;
#line 1179 "candidate-list.c"
}

/**
         * Move cursor to the next page.
         *
         * @return `true` if cursor position has changed, `false` otherwise
         */
gboolean
kkc_candidate_list_page_down (KkcCandidateList* self)
{
	gboolean result;
#line 314 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 315 "candidate-list.vala"
	result = kkc_candidate_list_page_move (self, 1);
#line 315 "candidate-list.vala"
	return result;
#line 1197 "candidate-list.c"
}

gint
kkc_candidate_list_get_cursor_pos (KkcCandidateList* self)
{
	gint result;
#line 35 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "candidate-list.vala"
	result = self->priv->_cursor_pos;
#line 36 "candidate-list.vala"
	return result;
#line 1210 "candidate-list.c"
}

void
kkc_candidate_list_set_cursor_pos (KkcCandidateList* self,
                                   gint value)
{
#line 38 "candidate-list.vala"
	g_return_if_fail (self != NULL);
#line 39 "candidate-list.vala"
	self->priv->_cursor_pos = value;
#line 38 "candidate-list.vala"
	g_object_notify_by_pspec ((GObject *) self, kkc_candidate_list_properties[KKC_CANDIDATE_LIST_CURSOR_POS_PROPERTY]);
#line 1223 "candidate-list.c"
}

gint
kkc_candidate_list_get_size (KkcCandidateList* self)
{
	gint result;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 61 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "candidate-list.vala"
	_tmp0_ = self->priv->_candidates;
#line 62 "candidate-list.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 62 "candidate-list.vala"
	_tmp2_ = _tmp1_;
#line 62 "candidate-list.vala"
	result = _tmp2_;
#line 62 "candidate-list.vala"
	return result;
#line 1245 "candidate-list.c"
}

guint
kkc_candidate_list_get_page_start (KkcCandidateList* self)
{
	guint result;
#line 321 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 321 "candidate-list.vala"
	result = self->priv->_page_start;
#line 321 "candidate-list.vala"
	return result;
#line 1258 "candidate-list.c"
}

void
kkc_candidate_list_set_page_start (KkcCandidateList* self,
                                   guint value)
{
	guint old_value;
#line 321 "candidate-list.vala"
	g_return_if_fail (self != NULL);
#line 321 "candidate-list.vala"
	old_value = kkc_candidate_list_get_page_start (self);
#line 321 "candidate-list.vala"
	if (old_value != value) {
#line 321 "candidate-list.vala"
		self->priv->_page_start = value;
#line 321 "candidate-list.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_candidate_list_properties[KKC_CANDIDATE_LIST_PAGE_START_PROPERTY]);
#line 1276 "candidate-list.c"
	}
}

guint
kkc_candidate_list_get_page_size (KkcCandidateList* self)
{
	guint result;
#line 326 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 326 "candidate-list.vala"
	result = self->priv->_page_size;
#line 326 "candidate-list.vala"
	return result;
#line 1290 "candidate-list.c"
}

void
kkc_candidate_list_set_page_size (KkcCandidateList* self,
                                  guint value)
{
	guint old_value;
#line 326 "candidate-list.vala"
	g_return_if_fail (self != NULL);
#line 326 "candidate-list.vala"
	old_value = kkc_candidate_list_get_page_size (self);
#line 326 "candidate-list.vala"
	if (old_value != value) {
#line 326 "candidate-list.vala"
		self->priv->_page_size = value;
#line 326 "candidate-list.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_candidate_list_properties[KKC_CANDIDATE_LIST_PAGE_SIZE_PROPERTY]);
#line 1308 "candidate-list.c"
	}
}

gboolean
kkc_candidate_list_get_round (KkcCandidateList* self)
{
	gboolean result;
#line 331 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 331 "candidate-list.vala"
	result = self->priv->_round;
#line 331 "candidate-list.vala"
	return result;
#line 1322 "candidate-list.c"
}

void
kkc_candidate_list_set_round (KkcCandidateList* self,
                              gboolean value)
{
	gboolean old_value;
#line 331 "candidate-list.vala"
	g_return_if_fail (self != NULL);
#line 331 "candidate-list.vala"
	old_value = kkc_candidate_list_get_round (self);
#line 331 "candidate-list.vala"
	if (old_value != value) {
#line 331 "candidate-list.vala"
		self->priv->_round = value;
#line 331 "candidate-list.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_candidate_list_properties[KKC_CANDIDATE_LIST_ROUND_PROPERTY]);
#line 1340 "candidate-list.c"
	}
}

gboolean
kkc_candidate_list_get_page_visible (KkcCandidateList* self)
{
	gboolean result;
	guint _tmp0_;
#line 337 "candidate-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 338 "candidate-list.vala"
	_tmp0_ = self->priv->_page_start;
#line 338 "candidate-list.vala"
	result = self->priv->_cursor_pos >= ((gint) _tmp0_);
#line 338 "candidate-list.vala"
	return result;
#line 1357 "candidate-list.c"
}

static void
kkc_candidate_list_class_init (KkcCandidateListClass * klass,
                               gpointer klass_data)
{
#line 24 "candidate-list.vala"
	kkc_candidate_list_parent_class = g_type_class_peek_parent (klass);
#line 24 "candidate-list.vala"
	g_type_class_adjust_private_offset (klass, &KkcCandidateList_private_offset);
#line 24 "candidate-list.vala"
	((KkcCandidateListClass *) klass)->next = (gboolean (*) (KkcCandidateList*)) kkc_candidate_list_real_next;
#line 24 "candidate-list.vala"
	((KkcCandidateListClass *) klass)->previous = (gboolean (*) (KkcCandidateList*)) kkc_candidate_list_real_previous;
#line 24 "candidate-list.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_kkc_candidate_list_get_property;
#line 24 "candidate-list.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_kkc_candidate_list_set_property;
#line 24 "candidate-list.vala"
	G_OBJECT_CLASS (klass)->finalize = kkc_candidate_list_finalize;
#line 1378 "candidate-list.c"
	/**
	         * Current cursor position.
	         */
#line 24 "candidate-list.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_CANDIDATE_LIST_CURSOR_POS_PROPERTY, kkc_candidate_list_properties[KKC_CANDIDATE_LIST_CURSOR_POS_PROPERTY] = g_param_spec_int ("cursor-pos", "cursor-pos", "cursor-pos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1384 "candidate-list.c"
	/**
	         * The number of candidate in the candidate list.
	         */
#line 24 "candidate-list.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_CANDIDATE_LIST_SIZE_PROPERTY, kkc_candidate_list_properties[KKC_CANDIDATE_LIST_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1390 "candidate-list.c"
	/**
	         * Starting index of paging.
	         */
#line 24 "candidate-list.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_CANDIDATE_LIST_PAGE_START_PROPERTY, kkc_candidate_list_properties[KKC_CANDIDATE_LIST_PAGE_START_PROPERTY] = g_param_spec_uint ("page-start", "page-start", "page-start", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1396 "candidate-list.c"
	/**
	         * Page size.
	         */
#line 24 "candidate-list.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_CANDIDATE_LIST_PAGE_SIZE_PROPERTY, kkc_candidate_list_properties[KKC_CANDIDATE_LIST_PAGE_SIZE_PROPERTY] = g_param_spec_uint ("page-size", "page-size", "page-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1402 "candidate-list.c"
	/**
	         * Flag to indicate whether to loop over the candidates.
	         */
#line 24 "candidate-list.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_CANDIDATE_LIST_ROUND_PROPERTY, kkc_candidate_list_properties[KKC_CANDIDATE_LIST_ROUND_PROPERTY] = g_param_spec_boolean ("round", "round", "round", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1408 "candidate-list.c"
	/**
	         * Flag to indicate whether page (lookup table) is visible.
	         */
#line 24 "candidate-list.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_CANDIDATE_LIST_PAGE_VISIBLE_PROPERTY, kkc_candidate_list_properties[KKC_CANDIDATE_LIST_PAGE_VISIBLE_PROPERTY] = g_param_spec_boolean ("page-visible", "page-visible", "page-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1414 "candidate-list.c"
	/**
	         * Signal emitted when candidates are filled and ready for traversal.
	         */
#line 24 "candidate-list.vala"
	kkc_candidate_list_signals[KKC_CANDIDATE_LIST_POPULATED_SIGNAL] = g_signal_new ("populated", KKC_TYPE_CANDIDATE_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1420 "candidate-list.c"
	/**
	         * Signal emitted when a candidate is selected.
	         *
	         * @param candidate selected candidate
	         */
#line 24 "candidate-list.vala"
	kkc_candidate_list_signals[KKC_CANDIDATE_LIST_SELECTED_SIGNAL] = g_signal_new ("selected", KKC_TYPE_CANDIDATE_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, KKC_TYPE_CANDIDATE);
#line 1428 "candidate-list.c"
}

static void
kkc_candidate_list_instance_init (KkcCandidateList * self,
                                  gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeHashMap* _tmp1_;
#line 24 "candidate-list.vala"
	self->priv = kkc_candidate_list_get_instance_private (self);
#line 25 "candidate-list.vala"
	_tmp0_ = gee_array_list_new (KKC_TYPE_CANDIDATE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 25 "candidate-list.vala"
	self->priv->_candidates = _tmp0_;
#line 66 "candidate-list.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, KKC_TYPE_CANDIDATE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 66 "candidate-list.vala"
	self->priv->seen = (GeeMap*) _tmp1_;
#line 1447 "candidate-list.c"
}

static void
kkc_candidate_list_finalize (GObject * obj)
{
	KkcCandidateList * self;
#line 24 "candidate-list.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_CANDIDATE_LIST, KkcCandidateList);
#line 25 "candidate-list.vala"
	_g_object_unref0 (self->priv->_candidates);
#line 66 "candidate-list.vala"
	_g_object_unref0 (self->priv->seen);
#line 24 "candidate-list.vala"
	G_OBJECT_CLASS (kkc_candidate_list_parent_class)->finalize (obj);
#line 1462 "candidate-list.c"
}

/**
     * Object representing a candidate list.
     */
static GType
kkc_candidate_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KkcCandidateListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_candidate_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcCandidateList), 0, (GInstanceInitFunc) kkc_candidate_list_instance_init, NULL };
	GType kkc_candidate_list_type_id;
	kkc_candidate_list_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcCandidateList", &g_define_type_info, 0);
	KkcCandidateList_private_offset = g_type_add_instance_private (kkc_candidate_list_type_id, sizeof (KkcCandidateListPrivate));
	return kkc_candidate_list_type_id;
}

GType
kkc_candidate_list_get_type (void)
{
	static volatile gsize kkc_candidate_list_type_id__once = 0;
	if (g_once_init_enter (&kkc_candidate_list_type_id__once)) {
		GType kkc_candidate_list_type_id;
		kkc_candidate_list_type_id = kkc_candidate_list_get_type_once ();
		g_once_init_leave (&kkc_candidate_list_type_id__once, kkc_candidate_list_type_id);
	}
	return kkc_candidate_list_type_id__once;
}

static void
_vala_kkc_candidate_list_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	KkcCandidateList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_CANDIDATE_LIST, KkcCandidateList);
#line 24 "candidate-list.vala"
	switch (property_id) {
#line 24 "candidate-list.vala"
		case KKC_CANDIDATE_LIST_CURSOR_POS_PROPERTY:
#line 24 "candidate-list.vala"
		g_value_set_int (value, kkc_candidate_list_get_cursor_pos (self));
#line 24 "candidate-list.vala"
		break;
#line 24 "candidate-list.vala"
		case KKC_CANDIDATE_LIST_SIZE_PROPERTY:
#line 24 "candidate-list.vala"
		g_value_set_int (value, kkc_candidate_list_get_size (self));
#line 24 "candidate-list.vala"
		break;
#line 24 "candidate-list.vala"
		case KKC_CANDIDATE_LIST_PAGE_START_PROPERTY:
#line 24 "candidate-list.vala"
		g_value_set_uint (value, kkc_candidate_list_get_page_start (self));
#line 24 "candidate-list.vala"
		break;
#line 24 "candidate-list.vala"
		case KKC_CANDIDATE_LIST_PAGE_SIZE_PROPERTY:
#line 24 "candidate-list.vala"
		g_value_set_uint (value, kkc_candidate_list_get_page_size (self));
#line 24 "candidate-list.vala"
		break;
#line 24 "candidate-list.vala"
		case KKC_CANDIDATE_LIST_ROUND_PROPERTY:
#line 24 "candidate-list.vala"
		g_value_set_boolean (value, kkc_candidate_list_get_round (self));
#line 24 "candidate-list.vala"
		break;
#line 24 "candidate-list.vala"
		case KKC_CANDIDATE_LIST_PAGE_VISIBLE_PROPERTY:
#line 24 "candidate-list.vala"
		g_value_set_boolean (value, kkc_candidate_list_get_page_visible (self));
#line 24 "candidate-list.vala"
		break;
#line 1536 "candidate-list.c"
		default:
#line 24 "candidate-list.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "candidate-list.vala"
		break;
#line 1542 "candidate-list.c"
	}
}

static void
_vala_kkc_candidate_list_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	KkcCandidateList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_CANDIDATE_LIST, KkcCandidateList);
#line 24 "candidate-list.vala"
	switch (property_id) {
#line 24 "candidate-list.vala"
		case KKC_CANDIDATE_LIST_CURSOR_POS_PROPERTY:
#line 24 "candidate-list.vala"
		kkc_candidate_list_set_cursor_pos (self, g_value_get_int (value));
#line 24 "candidate-list.vala"
		break;
#line 24 "candidate-list.vala"
		case KKC_CANDIDATE_LIST_PAGE_START_PROPERTY:
#line 24 "candidate-list.vala"
		kkc_candidate_list_set_page_start (self, g_value_get_uint (value));
#line 24 "candidate-list.vala"
		break;
#line 24 "candidate-list.vala"
		case KKC_CANDIDATE_LIST_PAGE_SIZE_PROPERTY:
#line 24 "candidate-list.vala"
		kkc_candidate_list_set_page_size (self, g_value_get_uint (value));
#line 24 "candidate-list.vala"
		break;
#line 24 "candidate-list.vala"
		case KKC_CANDIDATE_LIST_ROUND_PROPERTY:
#line 24 "candidate-list.vala"
		kkc_candidate_list_set_round (self, g_value_get_boolean (value));
#line 24 "candidate-list.vala"
		break;
#line 1580 "candidate-list.c"
		default:
#line 24 "candidate-list.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "candidate-list.vala"
		break;
#line 1586 "candidate-list.c"
	}
}

