/* dictionary-list.c generated by valac 0.56.17, the Vala compiler
 * generated from dictionary-list.vala, do not modify */

/*
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libkkc/libkkc.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	KKC_DICTIONARY_LIST_0_PROPERTY,
	KKC_DICTIONARY_LIST_SIZE_PROPERTY,
	KKC_DICTIONARY_LIST_NUM_PROPERTIES
};
static GParamSpec* kkc_dictionary_list_properties[KKC_DICTIONARY_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _KkcDictionaryListPrivate {
	GeeList* dictionaries;
};

static gint KkcDictionaryList_private_offset;
static gpointer kkc_dictionary_list_parent_class = NULL;

static KkcDictionaryCallbackReturn __lambda9_ (KkcDictionaryList* self,
                                        KkcDictionary* dictionary);
static KkcDictionaryCallbackReturn ___lambda9__kkc_dictionary_list_dictionary_callback (KkcDictionary* dictionary,
                                                                                 gpointer self);
static void kkc_dictionary_list_finalize (GObject * obj);
static GType kkc_dictionary_list_get_type_once (void);
static void _vala_kkc_dictionary_list_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
     * Type to specify how a dictionary callback is handled.
     */
static GType
kkc_dictionary_callback_return_get_type_once (void)
{
	static const GEnumValue values[] = {{KKC_DICTIONARY_CALLBACK_RETURN_CONTINUE, "KKC_DICTIONARY_CALLBACK_RETURN_CONTINUE", "continue"}, {KKC_DICTIONARY_CALLBACK_RETURN_REMOVE, "KKC_DICTIONARY_CALLBACK_RETURN_REMOVE", "remove"}, {0, NULL, NULL}};
	GType kkc_dictionary_callback_return_type_id;
	kkc_dictionary_callback_return_type_id = g_enum_register_static ("KkcDictionaryCallbackReturn", values);
	return kkc_dictionary_callback_return_type_id;
}

GType
kkc_dictionary_callback_return_get_type (void)
{
	static volatile gsize kkc_dictionary_callback_return_type_id__once = 0;
	if (g_once_init_enter (&kkc_dictionary_callback_return_type_id__once)) {
		GType kkc_dictionary_callback_return_type_id;
		kkc_dictionary_callback_return_type_id = kkc_dictionary_callback_return_get_type_once ();
		g_once_init_leave (&kkc_dictionary_callback_return_type_id__once, kkc_dictionary_callback_return_type_id);
	}
	return kkc_dictionary_callback_return_type_id__once;
}

static inline gpointer
kkc_dictionary_list_get_instance_private (KkcDictionaryList* self)
{
	return G_STRUCT_MEMBER_P (self, KkcDictionaryList_private_offset);
}

/**
         * Register dictionary.
         *
         * @param dictionary a dictionary
         */
void
kkc_dictionary_list_add (KkcDictionaryList* self,
                         KkcDictionary* dictionary)
{
	GeeList* _tmp0_;
#line 53 "dictionary-list.vala"
	g_return_if_fail (self != NULL);
#line 53 "dictionary-list.vala"
	g_return_if_fail (dictionary != NULL);
#line 54 "dictionary-list.vala"
	_tmp0_ = self->priv->dictionaries;
#line 54 "dictionary-list.vala"
	gee_collection_add ((GeeCollection*) _tmp0_, dictionary);
#line 116 "dictionary-list.c"
}

/**
         * Unregister dictionary.
         *
         * @param dictionary a dictionary
         */
void
kkc_dictionary_list_remove (KkcDictionaryList* self,
                            KkcDictionary* dictionary)
{
	GeeList* _tmp0_;
#line 62 "dictionary-list.vala"
	g_return_if_fail (self != NULL);
#line 62 "dictionary-list.vala"
	g_return_if_fail (dictionary != NULL);
#line 63 "dictionary-list.vala"
	_tmp0_ = self->priv->dictionaries;
#line 63 "dictionary-list.vala"
	gee_collection_remove ((GeeCollection*) _tmp0_, dictionary);
#line 137 "dictionary-list.c"
}

/**
         * Remove all dictionaries.
         */
void
kkc_dictionary_list_clear (KkcDictionaryList* self)
{
	GeeList* _tmp0_;
#line 69 "dictionary-list.vala"
	g_return_if_fail (self != NULL);
#line 70 "dictionary-list.vala"
	_tmp0_ = self->priv->dictionaries;
#line 70 "dictionary-list.vala"
	gee_collection_clear ((GeeCollection*) _tmp0_);
#line 153 "dictionary-list.c"
}

/**
         * Call function with dictionaries.
         *
         * @param type type of dictionary
         * @param callback callback
         */
void
kkc_dictionary_list_call (KkcDictionaryList* self,
                          GType* type,
                          KkcDictionaryListDictionaryCallback callback,
                          gpointer callback_target)
{
#line 82 "dictionary-list.vala"
	g_return_if_fail (self != NULL);
#line 170 "dictionary-list.c"
	{
		GeeList* _dictionary_list = NULL;
		GeeList* _tmp0_;
		gint _dictionary_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dictionary_index = 0;
#line 85 "dictionary-list.vala"
		_tmp0_ = self->priv->dictionaries;
#line 85 "dictionary-list.vala"
		_dictionary_list = _tmp0_;
#line 85 "dictionary-list.vala"
		_tmp1_ = _dictionary_list;
#line 85 "dictionary-list.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 85 "dictionary-list.vala"
		_tmp3_ = _tmp2_;
#line 85 "dictionary-list.vala"
		_dictionary_size = _tmp3_;
#line 85 "dictionary-list.vala"
		_dictionary_index = -1;
#line 85 "dictionary-list.vala"
		while (TRUE) {
#line 195 "dictionary-list.c"
			gint _tmp4_;
			gint _tmp5_;
			KkcDictionary* dictionary = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
#line 85 "dictionary-list.vala"
			_dictionary_index = _dictionary_index + 1;
#line 85 "dictionary-list.vala"
			_tmp4_ = _dictionary_index;
#line 85 "dictionary-list.vala"
			_tmp5_ = _dictionary_size;
#line 85 "dictionary-list.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 85 "dictionary-list.vala"
				break;
#line 213 "dictionary-list.c"
			}
#line 85 "dictionary-list.vala"
			_tmp6_ = _dictionary_list;
#line 85 "dictionary-list.vala"
			_tmp7_ = gee_list_get (_tmp6_, _dictionary_index);
#line 85 "dictionary-list.vala"
			dictionary = (KkcDictionary*) _tmp7_;
#line 86 "dictionary-list.vala"
			if (type == NULL) {
#line 86 "dictionary-list.vala"
				_tmp9_ = TRUE;
#line 225 "dictionary-list.c"
			} else {
				KkcDictionary* _tmp10_;
#line 86 "dictionary-list.vala"
				_tmp10_ = dictionary;
#line 86 "dictionary-list.vala"
				_tmp9_ = g_type_is_a (G_TYPE_FROM_INSTANCE ((GObject*) _tmp10_), *type);
#line 232 "dictionary-list.c"
			}
#line 86 "dictionary-list.vala"
			if (_tmp9_) {
#line 236 "dictionary-list.c"
				KkcDictionary* _tmp11_;
#line 87 "dictionary-list.vala"
				_tmp11_ = dictionary;
#line 87 "dictionary-list.vala"
				_tmp8_ = callback (_tmp11_, callback_target) == KKC_DICTIONARY_CALLBACK_RETURN_REMOVE;
#line 242 "dictionary-list.c"
			} else {
#line 86 "dictionary-list.vala"
				_tmp8_ = FALSE;
#line 246 "dictionary-list.c"
			}
#line 86 "dictionary-list.vala"
			if (_tmp8_) {
#line 88 "dictionary-list.vala"
				_g_object_unref0 (dictionary);
#line 88 "dictionary-list.vala"
				return;
#line 254 "dictionary-list.c"
			}
#line 85 "dictionary-list.vala"
			_g_object_unref0 (dictionary);
#line 258 "dictionary-list.c"
		}
	}
}

/**
         * Save dictionaries on to disk.
         */
static KkcDictionaryCallbackReturn
__lambda9_ (KkcDictionaryList* self,
            KkcDictionary* dictionary)
{
	GError* _inner_error0_ = NULL;
	KkcDictionaryCallbackReturn result;
#line 97 "dictionary-list.vala"
	g_return_val_if_fail (dictionary != NULL, 0);
#line 274 "dictionary-list.c"
	{
#line 99 "dictionary-list.vala"
		kkc_dictionary_save (dictionary, &_inner_error0_);
#line 99 "dictionary-list.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 280 "dictionary-list.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 98 "dictionary-list.vala"
		e = _inner_error0_;
#line 98 "dictionary-list.vala"
		_inner_error0_ = NULL;
#line 101 "dictionary-list.vala"
		_tmp0_ = e;
#line 101 "dictionary-list.vala"
		_tmp1_ = _tmp0_->message;
#line 101 "dictionary-list.vala"
		g_warning ("dictionary-list.vala:101: can't save dictionary: %s", _tmp1_);
#line 98 "dictionary-list.vala"
		_g_error_free0 (e);
#line 302 "dictionary-list.c"
	}
	__finally0:
#line 98 "dictionary-list.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "dictionary-list.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "dictionary-list.vala"
		g_clear_error (&_inner_error0_);
#line 98 "dictionary-list.vala"
		return 0;
#line 313 "dictionary-list.c"
	}
#line 104 "dictionary-list.vala"
	result = KKC_DICTIONARY_CALLBACK_RETURN_CONTINUE;
#line 104 "dictionary-list.vala"
	return result;
#line 319 "dictionary-list.c"
}

static KkcDictionaryCallbackReturn
___lambda9__kkc_dictionary_list_dictionary_callback (KkcDictionary* dictionary,
                                                     gpointer self)
{
	KkcDictionaryCallbackReturn result;
	result = __lambda9_ ((KkcDictionaryList*) self, dictionary);
#line 96 "dictionary-list.vala"
	return result;
#line 330 "dictionary-list.c"
}

void
kkc_dictionary_list_save (KkcDictionaryList* self)
{
#line 95 "dictionary-list.vala"
	g_return_if_fail (self != NULL);
#line 96 "dictionary-list.vala"
	kkc_dictionary_list_call (self, NULL, ___lambda9__kkc_dictionary_list_dictionary_callback, self);
#line 340 "dictionary-list.c"
}

KkcDictionaryList*
kkc_dictionary_list_construct (GType object_type)
{
	KkcDictionaryList * self = NULL;
#line 36 "dictionary-list.vala"
	self = (KkcDictionaryList*) g_object_new (object_type, NULL);
#line 36 "dictionary-list.vala"
	return self;
#line 351 "dictionary-list.c"
}

KkcDictionaryList*
kkc_dictionary_list_new (void)
{
#line 36 "dictionary-list.vala"
	return kkc_dictionary_list_construct (KKC_TYPE_DICTIONARY_LIST);
#line 359 "dictionary-list.c"
}

gint
kkc_dictionary_list_get_size (KkcDictionaryList* self)
{
	gint result;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 43 "dictionary-list.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "dictionary-list.vala"
	_tmp0_ = self->priv->dictionaries;
#line 44 "dictionary-list.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 44 "dictionary-list.vala"
	_tmp2_ = _tmp1_;
#line 44 "dictionary-list.vala"
	result = _tmp2_;
#line 44 "dictionary-list.vala"
	return result;
#line 381 "dictionary-list.c"
}

static void
kkc_dictionary_list_class_init (KkcDictionaryListClass * klass,
                                gpointer klass_data)
{
#line 36 "dictionary-list.vala"
	kkc_dictionary_list_parent_class = g_type_class_peek_parent (klass);
#line 36 "dictionary-list.vala"
	g_type_class_adjust_private_offset (klass, &KkcDictionaryList_private_offset);
#line 36 "dictionary-list.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_kkc_dictionary_list_get_property;
#line 36 "dictionary-list.vala"
	G_OBJECT_CLASS (klass)->finalize = kkc_dictionary_list_finalize;
#line 396 "dictionary-list.c"
	/**
	         * The number of dictionaries registered.
	         */
#line 36 "dictionary-list.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_DICTIONARY_LIST_SIZE_PROPERTY, kkc_dictionary_list_properties[KKC_DICTIONARY_LIST_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 402 "dictionary-list.c"
}

static void
kkc_dictionary_list_instance_init (KkcDictionaryList * self,
                                   gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 36 "dictionary-list.vala"
	self->priv = kkc_dictionary_list_get_instance_private (self);
#line 37 "dictionary-list.vala"
	_tmp0_ = gee_array_list_new (KKC_TYPE_DICTIONARY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 37 "dictionary-list.vala"
	self->priv->dictionaries = (GeeList*) _tmp0_;
#line 416 "dictionary-list.c"
}

static void
kkc_dictionary_list_finalize (GObject * obj)
{
	KkcDictionaryList * self;
#line 36 "dictionary-list.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_DICTIONARY_LIST, KkcDictionaryList);
#line 37 "dictionary-list.vala"
	_g_object_unref0 (self->priv->dictionaries);
#line 36 "dictionary-list.vala"
	G_OBJECT_CLASS (kkc_dictionary_list_parent_class)->finalize (obj);
#line 429 "dictionary-list.c"
}

static GType
kkc_dictionary_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KkcDictionaryListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_dictionary_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcDictionaryList), 0, (GInstanceInitFunc) kkc_dictionary_list_instance_init, NULL };
	GType kkc_dictionary_list_type_id;
	kkc_dictionary_list_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcDictionaryList", &g_define_type_info, 0);
	KkcDictionaryList_private_offset = g_type_add_instance_private (kkc_dictionary_list_type_id, sizeof (KkcDictionaryListPrivate));
	return kkc_dictionary_list_type_id;
}

GType
kkc_dictionary_list_get_type (void)
{
	static volatile gsize kkc_dictionary_list_type_id__once = 0;
	if (g_once_init_enter (&kkc_dictionary_list_type_id__once)) {
		GType kkc_dictionary_list_type_id;
		kkc_dictionary_list_type_id = kkc_dictionary_list_get_type_once ();
		g_once_init_leave (&kkc_dictionary_list_type_id__once, kkc_dictionary_list_type_id);
	}
	return kkc_dictionary_list_type_id__once;
}

static void
_vala_kkc_dictionary_list_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	KkcDictionaryList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_DICTIONARY_LIST, KkcDictionaryList);
#line 36 "dictionary-list.vala"
	switch (property_id) {
#line 36 "dictionary-list.vala"
		case KKC_DICTIONARY_LIST_SIZE_PROPERTY:
#line 36 "dictionary-list.vala"
		g_value_set_int (value, kkc_dictionary_list_get_size (self));
#line 36 "dictionary-list.vala"
		break;
#line 470 "dictionary-list.c"
		default:
#line 36 "dictionary-list.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "dictionary-list.vala"
		break;
#line 476 "dictionary-list.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 148 "rule.vala"
	if (mem && byte_size != 0) {
#line 148 "rule.vala"
		new_mem = g_malloc (byte_size);
#line 148 "rule.vala"
		memcpy (new_mem, mem, byte_size);
#line 491 "dictionary-list.c"
	} else {
#line 148 "rule.vala"
		new_mem = NULL;
#line 495 "dictionary-list.c"
	}
#line 148 "rule.vala"
	return new_mem;
#line 499 "dictionary-list.c"
}

