/* dictionary.c generated by valac 0.56.17, the Vala compiler
 * generated from dictionary.vala, do not modify */

/*
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "libkkc/libkkc.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define KKC_TYPE_DICTIONARY_UTILS (kkc_dictionary_utils_get_type ())
#define KKC_DICTIONARY_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KKC_TYPE_DICTIONARY_UTILS, KkcDictionaryUtils))
#define KKC_DICTIONARY_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KKC_TYPE_DICTIONARY_UTILS, KkcDictionaryUtilsClass))
#define KKC_IS_DICTIONARY_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KKC_TYPE_DICTIONARY_UTILS))
#define KKC_IS_DICTIONARY_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KKC_TYPE_DICTIONARY_UTILS))
#define KKC_DICTIONARY_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KKC_TYPE_DICTIONARY_UTILS, KkcDictionaryUtilsClass))

typedef struct _KkcDictionaryUtils KkcDictionaryUtils;
typedef struct _KkcDictionaryUtilsClass KkcDictionaryUtilsClass;
typedef struct _KkcDictionaryUtilsPrivate KkcDictionaryUtilsPrivate;
enum  {
	KKC_DICTIONARY_UTILS_0_PROPERTY,
	KKC_DICTIONARY_UTILS_NUM_PROPERTIES
};
static GParamSpec* kkc_dictionary_utils_properties[KKC_DICTIONARY_UTILS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KkcDictionaryUtils {
	GObject parent_instance;
	KkcDictionaryUtilsPrivate * priv;
};

struct _KkcDictionaryUtilsClass {
	GObjectClass parent_class;
};

static gpointer kkc_dictionary_utils_parent_class = NULL;
static GRegex* kkc_dictionary_utils_escape_regex;
static GRegex* kkc_dictionary_utils_escape_regex = NULL;

VALA_EXTERN GType kkc_dictionary_utils_get_type (void) G_GNUC_CONST ;
VALA_EXTERN KkcCandidate** kkc_dictionary_utils_split_candidates (const gchar* midasi,
                                                      gboolean okuri,
                                                      const gchar* line,
                                                      gint* result_length1);
VALA_EXTERN gchar* kkc_dictionary_utils_unescape (const gchar* input);
VALA_EXTERN gchar* kkc_dictionary_utils_join_candidates (KkcCandidate** candidates,
                                             gint candidates_length1);
VALA_EXTERN gchar* kkc_dictionary_utils_escape (const gchar* input);
static gboolean kkc_dictionary_utils_unescape_eval (GMatchInfo* info,
                                             GString* _result_);
VALA_EXTERN gchar* kkc_utils_parse_hex (const gchar* hex);
static gboolean _kkc_dictionary_utils_unescape_eval_gregex_eval_callback (GMatchInfo* match_info,
                                                                   GString* _result_,
                                                                   gpointer self);
VALA_EXTERN KkcDictionaryUtils* kkc_dictionary_utils_construct (GType object_type);
static void kkc_dictionary_utils_finalize (GObject * obj);
static GType kkc_dictionary_utils_get_type_once (void);
static void kkc_dictionary_real_save (KkcDictionary* self,
                               GError** error);
static GType kkc_dictionary_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
         * Parse a line consisting of candidates separated by "/".
         *
         * @param line a line consisting of candidates
         * @return an array of Candidates
         */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 130 "dictionary.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 157 "dictionary.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 163 "dictionary.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 169 "dictionary.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 173 "dictionary.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 181 "dictionary.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 185 "dictionary.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 197 "dictionary.c"
}

KkcCandidate**
kkc_dictionary_utils_split_candidates (const gchar* midasi,
                                       gboolean okuri,
                                       const gchar* line,
                                       gint* result_length1)
{
	gchar** strv = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint strv_length1;
	gint _strv_size_;
	KkcCandidate** candidates = NULL;
	gchar** _tmp7_;
	gint _tmp7__length1;
	KkcCandidate** _tmp8_;
	gint candidates_length1;
	gint _candidates_size_;
	KkcCandidate** _tmp31_;
	gint _tmp31__length1;
	KkcCandidate** result;
#line 26 "dictionary.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 26 "dictionary.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 30 "dictionary.vala"
	_tmp0_ = string_strip (line);
#line 30 "dictionary.vala"
	_tmp1_ = _tmp0_;
#line 30 "dictionary.vala"
	_tmp2_ = string_slice (_tmp1_, (glong) 1, (glong) -1);
#line 30 "dictionary.vala"
	_tmp3_ = _tmp2_;
#line 30 "dictionary.vala"
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, "/", 0);
#line 30 "dictionary.vala"
	_tmp6_ = _tmp5_;
#line 30 "dictionary.vala"
	_tmp6__length1 = _vala_array_length (_tmp4_);
#line 30 "dictionary.vala"
	_g_free0 (_tmp3_);
#line 30 "dictionary.vala"
	_g_free0 (_tmp1_);
#line 30 "dictionary.vala"
	strv = _tmp6_;
#line 30 "dictionary.vala"
	strv_length1 = _tmp6__length1;
#line 30 "dictionary.vala"
	_strv_size_ = strv_length1;
#line 31 "dictionary.vala"
	_tmp7_ = strv;
#line 31 "dictionary.vala"
	_tmp7__length1 = strv_length1;
#line 31 "dictionary.vala"
	_tmp8_ = g_new0 (KkcCandidate*, _tmp7__length1 + 1);
#line 31 "dictionary.vala"
	candidates = _tmp8_;
#line 31 "dictionary.vala"
	candidates_length1 = _tmp7__length1;
#line 31 "dictionary.vala"
	_candidates_size_ = candidates_length1;
#line 266 "dictionary.c"
	{
		gint i = 0;
#line 32 "dictionary.vala"
		i = 0;
#line 271 "dictionary.c"
		{
			gboolean _tmp9_ = FALSE;
#line 32 "dictionary.vala"
			_tmp9_ = TRUE;
#line 32 "dictionary.vala"
			while (TRUE) {
#line 278 "dictionary.c"
				gchar** _tmp11_;
				gint _tmp11__length1;
				gchar* candidate_str = NULL;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar** text_annotation = NULL;
				const gchar* _tmp15_;
				gchar** _tmp16_;
				gchar** _tmp17_;
				gint text_annotation_length1;
				gint _text_annotation_size_;
				gchar* text = NULL;
				gchar* annotation = NULL;
				gchar** _tmp18_;
				gint _tmp18__length1;
				KkcCandidate** _tmp27_;
				gint _tmp27__length1;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
				KkcCandidate* _tmp30_;
#line 32 "dictionary.vala"
				if (!_tmp9_) {
#line 303 "dictionary.c"
					gint _tmp10_;
#line 32 "dictionary.vala"
					_tmp10_ = i;
#line 32 "dictionary.vala"
					i = _tmp10_ + 1;
#line 309 "dictionary.c"
				}
#line 32 "dictionary.vala"
				_tmp9_ = FALSE;
#line 32 "dictionary.vala"
				_tmp11_ = strv;
#line 32 "dictionary.vala"
				_tmp11__length1 = strv_length1;
#line 32 "dictionary.vala"
				if (!(i < _tmp11__length1)) {
#line 32 "dictionary.vala"
					break;
#line 321 "dictionary.c"
				}
#line 33 "dictionary.vala"
				_tmp12_ = strv;
#line 33 "dictionary.vala"
				_tmp12__length1 = strv_length1;
#line 33 "dictionary.vala"
				_tmp13_ = _tmp12_[i];
#line 33 "dictionary.vala"
				_tmp14_ = kkc_dictionary_utils_unescape (_tmp13_);
#line 33 "dictionary.vala"
				candidate_str = _tmp14_;
#line 34 "dictionary.vala"
				_tmp15_ = candidate_str;
#line 34 "dictionary.vala"
				_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, ";", 2);
#line 34 "dictionary.vala"
				text_annotation = _tmp17_;
#line 34 "dictionary.vala"
				text_annotation_length1 = _vala_array_length (_tmp16_);
#line 34 "dictionary.vala"
				_text_annotation_size_ = text_annotation_length1;
#line 36 "dictionary.vala"
				_tmp18_ = text_annotation;
#line 36 "dictionary.vala"
				_tmp18__length1 = text_annotation_length1;
#line 36 "dictionary.vala"
				if (_tmp18__length1 == 2) {
#line 349 "dictionary.c"
					gchar** _tmp19_;
					gint _tmp19__length1;
					const gchar* _tmp20_;
					gchar* _tmp21_;
					gchar** _tmp22_;
					gint _tmp22__length1;
					const gchar* _tmp23_;
					gchar* _tmp24_;
#line 37 "dictionary.vala"
					_tmp19_ = text_annotation;
#line 37 "dictionary.vala"
					_tmp19__length1 = text_annotation_length1;
#line 37 "dictionary.vala"
					_tmp20_ = _tmp19_[0];
#line 37 "dictionary.vala"
					_tmp21_ = g_strdup (_tmp20_);
#line 37 "dictionary.vala"
					_g_free0 (text);
#line 37 "dictionary.vala"
					text = _tmp21_;
#line 38 "dictionary.vala"
					_tmp22_ = text_annotation;
#line 38 "dictionary.vala"
					_tmp22__length1 = text_annotation_length1;
#line 38 "dictionary.vala"
					_tmp23_ = _tmp22_[1];
#line 38 "dictionary.vala"
					_tmp24_ = g_strdup (_tmp23_);
#line 38 "dictionary.vala"
					_g_free0 (annotation);
#line 38 "dictionary.vala"
					annotation = _tmp24_;
#line 382 "dictionary.c"
				} else {
					const gchar* _tmp25_;
					gchar* _tmp26_;
#line 40 "dictionary.vala"
					_tmp25_ = candidate_str;
#line 40 "dictionary.vala"
					_tmp26_ = g_strdup (_tmp25_);
#line 40 "dictionary.vala"
					_g_free0 (text);
#line 40 "dictionary.vala"
					text = _tmp26_;
#line 41 "dictionary.vala"
					_g_free0 (annotation);
#line 41 "dictionary.vala"
					annotation = NULL;
#line 398 "dictionary.c"
				}
#line 43 "dictionary.vala"
				_tmp27_ = candidates;
#line 43 "dictionary.vala"
				_tmp27__length1 = candidates_length1;
#line 43 "dictionary.vala"
				_tmp28_ = text;
#line 43 "dictionary.vala"
				_tmp29_ = annotation;
#line 43 "dictionary.vala"
				_tmp30_ = kkc_candidate_new (midasi, okuri, _tmp28_, _tmp29_, NULL);
#line 43 "dictionary.vala"
				_g_object_unref0 (_tmp27_[i]);
#line 43 "dictionary.vala"
				_tmp27_[i] = _tmp30_;
#line 32 "dictionary.vala"
				_g_free0 (annotation);
#line 32 "dictionary.vala"
				_g_free0 (text);
#line 32 "dictionary.vala"
				text_annotation = (_vala_array_free (text_annotation, text_annotation_length1, (GDestroyNotify) g_free), NULL);
#line 32 "dictionary.vala"
				_g_free0 (candidate_str);
#line 422 "dictionary.c"
			}
		}
	}
#line 48 "dictionary.vala"
	_tmp31_ = candidates;
#line 48 "dictionary.vala"
	_tmp31__length1 = candidates_length1;
#line 48 "dictionary.vala"
	if (result_length1) {
#line 48 "dictionary.vala"
		*result_length1 = _tmp31__length1;
#line 434 "dictionary.c"
	}
#line 48 "dictionary.vala"
	result = _tmp31_;
#line 48 "dictionary.vala"
	strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 48 "dictionary.vala"
	return result;
#line 442 "dictionary.c"
}

/**
         * Format an array of Candidates to be saved in a dictionary file.
         *
         * @param candidates an array of Candidate
         * @return a string
         */
static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 462 "dictionary.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 466 "dictionary.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 472 "dictionary.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 477 "dictionary.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 483 "dictionary.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 487 "dictionary.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 491 "dictionary.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 495 "dictionary.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 499 "dictionary.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 503 "dictionary.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 518 "dictionary.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 527 "dictionary.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 534 "dictionary.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 540 "dictionary.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 548 "dictionary.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 552 "dictionary.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 558 "dictionary.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 563 "dictionary.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 569 "dictionary.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 573 "dictionary.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 577 "dictionary.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 583 "dictionary.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 589 "dictionary.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 601 "dictionary.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 605 "dictionary.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 609 "dictionary.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 614 "dictionary.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 622 "dictionary.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 640 "dictionary.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 646 "dictionary.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 650 "dictionary.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 658 "dictionary.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 667 "dictionary.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 676 "dictionary.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 682 "dictionary.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 690 "dictionary.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 702 "dictionary.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 708 "dictionary.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 712 "dictionary.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 720 "dictionary.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 731 "dictionary.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 740 "dictionary.c"
	}
}

gchar*
kkc_dictionary_utils_join_candidates (KkcCandidate** candidates,
                                      gint candidates_length1)
{
	gchar** strv = NULL;
	gchar** _tmp0_;
	gint strv_length1;
	gint _strv_size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* result;
#line 58 "dictionary.vala"
	_tmp0_ = g_new0 (gchar*, candidates_length1 + 1);
#line 58 "dictionary.vala"
	strv = _tmp0_;
#line 58 "dictionary.vala"
	strv_length1 = candidates_length1;
#line 58 "dictionary.vala"
	_strv_size_ = strv_length1;
#line 769 "dictionary.c"
	{
		gint i = 0;
#line 59 "dictionary.vala"
		i = 0;
#line 774 "dictionary.c"
		{
			gboolean _tmp1_ = FALSE;
#line 59 "dictionary.vala"
			_tmp1_ = TRUE;
#line 59 "dictionary.vala"
			while (TRUE) {
#line 781 "dictionary.c"
				gchar** _tmp3_;
				gint _tmp3__length1;
				KkcCandidate* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
#line 59 "dictionary.vala"
				if (!_tmp1_) {
#line 790 "dictionary.c"
					gint _tmp2_;
#line 59 "dictionary.vala"
					_tmp2_ = i;
#line 59 "dictionary.vala"
					i = _tmp2_ + 1;
#line 796 "dictionary.c"
				}
#line 59 "dictionary.vala"
				_tmp1_ = FALSE;
#line 59 "dictionary.vala"
				if (!(i < candidates_length1)) {
#line 59 "dictionary.vala"
					break;
#line 804 "dictionary.c"
				}
#line 60 "dictionary.vala"
				_tmp3_ = strv;
#line 60 "dictionary.vala"
				_tmp3__length1 = strv_length1;
#line 60 "dictionary.vala"
				_tmp4_ = candidates[i];
#line 60 "dictionary.vala"
				_tmp5_ = kkc_candidate_to_string (_tmp4_);
#line 60 "dictionary.vala"
				_tmp6_ = _tmp5_;
#line 60 "dictionary.vala"
				_tmp7_ = kkc_dictionary_utils_escape (_tmp6_);
#line 60 "dictionary.vala"
				_g_free0 (_tmp3_[i]);
#line 60 "dictionary.vala"
				_tmp3_[i] = _tmp7_;
#line 60 "dictionary.vala"
				_g_free0 (_tmp6_);
#line 824 "dictionary.c"
			}
		}
	}
#line 62 "dictionary.vala"
	_tmp8_ = strv;
#line 62 "dictionary.vala"
	_tmp8__length1 = strv_length1;
#line 62 "dictionary.vala"
	_tmp9_ = _vala_g_strjoinv ("/", _tmp8_, (gint) _tmp8__length1);
#line 62 "dictionary.vala"
	_tmp10_ = _tmp9_;
#line 62 "dictionary.vala"
	_tmp11_ = g_strconcat ("/", _tmp10_, NULL);
#line 62 "dictionary.vala"
	_tmp12_ = _tmp11_;
#line 62 "dictionary.vala"
	_tmp13_ = g_strconcat (_tmp12_, "/", NULL);
#line 62 "dictionary.vala"
	_tmp14_ = _tmp13_;
#line 62 "dictionary.vala"
	_g_free0 (_tmp12_);
#line 62 "dictionary.vala"
	_g_free0 (_tmp10_);
#line 62 "dictionary.vala"
	result = _tmp14_;
#line 62 "dictionary.vala"
	strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 62 "dictionary.vala"
	return result;
#line 854 "dictionary.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1302 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1303 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1304 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 870 "dictionary.c"
		gchar* _tmp0_;
#line 1305 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1305 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1306 "glib-2.0.vapi"
		result = TRUE;
#line 1306 "glib-2.0.vapi"
		if (c) {
#line 1306 "glib-2.0.vapi"
			*c = _vala_c;
#line 882 "dictionary.c"
		}
#line 1306 "glib-2.0.vapi"
		return result;
#line 886 "dictionary.c"
	} else {
#line 1308 "glib-2.0.vapi"
		result = FALSE;
#line 1308 "glib-2.0.vapi"
		if (c) {
#line 1308 "glib-2.0.vapi"
			*c = _vala_c;
#line 894 "dictionary.c"
		}
#line 1308 "glib-2.0.vapi"
		return result;
#line 898 "dictionary.c"
	}
}

gchar*
kkc_dictionary_utils_escape (const gchar* input)
{
	GString* builder = NULL;
	GString* _tmp0_;
	gint index = 0;
	gunichar uc = 0U;
	GString* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 65 "dictionary.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 66 "dictionary.vala"
	_tmp0_ = g_string_new ("");
#line 66 "dictionary.vala"
	builder = _tmp0_;
#line 67 "dictionary.vala"
	index = 0;
#line 69 "dictionary.vala"
	while (TRUE) {
#line 923 "dictionary.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
#line 69 "dictionary.vala"
		_tmp2_ = string_get_next_char (input, &index, &_tmp1_);
#line 69 "dictionary.vala"
		uc = _tmp1_;
#line 69 "dictionary.vala"
		if (!_tmp2_) {
#line 69 "dictionary.vala"
			break;
#line 934 "dictionary.c"
		}
#line 70 "dictionary.vala"
		switch (uc) {
#line 70 "dictionary.vala"
			case '\\':
#line 70 "dictionary.vala"
			case '/':
#line 70 "dictionary.vala"
			case ' ':
#line 70 "dictionary.vala"
			case '\t':
#line 70 "dictionary.vala"
			case '\n':
#line 948 "dictionary.c"
			{
				GString* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
#line 76 "dictionary.vala"
				_tmp3_ = builder;
#line 76 "dictionary.vala"
				_tmp4_ = g_strdup_printf ("\\x%02x", (guint) uc);
#line 76 "dictionary.vala"
				_tmp5_ = _tmp4_;
#line 76 "dictionary.vala"
				g_string_append (_tmp3_, _tmp5_);
#line 76 "dictionary.vala"
				_g_free0 (_tmp5_);
#line 77 "dictionary.vala"
				break;
#line 965 "dictionary.c"
			}
			default:
			{
				GString* _tmp6_;
#line 79 "dictionary.vala"
				_tmp6_ = builder;
#line 79 "dictionary.vala"
				g_string_append_unichar (_tmp6_, uc);
#line 80 "dictionary.vala"
				break;
#line 976 "dictionary.c"
			}
		}
	}
#line 83 "dictionary.vala"
	_tmp7_ = builder;
#line 83 "dictionary.vala"
	_tmp8_ = _tmp7_->str;
#line 83 "dictionary.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 83 "dictionary.vala"
	result = _tmp9_;
#line 83 "dictionary.vala"
	_g_string_free0 (builder);
#line 83 "dictionary.vala"
	return result;
#line 992 "dictionary.c"
}

static gboolean
kkc_dictionary_utils_unescape_eval (GMatchInfo* info,
                                    GString* _result_)
{
	gchar* hex = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean result;
#line 86 "dictionary.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 86 "dictionary.vala"
	g_return_val_if_fail (_result_ != NULL, FALSE);
#line 87 "dictionary.vala"
	_tmp0_ = g_match_info_fetch (info, 1);
#line 87 "dictionary.vala"
	hex = _tmp0_;
#line 88 "dictionary.vala"
	_vala_assert (hex != NULL, "hex != null");
#line 89 "dictionary.vala"
	_tmp1_ = kkc_utils_parse_hex (hex);
#line 89 "dictionary.vala"
	_tmp2_ = _tmp1_;
#line 89 "dictionary.vala"
	g_string_append (_result_, _tmp2_);
#line 89 "dictionary.vala"
	_g_free0 (_tmp2_);
#line 90 "dictionary.vala"
	result = FALSE;
#line 90 "dictionary.vala"
	_g_free0 (hex);
#line 90 "dictionary.vala"
	return result;
#line 1028 "dictionary.c"
}

static gboolean
_kkc_dictionary_utils_unescape_eval_gregex_eval_callback (GMatchInfo* match_info,
                                                          GString* _result_,
                                                          gpointer self)
{
	gboolean result;
	result = kkc_dictionary_utils_unescape_eval (match_info, _result_);
#line 95 "dictionary.vala"
	return result;
#line 1040 "dictionary.c"
}

gchar*
kkc_dictionary_utils_unescape (const gchar* input)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 93 "dictionary.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 1050 "dictionary.c"
	{
		gchar* _tmp0_ = NULL;
		GRegex* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 95 "dictionary.vala"
		_tmp1_ = kkc_dictionary_utils_escape_regex;
#line 95 "dictionary.vala"
		_tmp2_ = g_regex_replace_eval (_tmp1_, input, (gssize) -1, 0, 0, _kkc_dictionary_utils_unescape_eval_gregex_eval_callback, NULL, &_inner_error0_);
#line 95 "dictionary.vala"
		_tmp0_ = _tmp2_;
#line 95 "dictionary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "dictionary.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1066 "dictionary.c"
				goto __catch0_g_regex_error;
			}
#line 95 "dictionary.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 95 "dictionary.vala"
			g_clear_error (&_inner_error0_);
#line 95 "dictionary.vala"
			return NULL;
#line 1075 "dictionary.c"
		}
#line 95 "dictionary.vala"
		_tmp3_ = _tmp0_;
#line 95 "dictionary.vala"
		_tmp0_ = NULL;
#line 95 "dictionary.vala"
		result = _tmp3_;
#line 95 "dictionary.vala"
		_g_free0 (_tmp0_);
#line 95 "dictionary.vala"
		return result;
#line 1087 "dictionary.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 94 "dictionary.vala"
		g_clear_error (&_inner_error0_);
#line 101 "dictionary.vala"
		g_assert_not_reached ();
#line 1096 "dictionary.c"
	}
	__finally0:
#line 94 "dictionary.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "dictionary.vala"
	g_clear_error (&_inner_error0_);
#line 94 "dictionary.vala"
	return NULL;
#line 1105 "dictionary.c"
}

KkcDictionaryUtils*
kkc_dictionary_utils_construct (GType object_type)
{
	KkcDictionaryUtils * self = NULL;
#line 19 "dictionary.vala"
	self = (KkcDictionaryUtils*) g_object_new (object_type, NULL);
#line 19 "dictionary.vala"
	return self;
#line 1116 "dictionary.c"
}

static void
kkc_dictionary_utils_class_init (KkcDictionaryUtilsClass * klass,
                                 gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 19 "dictionary.vala"
	kkc_dictionary_utils_parent_class = g_type_class_peek_parent (klass);
#line 19 "dictionary.vala"
	G_OBJECT_CLASS (klass)->finalize = kkc_dictionary_utils_finalize;
#line 1128 "dictionary.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 109 "dictionary.vala"
		_tmp1_ = g_regex_new ("\\\\x([0-9A-Fa-f]{1,2})", 0, 0, &_inner_error0_);
#line 109 "dictionary.vala"
		_tmp0_ = _tmp1_;
#line 109 "dictionary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "dictionary.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1141 "dictionary.c"
				goto __catch0_g_regex_error;
			}
#line 109 "dictionary.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "dictionary.vala"
			g_clear_error (&_inner_error0_);
#line 1148 "dictionary.c"
		}
#line 109 "dictionary.vala"
		_tmp2_ = _tmp0_;
#line 109 "dictionary.vala"
		_tmp0_ = NULL;
#line 109 "dictionary.vala"
		_g_regex_unref0 (kkc_dictionary_utils_escape_regex);
#line 109 "dictionary.vala"
		kkc_dictionary_utils_escape_regex = _tmp2_;
#line 108 "dictionary.vala"
		_g_regex_unref0 (_tmp0_);
#line 1160 "dictionary.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 108 "dictionary.vala"
		g_clear_error (&_inner_error0_);
#line 112 "dictionary.vala"
		g_assert_not_reached ();
#line 1169 "dictionary.c"
	}
	__finally0:
#line 108 "dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "dictionary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "dictionary.vala"
		g_clear_error (&_inner_error0_);
#line 1178 "dictionary.c"
	}
}

static void
kkc_dictionary_utils_instance_init (KkcDictionaryUtils * self,
                                    gpointer klass)
{
}

static void
kkc_dictionary_utils_finalize (GObject * obj)
{
	KkcDictionaryUtils * self;
#line 19 "dictionary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_DICTIONARY_UTILS, KkcDictionaryUtils);
#line 19 "dictionary.vala"
	G_OBJECT_CLASS (kkc_dictionary_utils_parent_class)->finalize (obj);
#line 1196 "dictionary.c"
}

static GType
kkc_dictionary_utils_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KkcDictionaryUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_dictionary_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcDictionaryUtils), 0, (GInstanceInitFunc) kkc_dictionary_utils_instance_init, NULL };
	GType kkc_dictionary_utils_type_id;
	kkc_dictionary_utils_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcDictionaryUtils", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return kkc_dictionary_utils_type_id;
}

GType
kkc_dictionary_utils_get_type (void)
{
	static volatile gsize kkc_dictionary_utils_type_id__once = 0;
	if (g_once_init_enter (&kkc_dictionary_utils_type_id__once)) {
		GType kkc_dictionary_utils_type_id;
		kkc_dictionary_utils_type_id = kkc_dictionary_utils_get_type_once ();
		g_once_init_leave (&kkc_dictionary_utils_type_id__once, kkc_dictionary_utils_type_id);
	}
	return kkc_dictionary_utils_type_id__once;
}

/**
         * Reload the dictionary.
         *
         * @throws GLib.Error when reading the dictionary failed.
         */
void
kkc_dictionary_reload (KkcDictionary* self,
                       GError** error)
{
	KkcDictionaryIface* _iface_;
#line 126 "dictionary.vala"
	g_return_if_fail (self != NULL);
#line 126 "dictionary.vala"
	_iface_ = KKC_DICTIONARY_GET_INTERFACE (self);
#line 126 "dictionary.vala"
	if (_iface_->reload) {
#line 126 "dictionary.vala"
		_iface_->reload (self, error);
#line 1238 "dictionary.c"
	}
}

/**
         * Save the dictionary on disk.
         *
         * @throws GLib.Error if the dictionary cannot be saved.
         */
static void
kkc_dictionary_real_save (KkcDictionary* self,
                          GError** error)
{
}

void
kkc_dictionary_save (KkcDictionary* self,
                     GError** error)
{
	KkcDictionaryIface* _iface_;
#line 133 "dictionary.vala"
	g_return_if_fail (self != NULL);
#line 133 "dictionary.vala"
	_iface_ = KKC_DICTIONARY_GET_INTERFACE (self);
#line 133 "dictionary.vala"
	if (_iface_->save) {
#line 133 "dictionary.vala"
		_iface_->save (self, error);
#line 1266 "dictionary.c"
	}
}

static void
kkc_dictionary_default_init (KkcDictionaryIface * iface,
                             gpointer iface_data)
{
#line 120 "dictionary.vala"
	iface->save = kkc_dictionary_real_save;
#line 1276 "dictionary.c"
}

/**
     * Base interface of dictionaries.
     */
static GType
kkc_dictionary_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KkcDictionaryIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_dictionary_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType kkc_dictionary_type_id;
	kkc_dictionary_type_id = g_type_register_static (G_TYPE_INTERFACE, "KkcDictionary", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (kkc_dictionary_type_id, G_TYPE_OBJECT);
	return kkc_dictionary_type_id;
}

GType
kkc_dictionary_get_type (void)
{
	static volatile gsize kkc_dictionary_type_id__once = 0;
	if (g_once_init_enter (&kkc_dictionary_type_id__once)) {
		GType kkc_dictionary_type_id;
		kkc_dictionary_type_id = kkc_dictionary_get_type_once ();
		g_once_init_leave (&kkc_dictionary_type_id__once, kkc_dictionary_type_id);
	}
	return kkc_dictionary_type_id__once;
}

GQuark
kkc_dictionary_error_quark (void)
{
#line 148 "rule.vala"
	return g_quark_from_static_string ("kkc-dictionary-error-quark");
#line 1309 "dictionary.c"
}

static GType
kkc_dictionary_error_get_type_once (void)
{
	static const GEnumValue values[] = {{KKC_DICTIONARY_ERROR_NOT_READABLE, "KKC_DICTIONARY_ERROR_NOT_READABLE", "not-readable"}, {KKC_DICTIONARY_ERROR_MALFORMED_INPUT, "KKC_DICTIONARY_ERROR_MALFORMED_INPUT", "malformed-input"}, {0, NULL, NULL}};
	GType kkc_dictionary_error_type_id;
	kkc_dictionary_error_type_id = g_enum_register_static ("KkcDictionaryError", values);
	return kkc_dictionary_error_type_id;
}

GType
kkc_dictionary_error_get_type (void)
{
	static volatile gsize kkc_dictionary_error_type_id__once = 0;
	if (g_once_init_enter (&kkc_dictionary_error_type_id__once)) {
		GType kkc_dictionary_error_type_id;
		kkc_dictionary_error_type_id = kkc_dictionary_error_get_type_once ();
		g_once_init_leave (&kkc_dictionary_error_type_id__once, kkc_dictionary_error_type_id);
	}
	return kkc_dictionary_error_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 148 "rule.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1340 "dictionary.c"
		gssize i;
#line 148 "rule.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 148 "rule.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 148 "rule.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1348 "dictionary.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 148 "rule.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 148 "rule.vala"
	g_free (array);
#line 1363 "dictionary.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 148 "rule.vala"
	if (array) {
#line 148 "rule.vala"
		while (((gpointer*) array)[length]) {
#line 148 "rule.vala"
			length++;
#line 1377 "dictionary.c"
		}
	}
#line 148 "rule.vala"
	return length;
#line 1382 "dictionary.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 148 "rule.vala"
	if (mem && byte_size != 0) {
#line 148 "rule.vala"
		new_mem = g_malloc (byte_size);
#line 148 "rule.vala"
		memcpy (new_mem, mem, byte_size);
#line 1396 "dictionary.c"
	} else {
#line 148 "rule.vala"
		new_mem = NULL;
#line 1400 "dictionary.c"
	}
#line 148 "rule.vala"
	return new_mem;
#line 1404 "dictionary.c"
}

