/* encoding.c generated by valac 0.56.17, the Vala compiler
 * generated from encoding.vala, do not modify */

/*
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "libkkc/libkkc.h"

#define KKC_ENCODING_CONVERTER_BUFSIZ 4096
#define KKC_ENCODING_CONVERTER_INTERNAL_ENCODING "UTF-8"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define KKC_TYPE_ENCODING_CONVERTER (kkc_encoding_converter_get_type ())
#define KKC_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KKC_TYPE_ENCODING_CONVERTER, KkcEncodingConverter))
#define KKC_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KKC_TYPE_ENCODING_CONVERTER, KkcEncodingConverterClass))
#define KKC_IS_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KKC_TYPE_ENCODING_CONVERTER))
#define KKC_IS_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KKC_TYPE_ENCODING_CONVERTER))
#define KKC_ENCODING_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KKC_TYPE_ENCODING_CONVERTER, KkcEncodingConverterClass))

typedef struct _KkcEncodingConverter KkcEncodingConverter;
typedef struct _KkcEncodingConverterClass KkcEncodingConverterClass;
typedef struct _KkcEncodingConverterPrivate KkcEncodingConverterPrivate;
enum  {
	KKC_ENCODING_CONVERTER_0_PROPERTY,
	KKC_ENCODING_CONVERTER_ENCODING_PROPERTY,
	KKC_ENCODING_CONVERTER_NUM_PROPERTIES
};
static GParamSpec* kkc_encoding_converter_properties[KKC_ENCODING_CONVERTER_NUM_PROPERTIES];

#define KKC_ENCODING_CONVERTER_TYPE_ENCODING_CODING_SYSTEM_ENTRY (kkc_encoding_converter_encoding_coding_system_entry_get_type ())
typedef struct _KkcEncodingConverterEncodingCodingSystemEntry KkcEncodingConverterEncodingCodingSystemEntry;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _KkcEncodingConverter {
	GObject parent_instance;
	KkcEncodingConverterPrivate * priv;
};

struct _KkcEncodingConverterClass {
	GObjectClass parent_class;
};

struct _KkcEncodingConverterPrivate {
	gchar* _encoding;
	GCharsetConverter* encoder;
	GCharsetConverter* decoder;
};

struct _KkcEncodingConverterEncodingCodingSystemEntry {
	gchar* key;
	gchar* value;
};

static gint KkcEncodingConverter_private_offset;
static gpointer kkc_encoding_converter_parent_class = NULL;
static GRegex* kkc_encoding_converter_coding_cookie_regex;
static GRegex* kkc_encoding_converter_coding_cookie_regex = NULL;
static GInitableIface * kkc_encoding_converter_g_initable_parent_iface = NULL;

VALA_EXTERN GType kkc_encoding_converter_get_type (void) G_GNUC_CONST ;
static GType kkc_encoding_converter_encoding_coding_system_entry_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static KkcEncodingConverterEncodingCodingSystemEntry* kkc_encoding_converter_encoding_coding_system_entry_dup (const KkcEncodingConverterEncodingCodingSystemEntry* self);
static void kkc_encoding_converter_encoding_coding_system_entry_free (KkcEncodingConverterEncodingCodingSystemEntry* self);
static void kkc_encoding_converter_encoding_coding_system_entry_copy (const KkcEncodingConverterEncodingCodingSystemEntry* self,
                                                               KkcEncodingConverterEncodingCodingSystemEntry* dest);
static void kkc_encoding_converter_encoding_coding_system_entry_destroy (KkcEncodingConverterEncodingCodingSystemEntry* self);
VALA_EXTERN gchar* kkc_encoding_converter_extract_coding_system (const gchar* line);
static gboolean kkc_encoding_converter_real_init (GInitable* base,
                                           GCancellable* cancellable,
                                           GError** error);
VALA_EXTERN const gchar* kkc_encoding_converter_get_encoding (KkcEncodingConverter* self);
VALA_EXTERN KkcEncodingConverter* kkc_encoding_converter_new (const gchar* encoding,
                                                  GError** error);
VALA_EXTERN KkcEncodingConverter* kkc_encoding_converter_construct (GType object_type,
                                                        const gchar* encoding,
                                                        GError** error);
VALA_EXTERN KkcEncodingConverter* kkc_encoding_converter_new_from_coding_system (const gchar* coding,
                                                                     GError** error);
VALA_EXTERN KkcEncodingConverter* kkc_encoding_converter_construct_from_coding_system (GType object_type,
                                                                           const gchar* coding,
                                                                           GError** error);
static gchar* kkc_encoding_converter_convert (KkcEncodingConverter* self,
                                       GCharsetConverter* converter,
                                       const gchar* str,
                                       GError** error);
static guint8* _vala_array_dup5 (guint8* self,
                          gssize length);
VALA_EXTERN gchar* kkc_encoding_converter_encode (KkcEncodingConverter* self,
                                      const gchar* internal_str,
                                      GError** error);
VALA_EXTERN gchar* kkc_encoding_converter_decode (KkcEncodingConverter* self,
                                      const gchar* external_str,
                                      GError** error);
VALA_EXTERN void kkc_encoding_converter_set_encoding (KkcEncodingConverter* self,
                                          const gchar* value);
static void kkc_encoding_converter_finalize (GObject * obj);
static GType kkc_encoding_converter_get_type_once (void);
static void _vala_kkc_encoding_converter_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_kkc_encoding_converter_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const KkcEncodingConverterEncodingCodingSystemEntry KKC_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE[7] = {{"UTF-8", "utf-8"}, {"EUC-JP", "euc-jp"}, {"Shift_JIS", "shift_jis"}, {"ISO-2022-JP", "iso-2022-jp"}, {"EUC-JISX0213", "euc-jisx0213"}, {"EUC-JISX0213", "euc-jis-2004"}, {"SHIFT_JISX0213", "shift_jis-2004"}};

static inline gpointer
kkc_encoding_converter_get_instance_private (KkcEncodingConverter* self)
{
	return G_STRUCT_MEMBER_P (self, KkcEncodingConverter_private_offset);
}

gchar*
kkc_encoding_converter_extract_coding_system (const gchar* line)
{
	GMatchInfo* info = NULL;
	GRegex* _tmp0_;
	GMatchInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
	gchar* result;
#line 51 "encoding.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 52 "encoding.vala"
	info = NULL;
#line 53 "encoding.vala"
	_tmp0_ = kkc_encoding_converter_coding_cookie_regex;
#line 53 "encoding.vala"
	_tmp2_ = g_regex_match (_tmp0_, line, 0, &_tmp1_);
#line 53 "encoding.vala"
	_g_match_info_unref0 (info);
#line 53 "encoding.vala"
	info = _tmp1_;
#line 53 "encoding.vala"
	if (_tmp2_) {
#line 171 "encoding.c"
		GMatchInfo* _tmp3_;
		gchar* _tmp4_;
#line 54 "encoding.vala"
		_tmp3_ = info;
#line 54 "encoding.vala"
		_tmp4_ = g_match_info_fetch (_tmp3_, 1);
#line 54 "encoding.vala"
		result = _tmp4_;
#line 54 "encoding.vala"
		_g_match_info_unref0 (info);
#line 54 "encoding.vala"
		return result;
#line 184 "encoding.c"
	}
#line 56 "encoding.vala"
	result = NULL;
#line 56 "encoding.vala"
	_g_match_info_unref0 (info);
#line 56 "encoding.vala"
	return result;
#line 192 "encoding.c"
}

static gboolean
kkc_encoding_converter_real_init (GInitable* base,
                                  GCancellable* cancellable,
                                  GError** error)
{
	KkcEncodingConverter * self;
	GCharsetConverter* _tmp0_ = NULL;
	const gchar* _tmp1_;
	GCharsetConverter* _tmp2_;
	GCharsetConverter* _tmp4_;
	GCharsetConverter* _tmp5_ = NULL;
	const gchar* _tmp6_;
	GCharsetConverter* _tmp7_;
	GCharsetConverter* _tmp9_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 64 "encoding.vala"
	self = (KkcEncodingConverter*) base;
#line 65 "encoding.vala"
	_tmp1_ = self->priv->_encoding;
#line 65 "encoding.vala"
	_tmp2_ = g_charset_converter_new (_tmp1_, KKC_ENCODING_CONVERTER_INTERNAL_ENCODING, &_inner_error0_);
#line 65 "encoding.vala"
	_tmp0_ = _tmp2_;
#line 65 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "encoding.c"
		gboolean _tmp3_ = FALSE;
#line 65 "encoding.vala"
		g_propagate_error (error, _inner_error0_);
#line 65 "encoding.vala"
		return _tmp3_;
#line 227 "encoding.c"
	}
#line 65 "encoding.vala"
	_tmp4_ = _tmp0_;
#line 65 "encoding.vala"
	_tmp0_ = NULL;
#line 65 "encoding.vala"
	_g_object_unref0 (self->priv->encoder);
#line 65 "encoding.vala"
	self->priv->encoder = _tmp4_;
#line 66 "encoding.vala"
	_tmp6_ = self->priv->_encoding;
#line 66 "encoding.vala"
	_tmp7_ = g_charset_converter_new (KKC_ENCODING_CONVERTER_INTERNAL_ENCODING, _tmp6_, &_inner_error0_);
#line 66 "encoding.vala"
	_tmp5_ = _tmp7_;
#line 66 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 245 "encoding.c"
		gboolean _tmp8_ = FALSE;
#line 66 "encoding.vala"
		g_propagate_error (error, _inner_error0_);
#line 66 "encoding.vala"
		_g_object_unref0 (_tmp0_);
#line 66 "encoding.vala"
		return _tmp8_;
#line 253 "encoding.c"
	}
#line 66 "encoding.vala"
	_tmp9_ = _tmp5_;
#line 66 "encoding.vala"
	_tmp5_ = NULL;
#line 66 "encoding.vala"
	_g_object_unref0 (self->priv->decoder);
#line 66 "encoding.vala"
	self->priv->decoder = _tmp9_;
#line 67 "encoding.vala"
	result = TRUE;
#line 67 "encoding.vala"
	_g_object_unref0 (_tmp5_);
#line 67 "encoding.vala"
	_g_object_unref0 (_tmp0_);
#line 67 "encoding.vala"
	return result;
#line 271 "encoding.c"
}

KkcEncodingConverter*
kkc_encoding_converter_construct (GType object_type,
                                  const gchar* encoding,
                                  GError** error)
{
	KkcEncodingConverter * self = NULL;
	GError* _inner_error0_ = NULL;
#line 70 "encoding.vala"
	g_return_val_if_fail (encoding != NULL, NULL);
#line 71 "encoding.vala"
	self = (KkcEncodingConverter*) g_object_new (object_type, "encoding", encoding, NULL);
#line 72 "encoding.vala"
	g_initable_init ((GInitable*) self, NULL, &_inner_error0_);
#line 72 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "encoding.vala"
		g_propagate_error (error, _inner_error0_);
#line 72 "encoding.vala"
		_g_object_unref0 (self);
#line 72 "encoding.vala"
		return NULL;
#line 295 "encoding.c"
	}
#line 70 "encoding.vala"
	return self;
#line 299 "encoding.c"
}

KkcEncodingConverter*
kkc_encoding_converter_new (const gchar* encoding,
                            GError** error)
{
#line 70 "encoding.vala"
	return kkc_encoding_converter_construct (KKC_TYPE_ENCODING_CONVERTER, encoding, error);
#line 308 "encoding.c"
}

KkcEncodingConverter*
kkc_encoding_converter_construct_from_coding_system (GType object_type,
                                                     const gchar* coding,
                                                     GError** error)
{
	KkcEncodingConverter * self = NULL;
	GError* _inner_error0_ = NULL;
#line 75 "encoding.vala"
	g_return_val_if_fail (coding != NULL, NULL);
#line 320 "encoding.c"
	{
		KkcEncodingConverterEncodingCodingSystemEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 76 "encoding.vala"
		entry_collection = KKC_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE;
#line 76 "encoding.vala"
		entry_collection_length1 = G_N_ELEMENTS (KKC_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE);
#line 76 "encoding.vala"
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
#line 332 "encoding.c"
			KkcEncodingConverterEncodingCodingSystemEntry entry = {0};
#line 76 "encoding.vala"
			entry = entry_collection[entry_it];
#line 336 "encoding.c"
			{
				KkcEncodingConverterEncodingCodingSystemEntry _tmp0_;
				const gchar* _tmp1_;
#line 77 "encoding.vala"
				_tmp0_ = entry;
#line 77 "encoding.vala"
				_tmp1_ = _tmp0_.value;
#line 77 "encoding.vala"
				if (g_strcmp0 (_tmp1_, coding) == 0) {
#line 346 "encoding.c"
					KkcEncodingConverterEncodingCodingSystemEntry _tmp2_;
					const gchar* _tmp3_;
#line 78 "encoding.vala"
					_tmp2_ = entry;
#line 78 "encoding.vala"
					_tmp3_ = _tmp2_.key;
#line 78 "encoding.vala"
					self = (KkcEncodingConverter*) kkc_encoding_converter_construct (object_type, _tmp3_, &_inner_error0_);
#line 78 "encoding.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "encoding.vala"
						g_propagate_error (error, _inner_error0_);
#line 78 "encoding.vala"
						_g_object_unref0 (self);
#line 78 "encoding.vala"
						return NULL;
#line 363 "encoding.c"
					}
#line 79 "encoding.vala"
					return self;
#line 367 "encoding.c"
				}
			}
		}
	}
#line 82 "encoding.vala"
	g_assert_not_reached ();
#line 75 "encoding.vala"
	return self;
#line 376 "encoding.c"
}

KkcEncodingConverter*
kkc_encoding_converter_new_from_coding_system (const gchar* coding,
                                               GError** error)
{
#line 75 "encoding.vala"
	return kkc_encoding_converter_construct_from_coding_system (KKC_TYPE_ENCODING_CONVERTER, coding, error);
#line 385 "encoding.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 422 "encoding.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 428 "encoding.c"
}

static guint8*
_vala_array_dup5 (guint8* self,
                  gssize length)
{
#line 86 "encoding.vala"
	if (length > 0) {
#line 86 "encoding.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 439 "encoding.c"
	}
#line 86 "encoding.vala"
	return NULL;
#line 443 "encoding.c"
}

static gchar*
kkc_encoding_converter_convert (KkcEncodingConverter* self,
                                GCharsetConverter* converter,
                                const gchar* str,
                                GError** error)
{
	guint8* inbuf = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint inbuf_length1;
	gint _inbuf_size_;
	guint8* outbuf = NULL;
	guint8* _tmp4_;
	gint outbuf_length1;
	gint _outbuf_size_;
	GString* builder = NULL;
	GString* _tmp5_;
	gsize total_bytes_read = 0UL;
	GString* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 85 "encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "encoding.vala"
	g_return_val_if_fail (converter != NULL, NULL);
#line 85 "encoding.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 86 "encoding.vala"
	_tmp0_ = string_get_data (str, &_tmp1_);
#line 86 "encoding.vala"
	_tmp0__length1 = _tmp1_;
#line 86 "encoding.vala"
	_tmp2_ = _tmp0_;
#line 86 "encoding.vala"
	_tmp2__length1 = _tmp0__length1;
#line 86 "encoding.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup5 (_tmp2_, _tmp2__length1) : _tmp2_;
#line 86 "encoding.vala"
	_tmp3__length1 = _tmp2__length1;
#line 86 "encoding.vala"
	inbuf = _tmp3_;
#line 86 "encoding.vala"
	inbuf_length1 = _tmp3__length1;
#line 86 "encoding.vala"
	_inbuf_size_ = inbuf_length1;
#line 87 "encoding.vala"
	_tmp4_ = g_new0 (guint8, KKC_ENCODING_CONVERTER_BUFSIZ);
#line 87 "encoding.vala"
	outbuf = _tmp4_;
#line 87 "encoding.vala"
	outbuf_length1 = KKC_ENCODING_CONVERTER_BUFSIZ;
#line 87 "encoding.vala"
	_outbuf_size_ = outbuf_length1;
#line 88 "encoding.vala"
	_tmp5_ = g_string_new ("");
#line 88 "encoding.vala"
	builder = _tmp5_;
#line 89 "encoding.vala"
	total_bytes_read = (gsize) 0;
#line 90 "encoding.vala"
	while (TRUE) {
#line 514 "encoding.c"
		guint8* _tmp6_;
		gint _tmp6__length1;
		gsize bytes_read = 0UL;
		gsize bytes_written = 0UL;
		guint8* _tmp7_;
		gint _tmp7__length1;
		guint8* _tmp8_;
		gint _tmp8__length1;
		guint8* _tmp9_;
		gint _tmp9__length1;
		gsize _tmp10_ = 0UL;
		gsize _tmp11_ = 0UL;
#line 90 "encoding.vala"
		_tmp6_ = inbuf;
#line 90 "encoding.vala"
		_tmp6__length1 = inbuf_length1;
#line 90 "encoding.vala"
		if (!(total_bytes_read < ((gsize) _tmp6__length1))) {
#line 90 "encoding.vala"
			break;
#line 535 "encoding.c"
		}
#line 97 "encoding.vala"
		_tmp7_ = inbuf;
#line 97 "encoding.vala"
		_tmp7__length1 = inbuf_length1;
#line 97 "encoding.vala"
		_tmp8_ = inbuf;
#line 97 "encoding.vala"
		_tmp8__length1 = inbuf_length1;
#line 97 "encoding.vala"
		_tmp9_ = outbuf;
#line 97 "encoding.vala"
		_tmp9__length1 = outbuf_length1;
#line 97 "encoding.vala"
		g_converter_convert ((GConverter*) converter, _tmp7_ + ((gint) total_bytes_read), (gsize) (_tmp8__length1 - ((gint) total_bytes_read)), _tmp9_, (gsize) _tmp9__length1, G_CONVERTER_INPUT_AT_END, &_tmp10_, &_tmp11_, &_inner_error0_);
#line 97 "encoding.vala"
		bytes_read = _tmp10_;
#line 97 "encoding.vala"
		bytes_written = _tmp11_;
#line 97 "encoding.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "encoding.vala"
			g_propagate_error (error, _inner_error0_);
#line 97 "encoding.vala"
			_g_string_free0 (builder);
#line 97 "encoding.vala"
			outbuf = (g_free (outbuf), NULL);
#line 97 "encoding.vala"
			inbuf = (g_free (inbuf), NULL);
#line 97 "encoding.vala"
			return NULL;
#line 567 "encoding.c"
		}
		{
			gint i = 0;
#line 102 "encoding.vala"
			i = 0;
#line 573 "encoding.c"
			{
				gboolean _tmp12_ = FALSE;
#line 102 "encoding.vala"
				_tmp12_ = TRUE;
#line 102 "encoding.vala"
				while (TRUE) {
#line 580 "encoding.c"
					GString* _tmp14_;
					guint8* _tmp15_;
					gint _tmp15__length1;
					guint8 _tmp16_;
#line 102 "encoding.vala"
					if (!_tmp12_) {
#line 587 "encoding.c"
						gint _tmp13_;
#line 102 "encoding.vala"
						_tmp13_ = i;
#line 102 "encoding.vala"
						i = _tmp13_ + 1;
#line 593 "encoding.c"
					}
#line 102 "encoding.vala"
					_tmp12_ = FALSE;
#line 102 "encoding.vala"
					if (!(((gsize) i) < bytes_written)) {
#line 102 "encoding.vala"
						break;
#line 601 "encoding.c"
					}
#line 103 "encoding.vala"
					_tmp14_ = builder;
#line 103 "encoding.vala"
					_tmp15_ = outbuf;
#line 103 "encoding.vala"
					_tmp15__length1 = outbuf_length1;
#line 103 "encoding.vala"
					_tmp16_ = _tmp15_[i];
#line 103 "encoding.vala"
					g_string_append_c (_tmp14_, (gchar) _tmp16_);
#line 613 "encoding.c"
				}
			}
		}
#line 104 "encoding.vala"
		total_bytes_read += bytes_read;
#line 619 "encoding.c"
	}
#line 106 "encoding.vala"
	_tmp17_ = builder;
#line 106 "encoding.vala"
	_tmp18_ = _tmp17_->str;
#line 106 "encoding.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 106 "encoding.vala"
	result = _tmp19_;
#line 106 "encoding.vala"
	_g_string_free0 (builder);
#line 106 "encoding.vala"
	outbuf = (g_free (outbuf), NULL);
#line 106 "encoding.vala"
	inbuf = (g_free (inbuf), NULL);
#line 106 "encoding.vala"
	return result;
#line 637 "encoding.c"
}

gchar*
kkc_encoding_converter_encode (KkcEncodingConverter* self,
                               const gchar* internal_str,
                               GError** error)
{
	gchar* _tmp0_ = NULL;
	GCharsetConverter* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 109 "encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 109 "encoding.vala"
	g_return_val_if_fail (internal_str != NULL, NULL);
#line 110 "encoding.vala"
	_tmp1_ = self->priv->encoder;
#line 110 "encoding.vala"
	_tmp2_ = kkc_encoding_converter_convert (self, _tmp1_, internal_str, &_inner_error0_);
#line 110 "encoding.vala"
	_tmp0_ = _tmp2_;
#line 110 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 110 "encoding.vala"
		g_propagate_error (error, _inner_error0_);
#line 110 "encoding.vala"
		return NULL;
#line 667 "encoding.c"
	}
#line 110 "encoding.vala"
	_tmp3_ = _tmp0_;
#line 110 "encoding.vala"
	_tmp0_ = NULL;
#line 110 "encoding.vala"
	result = _tmp3_;
#line 110 "encoding.vala"
	_g_free0 (_tmp0_);
#line 110 "encoding.vala"
	return result;
#line 679 "encoding.c"
}

gchar*
kkc_encoding_converter_decode (KkcEncodingConverter* self,
                               const gchar* external_str,
                               GError** error)
{
	gchar* _tmp0_ = NULL;
	GCharsetConverter* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 113 "encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "encoding.vala"
	g_return_val_if_fail (external_str != NULL, NULL);
#line 114 "encoding.vala"
	_tmp1_ = self->priv->decoder;
#line 114 "encoding.vala"
	_tmp2_ = kkc_encoding_converter_convert (self, _tmp1_, external_str, &_inner_error0_);
#line 114 "encoding.vala"
	_tmp0_ = _tmp2_;
#line 114 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "encoding.vala"
		g_propagate_error (error, _inner_error0_);
#line 114 "encoding.vala"
		return NULL;
#line 709 "encoding.c"
	}
#line 114 "encoding.vala"
	_tmp3_ = _tmp0_;
#line 114 "encoding.vala"
	_tmp0_ = NULL;
#line 114 "encoding.vala"
	result = _tmp3_;
#line 114 "encoding.vala"
	_g_free0 (_tmp0_);
#line 114 "encoding.vala"
	return result;
#line 721 "encoding.c"
}

const gchar*
kkc_encoding_converter_get_encoding (KkcEncodingConverter* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 59 "encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "encoding.vala"
	_tmp0_ = self->priv->_encoding;
#line 59 "encoding.vala"
	result = _tmp0_;
#line 59 "encoding.vala"
	return result;
#line 737 "encoding.c"
}

void
kkc_encoding_converter_set_encoding (KkcEncodingConverter* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 59 "encoding.vala"
	g_return_if_fail (self != NULL);
#line 59 "encoding.vala"
	old_value = kkc_encoding_converter_get_encoding (self);
#line 59 "encoding.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 751 "encoding.c"
		gchar* _tmp0_;
#line 59 "encoding.vala"
		_tmp0_ = g_strdup (value);
#line 59 "encoding.vala"
		_g_free0 (self->priv->_encoding);
#line 59 "encoding.vala"
		self->priv->_encoding = _tmp0_;
#line 59 "encoding.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_encoding_converter_properties[KKC_ENCODING_CONVERTER_ENCODING_PROPERTY]);
#line 761 "encoding.c"
	}
}

static void
kkc_encoding_converter_encoding_coding_system_entry_copy (const KkcEncodingConverterEncodingCodingSystemEntry* self,
                                                          KkcEncodingConverterEncodingCodingSystemEntry* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 25 "encoding.vala"
	_tmp0_ = (*self).key;
#line 25 "encoding.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 25 "encoding.vala"
	_g_free0 ((*dest).key);
#line 25 "encoding.vala"
	(*dest).key = _tmp1_;
#line 25 "encoding.vala"
	_tmp2_ = (*self).value;
#line 25 "encoding.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 25 "encoding.vala"
	_g_free0 ((*dest).value);
#line 25 "encoding.vala"
	(*dest).value = _tmp3_;
#line 789 "encoding.c"
}

static void
kkc_encoding_converter_encoding_coding_system_entry_destroy (KkcEncodingConverterEncodingCodingSystemEntry* self)
{
#line 26 "encoding.vala"
	_g_free0 ((*self).key);
#line 27 "encoding.vala"
	_g_free0 ((*self).value);
#line 799 "encoding.c"
}

static KkcEncodingConverterEncodingCodingSystemEntry*
kkc_encoding_converter_encoding_coding_system_entry_dup (const KkcEncodingConverterEncodingCodingSystemEntry* self)
{
	KkcEncodingConverterEncodingCodingSystemEntry* dup;
#line 25 "encoding.vala"
	dup = g_new0 (KkcEncodingConverterEncodingCodingSystemEntry, 1);
#line 25 "encoding.vala"
	kkc_encoding_converter_encoding_coding_system_entry_copy (self, dup);
#line 25 "encoding.vala"
	return dup;
#line 812 "encoding.c"
}

static void
kkc_encoding_converter_encoding_coding_system_entry_free (KkcEncodingConverterEncodingCodingSystemEntry* self)
{
#line 25 "encoding.vala"
	kkc_encoding_converter_encoding_coding_system_entry_destroy (self);
#line 25 "encoding.vala"
	g_free (self);
#line 822 "encoding.c"
}

static GType
kkc_encoding_converter_encoding_coding_system_entry_get_type_once (void)
{
	GType kkc_encoding_converter_encoding_coding_system_entry_type_id;
	kkc_encoding_converter_encoding_coding_system_entry_type_id = g_boxed_type_register_static ("KkcEncodingConverterEncodingCodingSystemEntry", (GBoxedCopyFunc) kkc_encoding_converter_encoding_coding_system_entry_dup, (GBoxedFreeFunc) kkc_encoding_converter_encoding_coding_system_entry_free);
	return kkc_encoding_converter_encoding_coding_system_entry_type_id;
}

static GType
kkc_encoding_converter_encoding_coding_system_entry_get_type (void)
{
	static volatile gsize kkc_encoding_converter_encoding_coding_system_entry_type_id__once = 0;
	if (g_once_init_enter (&kkc_encoding_converter_encoding_coding_system_entry_type_id__once)) {
		GType kkc_encoding_converter_encoding_coding_system_entry_type_id;
		kkc_encoding_converter_encoding_coding_system_entry_type_id = kkc_encoding_converter_encoding_coding_system_entry_get_type_once ();
		g_once_init_leave (&kkc_encoding_converter_encoding_coding_system_entry_type_id__once, kkc_encoding_converter_encoding_coding_system_entry_type_id);
	}
	return kkc_encoding_converter_encoding_coding_system_entry_type_id__once;
}

static void
kkc_encoding_converter_class_init (KkcEncodingConverterClass * klass,
                                   gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 21 "encoding.vala"
	kkc_encoding_converter_parent_class = g_type_class_peek_parent (klass);
#line 21 "encoding.vala"
	g_type_class_adjust_private_offset (klass, &KkcEncodingConverter_private_offset);
#line 21 "encoding.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_kkc_encoding_converter_get_property;
#line 21 "encoding.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_kkc_encoding_converter_set_property;
#line 21 "encoding.vala"
	G_OBJECT_CLASS (klass)->finalize = kkc_encoding_converter_finalize;
#line 21 "encoding.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_ENCODING_CONVERTER_ENCODING_PROPERTY, kkc_encoding_converter_properties[KKC_ENCODING_CONVERTER_ENCODING_PROPERTY] = g_param_spec_string ("encoding", "encoding", "encoding", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 862 "encoding.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 44 "encoding.vala"
		_tmp1_ = g_regex_new ("-\\*-.*[ \t]coding:[ \t]*([^ \t;]+?)[ \t;].*-\\*-", 0, 0, &_inner_error0_);
#line 44 "encoding.vala"
		_tmp0_ = _tmp1_;
#line 44 "encoding.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 44 "encoding.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 875 "encoding.c"
				goto __catch0_g_regex_error;
			}
#line 44 "encoding.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 44 "encoding.vala"
			g_clear_error (&_inner_error0_);
#line 882 "encoding.c"
		}
#line 44 "encoding.vala"
		_tmp2_ = _tmp0_;
#line 44 "encoding.vala"
		_tmp0_ = NULL;
#line 44 "encoding.vala"
		_g_regex_unref0 (kkc_encoding_converter_coding_cookie_regex);
#line 44 "encoding.vala"
		kkc_encoding_converter_coding_cookie_regex = _tmp2_;
#line 43 "encoding.vala"
		_g_regex_unref0 (_tmp0_);
#line 894 "encoding.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 43 "encoding.vala"
		g_clear_error (&_inner_error0_);
#line 47 "encoding.vala"
		g_assert_not_reached ();
#line 903 "encoding.c"
	}
	__finally0:
#line 43 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "encoding.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "encoding.vala"
		g_clear_error (&_inner_error0_);
#line 912 "encoding.c"
	}
}

static void
kkc_encoding_converter_g_initable_interface_init (GInitableIface * iface,
                                                  gpointer iface_data)
{
#line 21 "encoding.vala"
	kkc_encoding_converter_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 21 "encoding.vala"
	iface->init = (gboolean (*) (GInitable*, GCancellable*, GError**)) kkc_encoding_converter_real_init;
#line 924 "encoding.c"
}

static void
kkc_encoding_converter_instance_init (KkcEncodingConverter * self,
                                      gpointer klass)
{
#line 21 "encoding.vala"
	self->priv = kkc_encoding_converter_get_instance_private (self);
#line 933 "encoding.c"
}

static void
kkc_encoding_converter_finalize (GObject * obj)
{
	KkcEncodingConverter * self;
#line 21 "encoding.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_ENCODING_CONVERTER, KkcEncodingConverter);
#line 59 "encoding.vala"
	_g_free0 (self->priv->_encoding);
#line 61 "encoding.vala"
	_g_object_unref0 (self->priv->encoder);
#line 62 "encoding.vala"
	_g_object_unref0 (self->priv->decoder);
#line 21 "encoding.vala"
	G_OBJECT_CLASS (kkc_encoding_converter_parent_class)->finalize (obj);
#line 950 "encoding.c"
}

static GType
kkc_encoding_converter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KkcEncodingConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_encoding_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcEncodingConverter), 0, (GInstanceInitFunc) kkc_encoding_converter_instance_init, NULL };
	static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) kkc_encoding_converter_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType kkc_encoding_converter_type_id;
	kkc_encoding_converter_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcEncodingConverter", &g_define_type_info, 0);
	g_type_add_interface_static (kkc_encoding_converter_type_id, g_initable_get_type (), &g_initable_info);
	KkcEncodingConverter_private_offset = g_type_add_instance_private (kkc_encoding_converter_type_id, sizeof (KkcEncodingConverterPrivate));
	return kkc_encoding_converter_type_id;
}

GType
kkc_encoding_converter_get_type (void)
{
	static volatile gsize kkc_encoding_converter_type_id__once = 0;
	if (g_once_init_enter (&kkc_encoding_converter_type_id__once)) {
		GType kkc_encoding_converter_type_id;
		kkc_encoding_converter_type_id = kkc_encoding_converter_get_type_once ();
		g_once_init_leave (&kkc_encoding_converter_type_id__once, kkc_encoding_converter_type_id);
	}
	return kkc_encoding_converter_type_id__once;
}

static void
_vala_kkc_encoding_converter_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	KkcEncodingConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_ENCODING_CONVERTER, KkcEncodingConverter);
#line 21 "encoding.vala"
	switch (property_id) {
#line 21 "encoding.vala"
		case KKC_ENCODING_CONVERTER_ENCODING_PROPERTY:
#line 21 "encoding.vala"
		g_value_set_string (value, kkc_encoding_converter_get_encoding (self));
#line 21 "encoding.vala"
		break;
#line 993 "encoding.c"
		default:
#line 21 "encoding.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "encoding.vala"
		break;
#line 999 "encoding.c"
	}
}

static void
_vala_kkc_encoding_converter_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	KkcEncodingConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_ENCODING_CONVERTER, KkcEncodingConverter);
#line 21 "encoding.vala"
	switch (property_id) {
#line 21 "encoding.vala"
		case KKC_ENCODING_CONVERTER_ENCODING_PROPERTY:
#line 21 "encoding.vala"
		kkc_encoding_converter_set_encoding (self, g_value_get_string (value));
#line 21 "encoding.vala"
		break;
#line 1019 "encoding.c"
		default:
#line 21 "encoding.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "encoding.vala"
		break;
#line 1025 "encoding.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 148 "rule.vala"
	if (mem && byte_size != 0) {
#line 148 "rule.vala"
		new_mem = g_malloc (byte_size);
#line 148 "rule.vala"
		memcpy (new_mem, mem, byte_size);
#line 1040 "encoding.c"
	} else {
#line 148 "rule.vala"
		new_mem = NULL;
#line 1044 "encoding.c"
	}
#line 148 "rule.vala"
	return new_mem;
#line 1048 "encoding.c"
}

