/* metadata-file.c generated by valac 0.56.17, the Vala compiler
 * generated from metadata-file.vala, do not modify */

/*
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libkkc/libkkc.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <json-glib/json-glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <config.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	KKC_METADATA_FILE_0_PROPERTY,
	KKC_METADATA_FILE_NAME_PROPERTY,
	KKC_METADATA_FILE_LABEL_PROPERTY,
	KKC_METADATA_FILE_DESCRIPTION_PROPERTY,
	KKC_METADATA_FILE_FILENAME_PROPERTY,
	KKC_METADATA_FILE_NUM_PROPERTIES
};
static GParamSpec* kkc_metadata_file_properties[KKC_METADATA_FILE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

struct _KkcMetadataFilePrivate {
	gchar* _name;
	gchar* _label;
	gchar* _description;
	gchar* _filename;
};

static gint KkcMetadataFile_private_offset;
static gpointer kkc_metadata_file_parent_class = NULL;
static GInitableIface * kkc_metadata_file_g_initable_parent_iface = NULL;

static gboolean kkc_metadata_file_real_parse (KkcMetadataFile* self,
                                       JsonObject* object,
                                       GError** error);
static gboolean kkc_metadata_file_real_init (GInitable* base,
                                      GCancellable* cancellable,
                                      GError** error);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static void kkc_metadata_file_finalize (GObject * obj);
static GType kkc_metadata_file_get_type_once (void);
static void _vala_kkc_metadata_file_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_kkc_metadata_file_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

GQuark
kkc_metadata_format_error_quark (void)
{
	return g_quark_from_static_string ("kkc-metadata-format-error-quark");
}

static GType
kkc_metadata_format_error_get_type_once (void)
{
	static const GEnumValue values[] = {{KKC_METADATA_FORMAT_ERROR_MISSING_FIELD, "KKC_METADATA_FORMAT_ERROR_MISSING_FIELD", "missing-field"}, {KKC_METADATA_FORMAT_ERROR_INVALID_FIELD, "KKC_METADATA_FORMAT_ERROR_INVALID_FIELD", "invalid-field"}, {0, NULL, NULL}};
	GType kkc_metadata_format_error_type_id;
	kkc_metadata_format_error_type_id = g_enum_register_static ("KkcMetadataFormatError", values);
	return kkc_metadata_format_error_type_id;
}

GType
kkc_metadata_format_error_get_type (void)
{
	static volatile gsize kkc_metadata_format_error_type_id__once = 0;
	if (g_once_init_enter (&kkc_metadata_format_error_type_id__once)) {
		GType kkc_metadata_format_error_type_id;
		kkc_metadata_format_error_type_id = kkc_metadata_format_error_get_type_once ();
		g_once_init_leave (&kkc_metadata_format_error_type_id__once, kkc_metadata_format_error_type_id);
	}
	return kkc_metadata_format_error_type_id__once;
}

static inline gpointer
kkc_metadata_file_get_instance_private (KkcMetadataFile* self)
{
	return G_STRUCT_MEMBER_P (self, KkcMetadataFile_private_offset);
}

KkcMetadataFile*
kkc_metadata_file_construct (GType object_type,
                             const gchar* name,
                             const gchar* filename,
                             GError** error)
{
	KkcMetadataFile * self = NULL;
	GError* _inner_error0_ = NULL;
#line 46 "metadata-file.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 46 "metadata-file.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 47 "metadata-file.vala"
	self = (KkcMetadataFile*) g_object_new (object_type, "name", name, "filename", filename, NULL);
#line 48 "metadata-file.vala"
	g_initable_init ((GInitable*) self, NULL, &_inner_error0_);
#line 48 "metadata-file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "metadata-file.vala"
		g_propagate_error (error, _inner_error0_);
#line 48 "metadata-file.vala"
		_g_object_unref0 (self);
#line 48 "metadata-file.vala"
		return NULL;
#line 143 "metadata-file.c"
	}
#line 46 "metadata-file.vala"
	return self;
#line 147 "metadata-file.c"
}

static gboolean
kkc_metadata_file_real_parse (KkcMetadataFile* self,
                              JsonObject* object,
                              GError** error)
{
	gboolean _tmp0_ = FALSE;
#line 51 "metadata-file.vala"
	g_critical ("Type `%s' does not implement abstract method `kkc_metadata_file_parse'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 51 "metadata-file.vala"
	return _tmp0_;
#line 160 "metadata-file.c"
}

gboolean
kkc_metadata_file_parse (KkcMetadataFile* self,
                         JsonObject* object,
                         GError** error)
{
	KkcMetadataFileClass* _klass_;
#line 51 "metadata-file.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "metadata-file.vala"
	_klass_ = KKC_METADATA_FILE_GET_CLASS (self);
#line 51 "metadata-file.vala"
	if (_klass_->parse) {
#line 51 "metadata-file.vala"
		return _klass_->parse (self, object, error);
#line 177 "metadata-file.c"
	}
#line 51 "metadata-file.vala"
	return FALSE;
#line 181 "metadata-file.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 57 "metadata-file.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 189 "metadata-file.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 57 "metadata-file.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 197 "metadata-file.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 59 "metadata-file.vala"
	g_boxed_free (json_node_get_type (), self);
#line 205 "metadata-file.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 62 "metadata-file.vala"
	return self ? json_object_ref (self) : NULL;
#line 213 "metadata-file.c"
}

static gboolean
kkc_metadata_file_real_init (GInitable* base,
                             GCancellable* cancellable,
                             GError** error)
{
	KkcMetadataFile * self;
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	JsonParser* _tmp1_;
	const gchar* _tmp2_;
	JsonNode* root = NULL;
	JsonParser* _tmp4_;
	JsonNode* _tmp5_;
	JsonNode* _tmp6_;
	JsonNode* _tmp7_;
	JsonObject* object = NULL;
	JsonNode* _tmp10_;
	JsonObject* _tmp11_;
	JsonObject* _tmp12_;
	JsonNode* member = NULL;
	JsonObject* _tmp13_;
	JsonObject* _tmp16_;
	JsonNode* _tmp17_;
	JsonNode* _tmp18_;
	gchar* name = NULL;
	JsonNode* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	JsonObject* _tmp22_;
	JsonObject* _tmp25_;
	JsonNode* _tmp26_;
	JsonNode* _tmp27_;
	gchar* description = NULL;
	JsonNode* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	JsonObject* _tmp31_;
	gchar* label = NULL;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp38_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 53 "metadata-file.vala"
	self = (KkcMetadataFile*) base;
#line 54 "metadata-file.vala"
	_tmp0_ = json_parser_new ();
#line 54 "metadata-file.vala"
	parser = _tmp0_;
#line 55 "metadata-file.vala"
	_tmp1_ = parser;
#line 55 "metadata-file.vala"
	_tmp2_ = self->priv->_filename;
#line 55 "metadata-file.vala"
	json_parser_load_from_file (_tmp1_, _tmp2_, &_inner_error0_);
#line 55 "metadata-file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 276 "metadata-file.c"
		gboolean _tmp3_ = FALSE;
#line 55 "metadata-file.vala"
		g_propagate_error (error, _inner_error0_);
#line 55 "metadata-file.vala"
		_g_object_unref0 (parser);
#line 55 "metadata-file.vala"
		return _tmp3_;
#line 284 "metadata-file.c"
	}
#line 57 "metadata-file.vala"
	_tmp4_ = parser;
#line 57 "metadata-file.vala"
	_tmp5_ = json_parser_get_root (_tmp4_);
#line 57 "metadata-file.vala"
	_tmp6_ = __vala_JsonNode_copy0 (_tmp5_);
#line 57 "metadata-file.vala"
	root = _tmp6_;
#line 58 "metadata-file.vala"
	_tmp7_ = root;
#line 58 "metadata-file.vala"
	if (json_node_get_node_type (_tmp7_) != JSON_NODE_OBJECT) {
#line 298 "metadata-file.c"
		GError* _tmp8_;
		gboolean _tmp9_ = FALSE;
#line 59 "metadata-file.vala"
		_tmp8_ = g_error_new_literal (KKC_METADATA_FORMAT_ERROR, KKC_METADATA_FORMAT_ERROR_MISSING_FIELD, "metadata must be a JSON object");
#line 59 "metadata-file.vala"
		_inner_error0_ = _tmp8_;
#line 59 "metadata-file.vala"
		g_propagate_error (error, _inner_error0_);
#line 59 "metadata-file.vala"
		__vala_JsonNode_free0 (root);
#line 59 "metadata-file.vala"
		_g_object_unref0 (parser);
#line 59 "metadata-file.vala"
		return _tmp9_;
#line 313 "metadata-file.c"
	}
#line 62 "metadata-file.vala"
	_tmp10_ = root;
#line 62 "metadata-file.vala"
	_tmp11_ = json_node_get_object (_tmp10_);
#line 62 "metadata-file.vala"
	_tmp12_ = _json_object_ref0 (_tmp11_);
#line 62 "metadata-file.vala"
	object = _tmp12_;
#line 65 "metadata-file.vala"
	_tmp13_ = object;
#line 65 "metadata-file.vala"
	if (!json_object_has_member (_tmp13_, "name")) {
#line 327 "metadata-file.c"
		GError* _tmp14_;
		gboolean _tmp15_ = FALSE;
#line 66 "metadata-file.vala"
		_tmp14_ = g_error_new_literal (KKC_METADATA_FORMAT_ERROR, KKC_METADATA_FORMAT_ERROR_MISSING_FIELD, "name is not defined in metadata");
#line 66 "metadata-file.vala"
		_inner_error0_ = _tmp14_;
#line 66 "metadata-file.vala"
		g_propagate_error (error, _inner_error0_);
#line 66 "metadata-file.vala"
		__vala_JsonNode_free0 (member);
#line 66 "metadata-file.vala"
		_json_object_unref0 (object);
#line 66 "metadata-file.vala"
		__vala_JsonNode_free0 (root);
#line 66 "metadata-file.vala"
		_g_object_unref0 (parser);
#line 66 "metadata-file.vala"
		return _tmp15_;
#line 346 "metadata-file.c"
	}
#line 69 "metadata-file.vala"
	_tmp16_ = object;
#line 69 "metadata-file.vala"
	_tmp17_ = json_object_get_member (_tmp16_, "name");
#line 69 "metadata-file.vala"
	_tmp18_ = __vala_JsonNode_copy0 (_tmp17_);
#line 69 "metadata-file.vala"
	__vala_JsonNode_free0 (member);
#line 69 "metadata-file.vala"
	member = _tmp18_;
#line 70 "metadata-file.vala"
	_tmp19_ = member;
#line 70 "metadata-file.vala"
	_tmp20_ = json_node_get_string (_tmp19_);
#line 70 "metadata-file.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 70 "metadata-file.vala"
	name = _tmp21_;
#line 72 "metadata-file.vala"
	_tmp22_ = object;
#line 72 "metadata-file.vala"
	if (!json_object_has_member (_tmp22_, "description")) {
#line 370 "metadata-file.c"
		GError* _tmp23_;
		gboolean _tmp24_ = FALSE;
#line 73 "metadata-file.vala"
		_tmp23_ = g_error_new_literal (KKC_METADATA_FORMAT_ERROR, KKC_METADATA_FORMAT_ERROR_MISSING_FIELD, "description is not defined in metadata");
#line 73 "metadata-file.vala"
		_inner_error0_ = _tmp23_;
#line 73 "metadata-file.vala"
		g_propagate_error (error, _inner_error0_);
#line 73 "metadata-file.vala"
		_g_free0 (name);
#line 73 "metadata-file.vala"
		__vala_JsonNode_free0 (member);
#line 73 "metadata-file.vala"
		_json_object_unref0 (object);
#line 73 "metadata-file.vala"
		__vala_JsonNode_free0 (root);
#line 73 "metadata-file.vala"
		_g_object_unref0 (parser);
#line 73 "metadata-file.vala"
		return _tmp24_;
#line 391 "metadata-file.c"
	}
#line 76 "metadata-file.vala"
	_tmp25_ = object;
#line 76 "metadata-file.vala"
	_tmp26_ = json_object_get_member (_tmp25_, "description");
#line 76 "metadata-file.vala"
	_tmp27_ = __vala_JsonNode_copy0 (_tmp26_);
#line 76 "metadata-file.vala"
	__vala_JsonNode_free0 (member);
#line 76 "metadata-file.vala"
	member = _tmp27_;
#line 77 "metadata-file.vala"
	_tmp28_ = member;
#line 77 "metadata-file.vala"
	_tmp29_ = json_node_get_string (_tmp28_);
#line 77 "metadata-file.vala"
	_tmp30_ = g_strdup (_tmp29_);
#line 77 "metadata-file.vala"
	description = _tmp30_;
#line 79 "metadata-file.vala"
	_tmp31_ = object;
#line 79 "metadata-file.vala"
	kkc_metadata_file_parse (self, _tmp31_, &_inner_error0_);
#line 79 "metadata-file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 417 "metadata-file.c"
		gboolean _tmp32_ = FALSE;
#line 79 "metadata-file.vala"
		g_propagate_error (error, _inner_error0_);
#line 79 "metadata-file.vala"
		_g_free0 (description);
#line 79 "metadata-file.vala"
		_g_free0 (name);
#line 79 "metadata-file.vala"
		__vala_JsonNode_free0 (member);
#line 79 "metadata-file.vala"
		_json_object_unref0 (object);
#line 79 "metadata-file.vala"
		__vala_JsonNode_free0 (root);
#line 79 "metadata-file.vala"
		_g_object_unref0 (parser);
#line 79 "metadata-file.vala"
		return _tmp32_;
#line 435 "metadata-file.c"
	}
#line 81 "metadata-file.vala"
	_tmp33_ = name;
#line 81 "metadata-file.vala"
	_tmp34_ = g_strdup (_tmp33_);
#line 81 "metadata-file.vala"
	label = _tmp34_;
#line 82 "metadata-file.vala"
	_tmp35_ = label;
#line 82 "metadata-file.vala"
	if (g_strcmp0 (_tmp35_, "") != 0) {
#line 447 "metadata-file.c"
		const gchar* _tmp36_;
		gchar* _tmp37_;
#line 83 "metadata-file.vala"
		_tmp36_ = label;
#line 83 "metadata-file.vala"
		_tmp37_ = g_strdup (g_dgettext (GETTEXT_PACKAGE, _tmp36_));
#line 83 "metadata-file.vala"
		_g_free0 (label);
#line 83 "metadata-file.vala"
		label = _tmp37_;
#line 458 "metadata-file.c"
	}
#line 84 "metadata-file.vala"
	_tmp38_ = description;
#line 84 "metadata-file.vala"
	if (g_strcmp0 (_tmp38_, "") != 0) {
#line 464 "metadata-file.c"
		const gchar* _tmp39_;
		gchar* _tmp40_;
#line 85 "metadata-file.vala"
		_tmp39_ = description;
#line 85 "metadata-file.vala"
		_tmp40_ = g_strdup (g_dgettext (GETTEXT_PACKAGE, _tmp39_));
#line 85 "metadata-file.vala"
		_g_free0 (description);
#line 85 "metadata-file.vala"
		description = _tmp40_;
#line 475 "metadata-file.c"
	}
#line 87 "metadata-file.vala"
	_tmp41_ = label;
#line 87 "metadata-file.vala"
	kkc_metadata_file_set_label (self, _tmp41_);
#line 88 "metadata-file.vala"
	_tmp42_ = description;
#line 88 "metadata-file.vala"
	kkc_metadata_file_set_description (self, _tmp42_);
#line 90 "metadata-file.vala"
	result = TRUE;
#line 90 "metadata-file.vala"
	_g_free0 (label);
#line 90 "metadata-file.vala"
	_g_free0 (description);
#line 90 "metadata-file.vala"
	_g_free0 (name);
#line 90 "metadata-file.vala"
	__vala_JsonNode_free0 (member);
#line 90 "metadata-file.vala"
	_json_object_unref0 (object);
#line 90 "metadata-file.vala"
	__vala_JsonNode_free0 (root);
#line 90 "metadata-file.vala"
	_g_object_unref0 (parser);
#line 90 "metadata-file.vala"
	return result;
#line 503 "metadata-file.c"
}

const gchar*
kkc_metadata_file_get_name (KkcMetadataFile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "metadata-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "metadata-file.vala"
	_tmp0_ = self->priv->_name;
#line 29 "metadata-file.vala"
	result = _tmp0_;
#line 29 "metadata-file.vala"
	return result;
#line 519 "metadata-file.c"
}

void
kkc_metadata_file_set_name (KkcMetadataFile* self,
                            const gchar* value)
{
	gchar* old_value;
#line 29 "metadata-file.vala"
	g_return_if_fail (self != NULL);
#line 29 "metadata-file.vala"
	old_value = kkc_metadata_file_get_name (self);
#line 29 "metadata-file.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 533 "metadata-file.c"
		gchar* _tmp0_;
#line 29 "metadata-file.vala"
		_tmp0_ = g_strdup (value);
#line 29 "metadata-file.vala"
		_g_free0 (self->priv->_name);
#line 29 "metadata-file.vala"
		self->priv->_name = _tmp0_;
#line 29 "metadata-file.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_metadata_file_properties[KKC_METADATA_FILE_NAME_PROPERTY]);
#line 543 "metadata-file.c"
	}
}

const gchar*
kkc_metadata_file_get_label (KkcMetadataFile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "metadata-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "metadata-file.vala"
	_tmp0_ = self->priv->_label;
#line 34 "metadata-file.vala"
	result = _tmp0_;
#line 34 "metadata-file.vala"
	return result;
#line 560 "metadata-file.c"
}

void
kkc_metadata_file_set_label (KkcMetadataFile* self,
                             const gchar* value)
{
	gchar* old_value;
#line 34 "metadata-file.vala"
	g_return_if_fail (self != NULL);
#line 34 "metadata-file.vala"
	old_value = kkc_metadata_file_get_label (self);
#line 34 "metadata-file.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 574 "metadata-file.c"
		gchar* _tmp0_;
#line 34 "metadata-file.vala"
		_tmp0_ = g_strdup (value);
#line 34 "metadata-file.vala"
		_g_free0 (self->priv->_label);
#line 34 "metadata-file.vala"
		self->priv->_label = _tmp0_;
#line 34 "metadata-file.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_metadata_file_properties[KKC_METADATA_FILE_LABEL_PROPERTY]);
#line 584 "metadata-file.c"
	}
}

const gchar*
kkc_metadata_file_get_description (KkcMetadataFile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "metadata-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "metadata-file.vala"
	_tmp0_ = self->priv->_description;
#line 39 "metadata-file.vala"
	result = _tmp0_;
#line 39 "metadata-file.vala"
	return result;
#line 601 "metadata-file.c"
}

void
kkc_metadata_file_set_description (KkcMetadataFile* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 39 "metadata-file.vala"
	g_return_if_fail (self != NULL);
#line 39 "metadata-file.vala"
	old_value = kkc_metadata_file_get_description (self);
#line 39 "metadata-file.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 615 "metadata-file.c"
		gchar* _tmp0_;
#line 39 "metadata-file.vala"
		_tmp0_ = g_strdup (value);
#line 39 "metadata-file.vala"
		_g_free0 (self->priv->_description);
#line 39 "metadata-file.vala"
		self->priv->_description = _tmp0_;
#line 39 "metadata-file.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_metadata_file_properties[KKC_METADATA_FILE_DESCRIPTION_PROPERTY]);
#line 625 "metadata-file.c"
	}
}

const gchar*
kkc_metadata_file_get_filename (KkcMetadataFile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "metadata-file.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "metadata-file.vala"
	_tmp0_ = self->priv->_filename;
#line 44 "metadata-file.vala"
	result = _tmp0_;
#line 44 "metadata-file.vala"
	return result;
#line 642 "metadata-file.c"
}

void
kkc_metadata_file_set_filename (KkcMetadataFile* self,
                                const gchar* value)
{
	gchar* old_value;
#line 44 "metadata-file.vala"
	g_return_if_fail (self != NULL);
#line 44 "metadata-file.vala"
	old_value = kkc_metadata_file_get_filename (self);
#line 44 "metadata-file.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 656 "metadata-file.c"
		gchar* _tmp0_;
#line 44 "metadata-file.vala"
		_tmp0_ = g_strdup (value);
#line 44 "metadata-file.vala"
		_g_free0 (self->priv->_filename);
#line 44 "metadata-file.vala"
		self->priv->_filename = _tmp0_;
#line 44 "metadata-file.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_metadata_file_properties[KKC_METADATA_FILE_FILENAME_PROPERTY]);
#line 666 "metadata-file.c"
	}
}

static void
kkc_metadata_file_class_init (KkcMetadataFileClass * klass,
                              gpointer klass_data)
{
#line 25 "metadata-file.vala"
	kkc_metadata_file_parent_class = g_type_class_peek_parent (klass);
#line 25 "metadata-file.vala"
	g_type_class_adjust_private_offset (klass, &KkcMetadataFile_private_offset);
#line 25 "metadata-file.vala"
	((KkcMetadataFileClass *) klass)->parse = (gboolean (*) (KkcMetadataFile*, JsonObject*, GError**)) kkc_metadata_file_real_parse;
#line 25 "metadata-file.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_kkc_metadata_file_get_property;
#line 25 "metadata-file.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_kkc_metadata_file_set_property;
#line 25 "metadata-file.vala"
	G_OBJECT_CLASS (klass)->finalize = kkc_metadata_file_finalize;
#line 686 "metadata-file.c"
	/**
	         * Name of the metadata.
	         */
#line 25 "metadata-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_METADATA_FILE_NAME_PROPERTY, kkc_metadata_file_properties[KKC_METADATA_FILE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 692 "metadata-file.c"
	/**
	         * Label string of the metadata.
	         */
#line 25 "metadata-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_METADATA_FILE_LABEL_PROPERTY, kkc_metadata_file_properties[KKC_METADATA_FILE_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 698 "metadata-file.c"
	/**
	         * Description of the metadata.
	         */
#line 25 "metadata-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_METADATA_FILE_DESCRIPTION_PROPERTY, kkc_metadata_file_properties[KKC_METADATA_FILE_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 704 "metadata-file.c"
	/**
	         * Location of the metadata file.
	         */
#line 25 "metadata-file.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_METADATA_FILE_FILENAME_PROPERTY, kkc_metadata_file_properties[KKC_METADATA_FILE_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 710 "metadata-file.c"
}

static void
kkc_metadata_file_g_initable_interface_init (GInitableIface * iface,
                                             gpointer iface_data)
{
#line 25 "metadata-file.vala"
	kkc_metadata_file_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "metadata-file.vala"
	iface->init = (gboolean (*) (GInitable*, GCancellable*, GError**)) kkc_metadata_file_real_init;
#line 721 "metadata-file.c"
}

static void
kkc_metadata_file_instance_init (KkcMetadataFile * self,
                                 gpointer klass)
{
#line 25 "metadata-file.vala"
	self->priv = kkc_metadata_file_get_instance_private (self);
#line 730 "metadata-file.c"
}

static void
kkc_metadata_file_finalize (GObject * obj)
{
	KkcMetadataFile * self;
#line 25 "metadata-file.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_METADATA_FILE, KkcMetadataFile);
#line 29 "metadata-file.vala"
	_g_free0 (self->priv->_name);
#line 34 "metadata-file.vala"
	_g_free0 (self->priv->_label);
#line 39 "metadata-file.vala"
	_g_free0 (self->priv->_description);
#line 44 "metadata-file.vala"
	_g_free0 (self->priv->_filename);
#line 25 "metadata-file.vala"
	G_OBJECT_CLASS (kkc_metadata_file_parent_class)->finalize (obj);
#line 749 "metadata-file.c"
}

static GType
kkc_metadata_file_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KkcMetadataFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_metadata_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcMetadataFile), 0, (GInstanceInitFunc) kkc_metadata_file_instance_init, NULL };
	static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) kkc_metadata_file_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType kkc_metadata_file_type_id;
	kkc_metadata_file_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcMetadataFile", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (kkc_metadata_file_type_id, g_initable_get_type (), &g_initable_info);
	KkcMetadataFile_private_offset = g_type_add_instance_private (kkc_metadata_file_type_id, sizeof (KkcMetadataFilePrivate));
	return kkc_metadata_file_type_id;
}

GType
kkc_metadata_file_get_type (void)
{
	static volatile gsize kkc_metadata_file_type_id__once = 0;
	if (g_once_init_enter (&kkc_metadata_file_type_id__once)) {
		GType kkc_metadata_file_type_id;
		kkc_metadata_file_type_id = kkc_metadata_file_get_type_once ();
		g_once_init_leave (&kkc_metadata_file_type_id__once, kkc_metadata_file_type_id);
	}
	return kkc_metadata_file_type_id__once;
}

static void
_vala_kkc_metadata_file_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	KkcMetadataFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_METADATA_FILE, KkcMetadataFile);
#line 25 "metadata-file.vala"
	switch (property_id) {
#line 25 "metadata-file.vala"
		case KKC_METADATA_FILE_NAME_PROPERTY:
#line 25 "metadata-file.vala"
		g_value_set_string (value, kkc_metadata_file_get_name (self));
#line 25 "metadata-file.vala"
		break;
#line 25 "metadata-file.vala"
		case KKC_METADATA_FILE_LABEL_PROPERTY:
#line 25 "metadata-file.vala"
		g_value_set_string (value, kkc_metadata_file_get_label (self));
#line 25 "metadata-file.vala"
		break;
#line 25 "metadata-file.vala"
		case KKC_METADATA_FILE_DESCRIPTION_PROPERTY:
#line 25 "metadata-file.vala"
		g_value_set_string (value, kkc_metadata_file_get_description (self));
#line 25 "metadata-file.vala"
		break;
#line 25 "metadata-file.vala"
		case KKC_METADATA_FILE_FILENAME_PROPERTY:
#line 25 "metadata-file.vala"
		g_value_set_string (value, kkc_metadata_file_get_filename (self));
#line 25 "metadata-file.vala"
		break;
#line 810 "metadata-file.c"
		default:
#line 25 "metadata-file.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "metadata-file.vala"
		break;
#line 816 "metadata-file.c"
	}
}

static void
_vala_kkc_metadata_file_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	KkcMetadataFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_METADATA_FILE, KkcMetadataFile);
#line 25 "metadata-file.vala"
	switch (property_id) {
#line 25 "metadata-file.vala"
		case KKC_METADATA_FILE_NAME_PROPERTY:
#line 25 "metadata-file.vala"
		kkc_metadata_file_set_name (self, g_value_get_string (value));
#line 25 "metadata-file.vala"
		break;
#line 25 "metadata-file.vala"
		case KKC_METADATA_FILE_LABEL_PROPERTY:
#line 25 "metadata-file.vala"
		kkc_metadata_file_set_label (self, g_value_get_string (value));
#line 25 "metadata-file.vala"
		break;
#line 25 "metadata-file.vala"
		case KKC_METADATA_FILE_DESCRIPTION_PROPERTY:
#line 25 "metadata-file.vala"
		kkc_metadata_file_set_description (self, g_value_get_string (value));
#line 25 "metadata-file.vala"
		break;
#line 25 "metadata-file.vala"
		case KKC_METADATA_FILE_FILENAME_PROPERTY:
#line 25 "metadata-file.vala"
		kkc_metadata_file_set_filename (self, g_value_get_string (value));
#line 25 "metadata-file.vala"
		break;
#line 854 "metadata-file.c"
		default:
#line 25 "metadata-file.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "metadata-file.vala"
		break;
#line 860 "metadata-file.c"
	}
}

