/* system-segment-dictionary.c generated by valac 0.56.17, the Vala compiler
 * generated from system-segment-dictionary.vala, do not modify */

/*
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libkkc/libkkc.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define KKC_TYPE_ENCODING_CONVERTER (kkc_encoding_converter_get_type ())
#define KKC_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KKC_TYPE_ENCODING_CONVERTER, KkcEncodingConverter))
#define KKC_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KKC_TYPE_ENCODING_CONVERTER, KkcEncodingConverterClass))
#define KKC_IS_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KKC_TYPE_ENCODING_CONVERTER))
#define KKC_IS_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KKC_TYPE_ENCODING_CONVERTER))
#define KKC_ENCODING_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KKC_TYPE_ENCODING_CONVERTER, KkcEncodingConverterClass))

typedef struct _KkcEncodingConverter KkcEncodingConverter;
typedef struct _KkcEncodingConverterClass KkcEncodingConverterClass;
enum  {
	KKC_SYSTEM_SEGMENT_DICTIONARY_0_PROPERTY,
	KKC_SYSTEM_SEGMENT_DICTIONARY_NUM_PROPERTIES
};
static GParamSpec* kkc_system_segment_dictionary_properties[KKC_SYSTEM_SEGMENT_DICTIONARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_mapped_file_unref0(var) ((var == NULL) ? NULL : (var = (g_mapped_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KkcSystemSegmentDictionaryPrivate {
	GFile* file;
	GMappedFile* mmap;
	gchar* etag;
	KkcEncodingConverter* converter;
	glong okuri_ari_offset;
	glong okuri_nasi_offset;
};

static gint KkcSystemSegmentDictionary_private_offset;
static gpointer kkc_system_segment_dictionary_parent_class = NULL;
static KkcDictionaryIface * kkc_system_segment_dictionary_kkc_dictionary_parent_iface = NULL;
static KkcSegmentDictionaryIface * kkc_system_segment_dictionary_kkc_segment_dictionary_parent_iface = NULL;

VALA_EXTERN GType kkc_encoding_converter_get_type (void) G_GNUC_CONST ;
static gchar* kkc_system_segment_dictionary_read_line (KkcSystemSegmentDictionary* self,
                                                glong* offset);
static gchar* kkc_system_segment_dictionary_read_previous_line (KkcSystemSegmentDictionary* self,
                                                         glong* pos,
                                                         const gchar* line);
static gchar* kkc_system_segment_dictionary_read_next_line (KkcSystemSegmentDictionary* self,
                                                     glong* pos,
                                                     const gchar* line);
static gboolean kkc_system_segment_dictionary_read_until (KkcSystemSegmentDictionary* self,
                                                   glong* offset,
                                                   const gchar* line);
static void kkc_system_segment_dictionary_load (KkcSystemSegmentDictionary* self,
                                         GError** error);
VALA_EXTERN gchar* kkc_encoding_converter_extract_coding_system (const gchar* line);
VALA_EXTERN KkcEncodingConverter* kkc_encoding_converter_new_from_coding_system (const gchar* coding,
                                                                     GError** error);
VALA_EXTERN KkcEncodingConverter* kkc_encoding_converter_construct_from_coding_system (GType object_type,
                                                                           const gchar* coding,
                                                                           GError** error);
static void kkc_system_segment_dictionary_real_reload (KkcDictionary* base,
                                                GError** error);
static gboolean kkc_system_segment_dictionary_search_pos (KkcSystemSegmentDictionary* self,
                                                   const gchar* midasi,
                                                   glong start_offset,
                                                   glong end_offset,
                                                   GCompareFunc cmp,
                                                   glong* pos,
                                                   gchar** line,
                                                   gint direction);
static gboolean kkc_system_segment_dictionary_real_lookup_candidates (KkcSegmentDictionary* base,
                                                               const gchar* midasi,
                                                               gboolean okuri,
                                                               KkcCandidate*** candidates,
                                                               gint* candidates_length1);
VALA_EXTERN gchar* kkc_encoding_converter_encode (KkcEncodingConverter* self,
                                      const gchar* internal_str,
                                      GError** error);
VALA_EXTERN gchar* kkc_encoding_converter_decode (KkcEncodingConverter* self,
                                      const gchar* external_str,
                                      GError** error);
VALA_EXTERN KkcCandidate** kkc_dictionary_utils_split_candidates (const gchar* midasi,
                                                      gboolean okuri,
                                                      const gchar* line,
                                                      gint* result_length1);
static gint kkc_system_segment_dictionary_strcmp_prefix (const gchar* a,
                                                  const gchar* b);
static gchar** kkc_system_segment_dictionary_real_complete (KkcSegmentDictionary* base,
                                                     const gchar* midasi,
                                                     gint* result_length1);
static gint _kkc_system_segment_dictionary_strcmp_prefix_gcompare_func (gconstpointer a,
                                                                 gconstpointer b);
VALA_EXTERN KkcEncodingConverter* kkc_encoding_converter_new (const gchar* encoding,
                                                  GError** error);
VALA_EXTERN KkcEncodingConverter* kkc_encoding_converter_construct (GType object_type,
                                                        const gchar* encoding,
                                                        GError** error);
static void kkc_system_segment_dictionary_finalize (GObject * obj);
static GType kkc_system_segment_dictionary_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
kkc_system_segment_dictionary_get_instance_private (KkcSystemSegmentDictionary* self)
{
	return G_STRUCT_MEMBER_P (self, KkcSystemSegmentDictionary_private_offset);
}

static gchar*
kkc_system_segment_dictionary_read_line (KkcSystemSegmentDictionary* self,
                                         glong* offset)
{
	GMappedFile* _tmp0_;
	gchar* p = NULL;
	GMappedFile* _tmp1_;
	gchar* _tmp2_;
	GString* builder = NULL;
	GString* _tmp9_;
	glong _offset = 0L;
	GString* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* result;
#line 27 "system-segment-dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "system-segment-dictionary.vala"
	_tmp0_ = self->priv->mmap;
#line 28 "system-segment-dictionary.vala"
	g_return_val_if_fail (((gsize) (*offset)) < g_mapped_file_get_length (_tmp0_), NULL);
#line 29 "system-segment-dictionary.vala"
	_tmp1_ = self->priv->mmap;
#line 29 "system-segment-dictionary.vala"
	_tmp2_ = g_mapped_file_get_contents (_tmp1_);
#line 29 "system-segment-dictionary.vala"
	p = ((gchar*) _tmp2_) + (*offset);
#line 179 "system-segment-dictionary.c"
	{
		gboolean _tmp3_ = FALSE;
#line 30 "system-segment-dictionary.vala"
		_tmp3_ = TRUE;
#line 30 "system-segment-dictionary.vala"
		while (TRUE) {
#line 186 "system-segment-dictionary.c"
			gchar* _tmp6_;
#line 30 "system-segment-dictionary.vala"
			if (!_tmp3_) {
#line 190 "system-segment-dictionary.c"
				glong _tmp4_;
				gchar* _tmp5_;
#line 30 "system-segment-dictionary.vala"
				_tmp4_ = *offset;
#line 30 "system-segment-dictionary.vala"
				*offset = _tmp4_ - 1;
#line 30 "system-segment-dictionary.vala"
				_tmp5_ = p;
#line 30 "system-segment-dictionary.vala"
				p = _tmp5_ - 1;
#line 201 "system-segment-dictionary.c"
			}
#line 30 "system-segment-dictionary.vala"
			_tmp3_ = FALSE;
#line 30 "system-segment-dictionary.vala"
			if (!((*offset) > ((glong) 0))) {
#line 30 "system-segment-dictionary.vala"
				break;
#line 209 "system-segment-dictionary.c"
			}
#line 31 "system-segment-dictionary.vala"
			_tmp6_ = p;
#line 31 "system-segment-dictionary.vala"
			if ((*_tmp6_) == '\n') {
#line 32 "system-segment-dictionary.vala"
				break;
#line 217 "system-segment-dictionary.c"
			}
		}
	}
#line 35 "system-segment-dictionary.vala"
	if ((*offset) > ((glong) 0)) {
#line 223 "system-segment-dictionary.c"
		glong _tmp7_;
		gchar* _tmp8_;
#line 36 "system-segment-dictionary.vala"
		_tmp7_ = *offset;
#line 36 "system-segment-dictionary.vala"
		*offset = _tmp7_ + 1;
#line 37 "system-segment-dictionary.vala"
		_tmp8_ = p;
#line 37 "system-segment-dictionary.vala"
		p = _tmp8_ + 1;
#line 234 "system-segment-dictionary.c"
	}
#line 40 "system-segment-dictionary.vala"
	_tmp9_ = g_string_new ("");
#line 40 "system-segment-dictionary.vala"
	builder = _tmp9_;
#line 41 "system-segment-dictionary.vala"
	_offset = *offset;
#line 242 "system-segment-dictionary.c"
	{
		gboolean _tmp10_ = FALSE;
#line 42 "system-segment-dictionary.vala"
		_tmp10_ = TRUE;
#line 42 "system-segment-dictionary.vala"
		while (TRUE) {
#line 249 "system-segment-dictionary.c"
			GMappedFile* _tmp13_;
			gchar* _tmp14_;
			GString* _tmp15_;
			gchar* _tmp16_;
#line 42 "system-segment-dictionary.vala"
			if (!_tmp10_) {
#line 256 "system-segment-dictionary.c"
				glong _tmp11_;
				gchar* _tmp12_;
#line 42 "system-segment-dictionary.vala"
				_tmp11_ = _offset;
#line 42 "system-segment-dictionary.vala"
				_offset = _tmp11_ + 1;
#line 42 "system-segment-dictionary.vala"
				_tmp12_ = p;
#line 42 "system-segment-dictionary.vala"
				p = _tmp12_ + 1;
#line 267 "system-segment-dictionary.c"
			}
#line 42 "system-segment-dictionary.vala"
			_tmp10_ = FALSE;
#line 42 "system-segment-dictionary.vala"
			_tmp13_ = self->priv->mmap;
#line 42 "system-segment-dictionary.vala"
			if (!(((gsize) _offset) < g_mapped_file_get_length (_tmp13_))) {
#line 42 "system-segment-dictionary.vala"
				break;
#line 277 "system-segment-dictionary.c"
			}
#line 43 "system-segment-dictionary.vala"
			_tmp14_ = p;
#line 43 "system-segment-dictionary.vala"
			if ((*_tmp14_) == '\n') {
#line 44 "system-segment-dictionary.vala"
				break;
#line 285 "system-segment-dictionary.c"
			}
#line 45 "system-segment-dictionary.vala"
			_tmp15_ = builder;
#line 45 "system-segment-dictionary.vala"
			_tmp16_ = p;
#line 45 "system-segment-dictionary.vala"
			g_string_append_c (_tmp15_, *_tmp16_);
#line 293 "system-segment-dictionary.c"
		}
	}
#line 47 "system-segment-dictionary.vala"
	_tmp17_ = builder;
#line 47 "system-segment-dictionary.vala"
	_tmp18_ = _tmp17_->str;
#line 47 "system-segment-dictionary.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 47 "system-segment-dictionary.vala"
	result = _tmp19_;
#line 47 "system-segment-dictionary.vala"
	_g_string_free0 (builder);
#line 47 "system-segment-dictionary.vala"
	return result;
#line 308 "system-segment-dictionary.c"
}

static gchar*
kkc_system_segment_dictionary_read_previous_line (KkcSystemSegmentDictionary* self,
                                                  glong* pos,
                                                  const gchar* line)
{
	gchar* _tmp0_;
	gchar* result;
#line 51 "system-segment-dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "system-segment-dictionary.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 52 "system-segment-dictionary.vala"
	if ((*pos) < ((glong) 2)) {
#line 53 "system-segment-dictionary.vala"
		result = NULL;
#line 53 "system-segment-dictionary.vala"
		return result;
#line 328 "system-segment-dictionary.c"
	}
#line 56 "system-segment-dictionary.vala"
	*pos = (*pos) - 2;
#line 57 "system-segment-dictionary.vala"
	_tmp0_ = kkc_system_segment_dictionary_read_line (self, pos);
#line 57 "system-segment-dictionary.vala"
	result = _tmp0_;
#line 57 "system-segment-dictionary.vala"
	return result;
#line 338 "system-segment-dictionary.c"
}

static gchar*
kkc_system_segment_dictionary_read_next_line (KkcSystemSegmentDictionary* self,
                                              glong* pos,
                                              const gchar* line)
{
	gint _tmp0_;
	gint _tmp1_;
	GMappedFile* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 61 "system-segment-dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "system-segment-dictionary.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 62 "system-segment-dictionary.vala"
	_tmp0_ = strlen (line);
#line 62 "system-segment-dictionary.vala"
	_tmp1_ = _tmp0_;
#line 62 "system-segment-dictionary.vala"
	_tmp2_ = self->priv->mmap;
#line 62 "system-segment-dictionary.vala"
	if (((gsize) (((*pos) + _tmp1_) + 1)) >= g_mapped_file_get_length (_tmp2_)) {
#line 63 "system-segment-dictionary.vala"
		result = NULL;
#line 63 "system-segment-dictionary.vala"
		return result;
#line 369 "system-segment-dictionary.c"
	}
#line 66 "system-segment-dictionary.vala"
	_tmp3_ = strlen (line);
#line 66 "system-segment-dictionary.vala"
	_tmp4_ = _tmp3_;
#line 66 "system-segment-dictionary.vala"
	*pos = (*pos) + (_tmp4_ + 1);
#line 67 "system-segment-dictionary.vala"
	_tmp5_ = kkc_system_segment_dictionary_read_line (self, pos);
#line 67 "system-segment-dictionary.vala"
	result = _tmp5_;
#line 67 "system-segment-dictionary.vala"
	return result;
#line 383 "system-segment-dictionary.c"
}

static gboolean
kkc_system_segment_dictionary_read_until (KkcSystemSegmentDictionary* self,
                                          glong* offset,
                                          const gchar* line)
{
	GMappedFile* _tmp0_;
	gboolean result;
#line 72 "system-segment-dictionary.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 72 "system-segment-dictionary.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 73 "system-segment-dictionary.vala"
	_tmp0_ = self->priv->mmap;
#line 73 "system-segment-dictionary.vala"
	g_return_val_if_fail (((gsize) (*offset)) < g_mapped_file_get_length (_tmp0_), FALSE);
#line 74 "system-segment-dictionary.vala"
	while (TRUE) {
#line 403 "system-segment-dictionary.c"
		gint _tmp1_;
		gint _tmp2_;
		GMappedFile* _tmp3_;
		gchar* p = NULL;
		GMappedFile* _tmp4_;
		gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
		gchar* _tmp7_;
		glong _tmp13_;
#line 74 "system-segment-dictionary.vala"
		_tmp1_ = strlen (line);
#line 74 "system-segment-dictionary.vala"
		_tmp2_ = _tmp1_;
#line 74 "system-segment-dictionary.vala"
		_tmp3_ = self->priv->mmap;
#line 74 "system-segment-dictionary.vala"
		if (!(((gsize) ((*offset) + _tmp2_)) < g_mapped_file_get_length (_tmp3_))) {
#line 74 "system-segment-dictionary.vala"
			break;
#line 423 "system-segment-dictionary.c"
		}
#line 75 "system-segment-dictionary.vala"
		_tmp4_ = self->priv->mmap;
#line 75 "system-segment-dictionary.vala"
		_tmp5_ = g_mapped_file_get_contents (_tmp4_);
#line 75 "system-segment-dictionary.vala"
		p = ((gchar*) _tmp5_) + (*offset);
#line 76 "system-segment-dictionary.vala"
		_tmp7_ = p;
#line 76 "system-segment-dictionary.vala"
		if ((*_tmp7_) == '\n') {
#line 435 "system-segment-dictionary.c"
			gchar* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 77 "system-segment-dictionary.vala"
			_tmp8_ = p;
#line 77 "system-segment-dictionary.vala"
			_tmp9_ = strlen (line);
#line 77 "system-segment-dictionary.vala"
			_tmp10_ = _tmp9_;
#line 77 "system-segment-dictionary.vala"
			_tmp6_ = memcmp (_tmp8_ + 1, (void*) line, (gsize) _tmp10_) == 0;
#line 447 "system-segment-dictionary.c"
		} else {
#line 76 "system-segment-dictionary.vala"
			_tmp6_ = FALSE;
#line 451 "system-segment-dictionary.c"
		}
#line 76 "system-segment-dictionary.vala"
		if (_tmp6_) {
#line 455 "system-segment-dictionary.c"
			gint _tmp11_;
			gint _tmp12_;
#line 78 "system-segment-dictionary.vala"
			_tmp11_ = strlen (line);
#line 78 "system-segment-dictionary.vala"
			_tmp12_ = _tmp11_;
#line 78 "system-segment-dictionary.vala"
			*offset = (*offset) + _tmp12_;
#line 79 "system-segment-dictionary.vala"
			result = TRUE;
#line 79 "system-segment-dictionary.vala"
			return result;
#line 468 "system-segment-dictionary.c"
		}
#line 81 "system-segment-dictionary.vala"
		_tmp13_ = *offset;
#line 81 "system-segment-dictionary.vala"
		*offset = _tmp13_ + 1;
#line 474 "system-segment-dictionary.c"
	}
#line 83 "system-segment-dictionary.vala"
	result = FALSE;
#line 83 "system-segment-dictionary.vala"
	return result;
#line 480 "system-segment-dictionary.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 101 "system-segment-dictionary.vala"
	return self ? g_object_ref (self) : NULL;
#line 488 "system-segment-dictionary.c"
}

static void
kkc_system_segment_dictionary_load (KkcSystemSegmentDictionary* self,
                                    GError** error)
{
	GMappedFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GMappedFile* _tmp4_;
	GMappedFile* _tmp5_;
	GMappedFile* _tmp6_;
	glong offset = 0L;
	gchar* line = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* coding = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp21_;
	gboolean _tmp24_;
	GError* _inner_error0_ = NULL;
#line 86 "system-segment-dictionary.vala"
	g_return_if_fail (self != NULL);
#line 87 "system-segment-dictionary.vala"
	_tmp1_ = self->priv->file;
#line 87 "system-segment-dictionary.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 87 "system-segment-dictionary.vala"
	_tmp3_ = _tmp2_;
#line 87 "system-segment-dictionary.vala"
	_tmp4_ = g_mapped_file_new (_tmp3_, FALSE, &_inner_error0_);
#line 87 "system-segment-dictionary.vala"
	_tmp5_ = _tmp4_;
#line 87 "system-segment-dictionary.vala"
	_g_free0 (_tmp3_);
#line 87 "system-segment-dictionary.vala"
	_tmp0_ = _tmp5_;
#line 87 "system-segment-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "system-segment-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 87 "system-segment-dictionary.vala"
		return;
#line 535 "system-segment-dictionary.c"
	}
#line 87 "system-segment-dictionary.vala"
	_tmp6_ = _tmp0_;
#line 87 "system-segment-dictionary.vala"
	_tmp0_ = NULL;
#line 87 "system-segment-dictionary.vala"
	_g_mapped_file_unref0 (self->priv->mmap);
#line 87 "system-segment-dictionary.vala"
	self->priv->mmap = _tmp6_;
#line 88 "system-segment-dictionary.vala"
	offset = (glong) 0;
#line 89 "system-segment-dictionary.vala"
	_tmp7_ = kkc_system_segment_dictionary_read_line (self, &offset);
#line 89 "system-segment-dictionary.vala"
	line = _tmp7_;
#line 90 "system-segment-dictionary.vala"
	_tmp8_ = line;
#line 90 "system-segment-dictionary.vala"
	if (_tmp8_ == NULL) {
#line 555 "system-segment-dictionary.c"
		GError* _tmp9_;
#line 91 "system-segment-dictionary.vala"
		_tmp9_ = g_error_new_literal (KKC_DICTIONARY_ERROR, KKC_DICTIONARY_ERROR_MALFORMED_INPUT, "can't read the first line");
#line 91 "system-segment-dictionary.vala"
		_inner_error0_ = _tmp9_;
#line 91 "system-segment-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 91 "system-segment-dictionary.vala"
		_g_free0 (line);
#line 91 "system-segment-dictionary.vala"
		_g_mapped_file_unref0 (_tmp0_);
#line 91 "system-segment-dictionary.vala"
		return;
#line 569 "system-segment-dictionary.c"
	}
#line 95 "system-segment-dictionary.vala"
	_tmp10_ = line;
#line 95 "system-segment-dictionary.vala"
	_tmp11_ = kkc_encoding_converter_extract_coding_system (_tmp10_);
#line 95 "system-segment-dictionary.vala"
	coding = _tmp11_;
#line 96 "system-segment-dictionary.vala"
	_tmp12_ = coding;
#line 96 "system-segment-dictionary.vala"
	if (_tmp12_ != NULL) {
#line 581 "system-segment-dictionary.c"
		{
			KkcEncodingConverter* _converter = NULL;
			const gchar* _tmp13_;
			KkcEncodingConverter* _tmp14_;
			KkcEncodingConverter* _tmp15_;
#line 98 "system-segment-dictionary.vala"
			_tmp13_ = coding;
#line 98 "system-segment-dictionary.vala"
			_tmp14_ = kkc_encoding_converter_new_from_coding_system (_tmp13_, &_inner_error0_);
#line 98 "system-segment-dictionary.vala"
			_converter = _tmp14_;
#line 98 "system-segment-dictionary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 595 "system-segment-dictionary.c"
				goto __catch0_g_error;
			}
#line 100 "system-segment-dictionary.vala"
			_tmp15_ = _converter;
#line 100 "system-segment-dictionary.vala"
			if (_tmp15_ != NULL) {
#line 602 "system-segment-dictionary.c"
				KkcEncodingConverter* _tmp16_;
				KkcEncodingConverter* _tmp17_;
#line 101 "system-segment-dictionary.vala"
				_tmp16_ = _converter;
#line 101 "system-segment-dictionary.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 101 "system-segment-dictionary.vala"
				_g_object_unref0 (self->priv->converter);
#line 101 "system-segment-dictionary.vala"
				self->priv->converter = _tmp17_;
#line 613 "system-segment-dictionary.c"
			}
#line 97 "system-segment-dictionary.vala"
			_g_object_unref0 (_converter);
#line 617 "system-segment-dictionary.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp18_;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 97 "system-segment-dictionary.vala"
			e = _inner_error0_;
#line 97 "system-segment-dictionary.vala"
			_inner_error0_ = NULL;
#line 104 "system-segment-dictionary.vala"
			_tmp18_ = coding;
#line 104 "system-segment-dictionary.vala"
			_tmp19_ = e;
#line 104 "system-segment-dictionary.vala"
			_tmp20_ = _tmp19_->message;
#line 104 "system-segment-dictionary.vala"
			g_warning ("system-segment-dictionary.vala:104: can't create converter from coding" \
" system %s: %s", _tmp18_, _tmp20_);
#line 97 "system-segment-dictionary.vala"
			_g_error_free0 (e);
#line 640 "system-segment-dictionary.c"
		}
		__finally0:
#line 97 "system-segment-dictionary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "system-segment-dictionary.vala"
			g_propagate_error (error, _inner_error0_);
#line 97 "system-segment-dictionary.vala"
			_g_free0 (coding);
#line 97 "system-segment-dictionary.vala"
			_g_free0 (line);
#line 97 "system-segment-dictionary.vala"
			_g_mapped_file_unref0 (_tmp0_);
#line 97 "system-segment-dictionary.vala"
			return;
#line 655 "system-segment-dictionary.c"
		}
	}
#line 109 "system-segment-dictionary.vala"
	_tmp21_ = line;
#line 109 "system-segment-dictionary.vala"
	if (g_strcmp0 (_tmp21_, ";; okuri-ari entries.") == 0) {
#line 110 "system-segment-dictionary.vala"
		offset = (glong) 0;
#line 664 "system-segment-dictionary.c"
	} else {
		gboolean _tmp22_;
#line 111 "system-segment-dictionary.vala"
		_tmp22_ = kkc_system_segment_dictionary_read_until (self, &offset, ";; okuri-ari entries.\n");
#line 111 "system-segment-dictionary.vala"
		if (!_tmp22_) {
#line 671 "system-segment-dictionary.c"
			GError* _tmp23_;
#line 112 "system-segment-dictionary.vala"
			_tmp23_ = g_error_new_literal (KKC_DICTIONARY_ERROR, KKC_DICTIONARY_ERROR_MALFORMED_INPUT, "no okuri-ari boundary");
#line 112 "system-segment-dictionary.vala"
			_inner_error0_ = _tmp23_;
#line 112 "system-segment-dictionary.vala"
			g_propagate_error (error, _inner_error0_);
#line 112 "system-segment-dictionary.vala"
			_g_free0 (coding);
#line 112 "system-segment-dictionary.vala"
			_g_free0 (line);
#line 112 "system-segment-dictionary.vala"
			_g_mapped_file_unref0 (_tmp0_);
#line 112 "system-segment-dictionary.vala"
			return;
#line 687 "system-segment-dictionary.c"
		}
	}
#line 114 "system-segment-dictionary.vala"
	self->priv->okuri_ari_offset = offset;
#line 116 "system-segment-dictionary.vala"
	_tmp24_ = kkc_system_segment_dictionary_read_until (self, &offset, ";; okuri-nasi entries.\n");
#line 116 "system-segment-dictionary.vala"
	if (!_tmp24_) {
#line 696 "system-segment-dictionary.c"
		GError* _tmp25_;
#line 117 "system-segment-dictionary.vala"
		_tmp25_ = g_error_new_literal (KKC_DICTIONARY_ERROR, KKC_DICTIONARY_ERROR_MALFORMED_INPUT, "no okuri-nasi boundary");
#line 117 "system-segment-dictionary.vala"
		_inner_error0_ = _tmp25_;
#line 117 "system-segment-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 117 "system-segment-dictionary.vala"
		_g_free0 (coding);
#line 117 "system-segment-dictionary.vala"
		_g_free0 (line);
#line 117 "system-segment-dictionary.vala"
		_g_mapped_file_unref0 (_tmp0_);
#line 117 "system-segment-dictionary.vala"
		return;
#line 712 "system-segment-dictionary.c"
	}
#line 120 "system-segment-dictionary.vala"
	self->priv->okuri_nasi_offset = offset;
#line 86 "system-segment-dictionary.vala"
	_g_free0 (coding);
#line 86 "system-segment-dictionary.vala"
	_g_free0 (line);
#line 86 "system-segment-dictionary.vala"
	_g_mapped_file_unref0 (_tmp0_);
#line 722 "system-segment-dictionary.c"
}

/**
         * {@inheritDoc}
         */
static void
kkc_system_segment_dictionary_real_reload (KkcDictionary* base,
                                           GError** error)
{
	KkcSystemSegmentDictionary * self;
	gchar* attributes = NULL;
	gchar* _tmp0_;
	GFileInfo* info = NULL;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 126 "system-segment-dictionary.vala"
	self = (KkcSystemSegmentDictionary*) base;
#line 127 "system-segment-dictionary.vala"
	_tmp0_ = g_strdup (G_FILE_ATTRIBUTE_ETAG_VALUE);
#line 127 "system-segment-dictionary.vala"
	attributes = _tmp0_;
#line 128 "system-segment-dictionary.vala"
	_tmp1_ = self->priv->file;
#line 128 "system-segment-dictionary.vala"
	_tmp2_ = attributes;
#line 128 "system-segment-dictionary.vala"
	_tmp3_ = g_file_query_info (_tmp1_, _tmp2_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 128 "system-segment-dictionary.vala"
	info = _tmp3_;
#line 128 "system-segment-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "system-segment-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 128 "system-segment-dictionary.vala"
		_g_free0 (attributes);
#line 128 "system-segment-dictionary.vala"
		return;
#line 765 "system-segment-dictionary.c"
	}
#line 130 "system-segment-dictionary.vala"
	_tmp4_ = info;
#line 130 "system-segment-dictionary.vala"
	_tmp5_ = g_file_info_get_etag (_tmp4_);
#line 130 "system-segment-dictionary.vala"
	_tmp6_ = self->priv->etag;
#line 130 "system-segment-dictionary.vala"
	if (g_strcmp0 (_tmp5_, _tmp6_) != 0) {
#line 775 "system-segment-dictionary.c"
		GFileInfo* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 131 "system-segment-dictionary.vala"
		kkc_system_segment_dictionary_load (self, &_inner_error0_);
#line 131 "system-segment-dictionary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "system-segment-dictionary.vala"
			g_propagate_error (error, _inner_error0_);
#line 131 "system-segment-dictionary.vala"
			_g_object_unref0 (info);
#line 131 "system-segment-dictionary.vala"
			_g_free0 (attributes);
#line 131 "system-segment-dictionary.vala"
			return;
#line 791 "system-segment-dictionary.c"
		}
#line 132 "system-segment-dictionary.vala"
		_tmp7_ = info;
#line 132 "system-segment-dictionary.vala"
		_tmp8_ = g_file_info_get_etag (_tmp7_);
#line 132 "system-segment-dictionary.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 132 "system-segment-dictionary.vala"
		_g_free0 (self->priv->etag);
#line 132 "system-segment-dictionary.vala"
		self->priv->etag = _tmp9_;
#line 803 "system-segment-dictionary.c"
	}
#line 126 "system-segment-dictionary.vala"
	_g_object_unref0 (info);
#line 126 "system-segment-dictionary.vala"
	_g_free0 (attributes);
#line 809 "system-segment-dictionary.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 833 "system-segment-dictionary.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 841 "system-segment-dictionary.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 847 "system-segment-dictionary.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 875 "system-segment-dictionary.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 881 "system-segment-dictionary.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 887 "system-segment-dictionary.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 891 "system-segment-dictionary.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 899 "system-segment-dictionary.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 903 "system-segment-dictionary.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 915 "system-segment-dictionary.c"
}

static gboolean
kkc_system_segment_dictionary_search_pos (KkcSystemSegmentDictionary* self,
                                          const gchar* midasi,
                                          glong start_offset,
                                          glong end_offset,
                                          GCompareFunc cmp,
                                          glong* pos,
                                          gchar** line,
                                          gint direction)
{
	glong _vala_pos = 0L;
	gchar* _vala_line = NULL;
	glong offset = 0L;
	gboolean result;
#line 136 "system-segment-dictionary.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "system-segment-dictionary.vala"
	g_return_val_if_fail (midasi != NULL, FALSE);
#line 143 "system-segment-dictionary.vala"
	offset = start_offset + ((end_offset - start_offset) / 2);
#line 144 "system-segment-dictionary.vala"
	while (TRUE) {
#line 940 "system-segment-dictionary.c"
		GMappedFile* _tmp0_;
		gchar* _line = NULL;
		gchar* _tmp1_;
		gint index = 0;
		const gchar* _tmp2_;
		gint r = 0;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gint _tmp7_;
#line 144 "system-segment-dictionary.vala"
		if (!(start_offset <= end_offset)) {
#line 144 "system-segment-dictionary.vala"
			break;
#line 955 "system-segment-dictionary.c"
		}
#line 145 "system-segment-dictionary.vala"
		_tmp0_ = self->priv->mmap;
#line 145 "system-segment-dictionary.vala"
		_vala_assert (((gsize) offset) < g_mapped_file_get_length (_tmp0_), "offset < mmap.get_length ()");
#line 147 "system-segment-dictionary.vala"
		_tmp1_ = kkc_system_segment_dictionary_read_line (self, &offset);
#line 147 "system-segment-dictionary.vala"
		_line = _tmp1_;
#line 148 "system-segment-dictionary.vala"
		_tmp2_ = _line;
#line 148 "system-segment-dictionary.vala"
		index = string_index_of (_tmp2_, " ", 0);
#line 149 "system-segment-dictionary.vala"
		if (index < 1) {
#line 971 "system-segment-dictionary.c"
			const gchar* _tmp3_;
#line 150 "system-segment-dictionary.vala"
			_tmp3_ = _line;
#line 150 "system-segment-dictionary.vala"
			g_warning ("system-segment-dictionary.vala:150: corrupted dictionary entry: %s", _tmp3_);
#line 151 "system-segment-dictionary.vala"
			_g_free0 (_line);
#line 151 "system-segment-dictionary.vala"
			break;
#line 981 "system-segment-dictionary.c"
		}
#line 154 "system-segment-dictionary.vala"
		_tmp4_ = _line;
#line 154 "system-segment-dictionary.vala"
		_tmp5_ = string_slice (_tmp4_, (glong) 0, (glong) index);
#line 154 "system-segment-dictionary.vala"
		_tmp6_ = _tmp5_;
#line 154 "system-segment-dictionary.vala"
		_tmp7_ = cmp (_tmp6_, midasi);
#line 154 "system-segment-dictionary.vala"
		_g_free0 (_tmp6_);
#line 154 "system-segment-dictionary.vala"
		r = _tmp7_;
#line 155 "system-segment-dictionary.vala"
		if (r == 0) {
#line 997 "system-segment-dictionary.c"
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 156 "system-segment-dictionary.vala"
			_vala_pos = offset;
#line 157 "system-segment-dictionary.vala"
			_tmp8_ = _line;
#line 157 "system-segment-dictionary.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 157 "system-segment-dictionary.vala"
			_g_free0 (_vala_line);
#line 157 "system-segment-dictionary.vala"
			_vala_line = _tmp9_;
#line 158 "system-segment-dictionary.vala"
			result = TRUE;
#line 158 "system-segment-dictionary.vala"
			_g_free0 (_line);
#line 158 "system-segment-dictionary.vala"
			if (pos) {
#line 158 "system-segment-dictionary.vala"
				*pos = _vala_pos;
#line 1018 "system-segment-dictionary.c"
			}
#line 158 "system-segment-dictionary.vala"
			if (line) {
#line 158 "system-segment-dictionary.vala"
				*line = _vala_line;
#line 1024 "system-segment-dictionary.c"
			} else {
#line 158 "system-segment-dictionary.vala"
				_g_free0 (_vala_line);
#line 1028 "system-segment-dictionary.c"
			}
#line 158 "system-segment-dictionary.vala"
			return result;
#line 1032 "system-segment-dictionary.c"
		}
#line 161 "system-segment-dictionary.vala"
		if ((r * direction) > 0) {
#line 162 "system-segment-dictionary.vala"
			end_offset = offset - 2;
#line 1038 "system-segment-dictionary.c"
		} else {
			const gchar* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
#line 164 "system-segment-dictionary.vala"
			_tmp10_ = _line;
#line 164 "system-segment-dictionary.vala"
			_tmp11_ = strlen (_tmp10_);
#line 164 "system-segment-dictionary.vala"
			_tmp12_ = _tmp11_;
#line 164 "system-segment-dictionary.vala"
			start_offset = (offset + _tmp12_) + 1;
#line 1051 "system-segment-dictionary.c"
		}
#line 166 "system-segment-dictionary.vala"
		offset = start_offset + ((end_offset - start_offset) / 2);
#line 144 "system-segment-dictionary.vala"
		_g_free0 (_line);
#line 1057 "system-segment-dictionary.c"
	}
#line 168 "system-segment-dictionary.vala"
	_vala_pos = (glong) -1;
#line 169 "system-segment-dictionary.vala"
	_g_free0 (_vala_line);
#line 169 "system-segment-dictionary.vala"
	_vala_line = NULL;
#line 170 "system-segment-dictionary.vala"
	result = FALSE;
#line 170 "system-segment-dictionary.vala"
	if (pos) {
#line 170 "system-segment-dictionary.vala"
		*pos = _vala_pos;
#line 1071 "system-segment-dictionary.c"
	}
#line 170 "system-segment-dictionary.vala"
	if (line) {
#line 170 "system-segment-dictionary.vala"
		*line = _vala_line;
#line 1077 "system-segment-dictionary.c"
	} else {
#line 170 "system-segment-dictionary.vala"
		_g_free0 (_vala_line);
#line 1081 "system-segment-dictionary.c"
	}
#line 170 "system-segment-dictionary.vala"
	return result;
#line 1085 "system-segment-dictionary.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
kkc_system_segment_dictionary_real_lookup_candidates (KkcSegmentDictionary* base,
                                                      const gchar* midasi,
                                                      gboolean okuri,
                                                      KkcCandidate*** candidates,
                                                      gint* candidates_length1)
{
	KkcSystemSegmentDictionary * self;
	KkcCandidate** _vala_candidates = NULL;
	gint _vala_candidates_length1 = 0;
	GMappedFile* _tmp0_;
	gchar* _tmp1_;
	glong start_offset = 0L;
	glong end_offset = 0L;
	gchar* _midasi = NULL;
	glong pos = 0L;
	gchar* line = NULL;
	gint _tmp12_ = 0;
	const gchar* _tmp13_;
	GCompareFunc _tmp14_;
	glong _tmp15_ = 0L;
	gchar* _tmp16_ = NULL;
	gboolean _tmp17_;
	KkcCandidate** _tmp38_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 176 "system-segment-dictionary.vala"
	self = (KkcSystemSegmentDictionary*) base;
#line 176 "system-segment-dictionary.vala"
	g_return_val_if_fail (midasi != NULL, FALSE);
#line 179 "system-segment-dictionary.vala"
	_tmp0_ = self->priv->mmap;
#line 179 "system-segment-dictionary.vala"
	_tmp1_ = g_mapped_file_get_contents (_tmp0_);
#line 179 "system-segment-dictionary.vala"
	if (_tmp1_ == NULL) {
#line 1127 "system-segment-dictionary.c"
		KkcCandidate** _tmp2_;
#line 180 "system-segment-dictionary.vala"
		_tmp2_ = g_new0 (KkcCandidate*, 0 + 1);
#line 180 "system-segment-dictionary.vala"
		_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 180 "system-segment-dictionary.vala"
		_vala_candidates = _tmp2_;
#line 180 "system-segment-dictionary.vala"
		_vala_candidates_length1 = 0;
#line 181 "system-segment-dictionary.vala"
		result = FALSE;
#line 181 "system-segment-dictionary.vala"
		if (candidates) {
#line 181 "system-segment-dictionary.vala"
			*candidates = _vala_candidates;
#line 1143 "system-segment-dictionary.c"
		} else {
#line 181 "system-segment-dictionary.vala"
			_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1147 "system-segment-dictionary.c"
		}
#line 181 "system-segment-dictionary.vala"
		if (candidates_length1) {
#line 181 "system-segment-dictionary.vala"
			*candidates_length1 = _vala_candidates_length1;
#line 1153 "system-segment-dictionary.c"
		}
#line 181 "system-segment-dictionary.vala"
		return result;
#line 1157 "system-segment-dictionary.c"
	}
#line 185 "system-segment-dictionary.vala"
	if (okuri) {
#line 186 "system-segment-dictionary.vala"
		start_offset = self->priv->okuri_ari_offset;
#line 187 "system-segment-dictionary.vala"
		end_offset = self->priv->okuri_nasi_offset;
#line 1165 "system-segment-dictionary.c"
	} else {
		GMappedFile* _tmp3_;
#line 189 "system-segment-dictionary.vala"
		start_offset = self->priv->okuri_nasi_offset;
#line 190 "system-segment-dictionary.vala"
		_tmp3_ = self->priv->mmap;
#line 190 "system-segment-dictionary.vala"
		end_offset = ((glong) g_mapped_file_get_length (_tmp3_)) - 1;
#line 1174 "system-segment-dictionary.c"
	}
	{
		gchar* _tmp4_ = NULL;
		KkcEncodingConverter* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 194 "system-segment-dictionary.vala"
		_tmp5_ = self->priv->converter;
#line 194 "system-segment-dictionary.vala"
		_tmp6_ = kkc_encoding_converter_encode (_tmp5_, midasi, &_inner_error0_);
#line 194 "system-segment-dictionary.vala"
		_tmp4_ = _tmp6_;
#line 194 "system-segment-dictionary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1189 "system-segment-dictionary.c"
			goto __catch0_g_error;
		}
#line 194 "system-segment-dictionary.vala"
		_tmp7_ = _tmp4_;
#line 194 "system-segment-dictionary.vala"
		_tmp4_ = NULL;
#line 194 "system-segment-dictionary.vala"
		_g_free0 (_midasi);
#line 194 "system-segment-dictionary.vala"
		_midasi = _tmp7_;
#line 193 "system-segment-dictionary.vala"
		_g_free0 (_tmp4_);
#line 1202 "system-segment-dictionary.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		KkcCandidate** _tmp10_;
#line 193 "system-segment-dictionary.vala"
		e = _inner_error0_;
#line 193 "system-segment-dictionary.vala"
		_inner_error0_ = NULL;
#line 196 "system-segment-dictionary.vala"
		_tmp8_ = e;
#line 196 "system-segment-dictionary.vala"
		_tmp9_ = _tmp8_->message;
#line 196 "system-segment-dictionary.vala"
		g_warning ("system-segment-dictionary.vala:196: can't encode %s: %s", midasi, _tmp9_);
#line 197 "system-segment-dictionary.vala"
		_tmp10_ = g_new0 (KkcCandidate*, 0 + 1);
#line 197 "system-segment-dictionary.vala"
		_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 197 "system-segment-dictionary.vala"
		_vala_candidates = _tmp10_;
#line 197 "system-segment-dictionary.vala"
		_vala_candidates_length1 = 0;
#line 198 "system-segment-dictionary.vala"
		result = FALSE;
#line 198 "system-segment-dictionary.vala"
		_g_error_free0 (e);
#line 198 "system-segment-dictionary.vala"
		_g_free0 (_midasi);
#line 198 "system-segment-dictionary.vala"
		if (candidates) {
#line 198 "system-segment-dictionary.vala"
			*candidates = _vala_candidates;
#line 1239 "system-segment-dictionary.c"
		} else {
#line 198 "system-segment-dictionary.vala"
			_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1243 "system-segment-dictionary.c"
		}
#line 198 "system-segment-dictionary.vala"
		if (candidates_length1) {
#line 198 "system-segment-dictionary.vala"
			*candidates_length1 = _vala_candidates_length1;
#line 1249 "system-segment-dictionary.c"
		}
#line 198 "system-segment-dictionary.vala"
		return result;
#line 1253 "system-segment-dictionary.c"
	}
	__finally0:
#line 193 "system-segment-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1258 "system-segment-dictionary.c"
		gboolean _tmp11_ = FALSE;
#line 193 "system-segment-dictionary.vala"
		_g_free0 (_midasi);
#line 193 "system-segment-dictionary.vala"
		_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 193 "system-segment-dictionary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 193 "system-segment-dictionary.vala"
		g_clear_error (&_inner_error0_);
#line 193 "system-segment-dictionary.vala"
		return _tmp11_;
#line 1270 "system-segment-dictionary.c"
	}
#line 209 "system-segment-dictionary.vala"
	if (okuri) {
#line 209 "system-segment-dictionary.vala"
		_tmp12_ = -1;
#line 1276 "system-segment-dictionary.c"
	} else {
#line 209 "system-segment-dictionary.vala"
		_tmp12_ = 1;
#line 1280 "system-segment-dictionary.c"
	}
#line 203 "system-segment-dictionary.vala"
	_tmp13_ = _midasi;
#line 203 "system-segment-dictionary.vala"
	_tmp14_ = ((GCompareFunc) g_strcmp0);
#line 203 "system-segment-dictionary.vala"
	_tmp17_ = kkc_system_segment_dictionary_search_pos (self, _tmp13_, start_offset, end_offset, _tmp14_, &_tmp15_, &_tmp16_, _tmp12_);
#line 203 "system-segment-dictionary.vala"
	pos = _tmp15_;
#line 203 "system-segment-dictionary.vala"
	_g_free0 (line);
#line 203 "system-segment-dictionary.vala"
	line = _tmp16_;
#line 203 "system-segment-dictionary.vala"
	if (_tmp17_) {
#line 1296 "system-segment-dictionary.c"
		gint index = 0;
		const gchar* _tmp18_;
		gchar* _line = NULL;
#line 210 "system-segment-dictionary.vala"
		_tmp18_ = line;
#line 210 "system-segment-dictionary.vala"
		index = string_index_of (_tmp18_, " ", 0);
#line 212 "system-segment-dictionary.vala"
		if (index > 0) {
#line 1306 "system-segment-dictionary.c"
			const gchar* _tmp35_;
			gint _tmp36_ = 0;
			KkcCandidate** _tmp37_;
			{
				gchar* _tmp19_ = NULL;
				KkcEncodingConverter* _tmp20_;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
#line 214 "system-segment-dictionary.vala"
				_tmp20_ = self->priv->converter;
#line 214 "system-segment-dictionary.vala"
				_tmp21_ = line;
#line 214 "system-segment-dictionary.vala"
				_tmp22_ = line;
#line 214 "system-segment-dictionary.vala"
				_tmp23_ = strlen (_tmp22_);
#line 214 "system-segment-dictionary.vala"
				_tmp24_ = _tmp23_;
#line 214 "system-segment-dictionary.vala"
				_tmp25_ = string_slice (_tmp21_, (glong) index, (glong) _tmp24_);
#line 214 "system-segment-dictionary.vala"
				_tmp26_ = _tmp25_;
#line 214 "system-segment-dictionary.vala"
				_tmp27_ = kkc_encoding_converter_decode (_tmp20_, _tmp26_, &_inner_error0_);
#line 214 "system-segment-dictionary.vala"
				_tmp28_ = _tmp27_;
#line 214 "system-segment-dictionary.vala"
				_g_free0 (_tmp26_);
#line 214 "system-segment-dictionary.vala"
				_tmp19_ = _tmp28_;
#line 214 "system-segment-dictionary.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1346 "system-segment-dictionary.c"
					goto __catch1_g_error;
				}
#line 214 "system-segment-dictionary.vala"
				_tmp29_ = _tmp19_;
#line 214 "system-segment-dictionary.vala"
				_tmp19_ = NULL;
#line 214 "system-segment-dictionary.vala"
				_g_free0 (_line);
#line 214 "system-segment-dictionary.vala"
				_line = _tmp29_;
#line 213 "system-segment-dictionary.vala"
				_g_free0 (_tmp19_);
#line 1359 "system-segment-dictionary.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				const gchar* _tmp30_;
				GError* _tmp31_;
				const gchar* _tmp32_;
				KkcCandidate** _tmp33_;
#line 213 "system-segment-dictionary.vala"
				e = _inner_error0_;
#line 213 "system-segment-dictionary.vala"
				_inner_error0_ = NULL;
#line 216 "system-segment-dictionary.vala"
				_tmp30_ = line;
#line 216 "system-segment-dictionary.vala"
				_tmp31_ = e;
#line 216 "system-segment-dictionary.vala"
				_tmp32_ = _tmp31_->message;
#line 216 "system-segment-dictionary.vala"
				g_warning ("system-segment-dictionary.vala:216: can't decode line %s: %s", _tmp30_, _tmp32_);
#line 218 "system-segment-dictionary.vala"
				_tmp33_ = g_new0 (KkcCandidate*, 0 + 1);
#line 218 "system-segment-dictionary.vala"
				_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 218 "system-segment-dictionary.vala"
				_vala_candidates = _tmp33_;
#line 218 "system-segment-dictionary.vala"
				_vala_candidates_length1 = 0;
#line 219 "system-segment-dictionary.vala"
				result = FALSE;
#line 219 "system-segment-dictionary.vala"
				_g_error_free0 (e);
#line 219 "system-segment-dictionary.vala"
				_g_free0 (_line);
#line 219 "system-segment-dictionary.vala"
				_g_free0 (line);
#line 219 "system-segment-dictionary.vala"
				_g_free0 (_midasi);
#line 219 "system-segment-dictionary.vala"
				if (candidates) {
#line 219 "system-segment-dictionary.vala"
					*candidates = _vala_candidates;
#line 1403 "system-segment-dictionary.c"
				} else {
#line 219 "system-segment-dictionary.vala"
					_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1407 "system-segment-dictionary.c"
				}
#line 219 "system-segment-dictionary.vala"
				if (candidates_length1) {
#line 219 "system-segment-dictionary.vala"
					*candidates_length1 = _vala_candidates_length1;
#line 1413 "system-segment-dictionary.c"
				}
#line 219 "system-segment-dictionary.vala"
				return result;
#line 1417 "system-segment-dictionary.c"
			}
			__finally1:
#line 213 "system-segment-dictionary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1422 "system-segment-dictionary.c"
				gboolean _tmp34_ = FALSE;
#line 213 "system-segment-dictionary.vala"
				_g_free0 (_line);
#line 213 "system-segment-dictionary.vala"
				_g_free0 (line);
#line 213 "system-segment-dictionary.vala"
				_g_free0 (_midasi);
#line 213 "system-segment-dictionary.vala"
				_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 213 "system-segment-dictionary.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 213 "system-segment-dictionary.vala"
				g_clear_error (&_inner_error0_);
#line 213 "system-segment-dictionary.vala"
				return _tmp34_;
#line 1438 "system-segment-dictionary.c"
			}
#line 221 "system-segment-dictionary.vala"
			_tmp35_ = _line;
#line 221 "system-segment-dictionary.vala"
			_tmp37_ = kkc_dictionary_utils_split_candidates (midasi, okuri, _tmp35_, &_tmp36_);
#line 221 "system-segment-dictionary.vala"
			_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 221 "system-segment-dictionary.vala"
			_vala_candidates = _tmp37_;
#line 221 "system-segment-dictionary.vala"
			_vala_candidates_length1 = _tmp36_;
#line 224 "system-segment-dictionary.vala"
			result = TRUE;
#line 224 "system-segment-dictionary.vala"
			_g_free0 (_line);
#line 224 "system-segment-dictionary.vala"
			_g_free0 (line);
#line 224 "system-segment-dictionary.vala"
			_g_free0 (_midasi);
#line 224 "system-segment-dictionary.vala"
			if (candidates) {
#line 224 "system-segment-dictionary.vala"
				*candidates = _vala_candidates;
#line 1462 "system-segment-dictionary.c"
			} else {
#line 224 "system-segment-dictionary.vala"
				_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1466 "system-segment-dictionary.c"
			}
#line 224 "system-segment-dictionary.vala"
			if (candidates_length1) {
#line 224 "system-segment-dictionary.vala"
				*candidates_length1 = _vala_candidates_length1;
#line 1472 "system-segment-dictionary.c"
			}
#line 224 "system-segment-dictionary.vala"
			return result;
#line 1476 "system-segment-dictionary.c"
		}
#line 203 "system-segment-dictionary.vala"
		_g_free0 (_line);
#line 1480 "system-segment-dictionary.c"
	}
#line 227 "system-segment-dictionary.vala"
	_tmp38_ = g_new0 (KkcCandidate*, 0 + 1);
#line 227 "system-segment-dictionary.vala"
	_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 227 "system-segment-dictionary.vala"
	_vala_candidates = _tmp38_;
#line 227 "system-segment-dictionary.vala"
	_vala_candidates_length1 = 0;
#line 228 "system-segment-dictionary.vala"
	result = FALSE;
#line 228 "system-segment-dictionary.vala"
	_g_free0 (line);
#line 228 "system-segment-dictionary.vala"
	_g_free0 (_midasi);
#line 228 "system-segment-dictionary.vala"
	if (candidates) {
#line 228 "system-segment-dictionary.vala"
		*candidates = _vala_candidates;
#line 1500 "system-segment-dictionary.c"
	} else {
#line 228 "system-segment-dictionary.vala"
		_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1504 "system-segment-dictionary.c"
	}
#line 228 "system-segment-dictionary.vala"
	if (candidates_length1) {
#line 228 "system-segment-dictionary.vala"
		*candidates_length1 = _vala_candidates_length1;
#line 1510 "system-segment-dictionary.c"
	}
#line 228 "system-segment-dictionary.vala"
	return result;
#line 1514 "system-segment-dictionary.c"
}

static gint
kkc_system_segment_dictionary_strcmp_prefix (const gchar* a,
                                             const gchar* b)
{
	GCompareFunc _tmp0_;
	gint result;
#line 231 "system-segment-dictionary.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 231 "system-segment-dictionary.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 232 "system-segment-dictionary.vala"
	if (g_str_has_prefix (a, b)) {
#line 233 "system-segment-dictionary.vala"
		result = 0;
#line 233 "system-segment-dictionary.vala"
		return result;
#line 1533 "system-segment-dictionary.c"
	}
#line 234 "system-segment-dictionary.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 234 "system-segment-dictionary.vala"
	result = _tmp0_ (a, b);
#line 234 "system-segment-dictionary.vala"
	return result;
#line 1541 "system-segment-dictionary.c"
}

/**
         * {@inheritDoc}
         */
static gint
_kkc_system_segment_dictionary_strcmp_prefix_gcompare_func (gconstpointer a,
                                                            gconstpointer b)
{
	gint result;
	result = kkc_system_segment_dictionary_strcmp_prefix ((const gchar*) a, (const gchar*) b);
#line 260 "system-segment-dictionary.vala"
	return result;
#line 1555 "system-segment-dictionary.c"
}

static gchar**
kkc_system_segment_dictionary_real_complete (KkcSegmentDictionary* base,
                                             const gchar* midasi,
                                             gint* result_length1)
{
	KkcSystemSegmentDictionary * self;
	GMappedFile* _tmp0_;
	gchar* _tmp1_;
	GeeArrayList* completion = NULL;
	GeeArrayList* _tmp4_;
	glong start_offset = 0L;
	glong end_offset = 0L;
	GMappedFile* _tmp5_;
	gchar* _midasi = NULL;
	glong pos = 0L;
	gchar* line = NULL;
	const gchar* _tmp16_;
	glong _tmp17_ = 0L;
	gchar* _tmp18_ = NULL;
	gboolean _tmp19_;
	GeeArrayList* _tmp69_;
	gint _tmp70_ = 0;
	gpointer* _tmp71_;
	gchar** _tmp72_;
	gint _tmp72__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 240 "system-segment-dictionary.vala"
	self = (KkcSystemSegmentDictionary*) base;
#line 240 "system-segment-dictionary.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 241 "system-segment-dictionary.vala"
	_tmp0_ = self->priv->mmap;
#line 241 "system-segment-dictionary.vala"
	_tmp1_ = g_mapped_file_get_contents (_tmp0_);
#line 241 "system-segment-dictionary.vala"
	if (_tmp1_ == NULL) {
#line 1595 "system-segment-dictionary.c"
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 242 "system-segment-dictionary.vala"
		_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 242 "system-segment-dictionary.vala"
		_tmp3_ = _tmp2_;
#line 242 "system-segment-dictionary.vala"
		_tmp3__length1 = 0;
#line 242 "system-segment-dictionary.vala"
		if (result_length1) {
#line 242 "system-segment-dictionary.vala"
			*result_length1 = _tmp3__length1;
#line 1609 "system-segment-dictionary.c"
		}
#line 242 "system-segment-dictionary.vala"
		result = _tmp3_;
#line 242 "system-segment-dictionary.vala"
		return result;
#line 1615 "system-segment-dictionary.c"
	}
#line 244 "system-segment-dictionary.vala"
	_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 244 "system-segment-dictionary.vala"
	completion = _tmp4_;
#line 247 "system-segment-dictionary.vala"
	start_offset = self->priv->okuri_nasi_offset;
#line 248 "system-segment-dictionary.vala"
	_tmp5_ = self->priv->mmap;
#line 248 "system-segment-dictionary.vala"
	end_offset = ((glong) g_mapped_file_get_length (_tmp5_)) - 1;
#line 1627 "system-segment-dictionary.c"
	{
		gchar* _tmp6_ = NULL;
		KkcEncodingConverter* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 252 "system-segment-dictionary.vala"
		_tmp7_ = self->priv->converter;
#line 252 "system-segment-dictionary.vala"
		_tmp8_ = kkc_encoding_converter_encode (_tmp7_, midasi, &_inner_error0_);
#line 252 "system-segment-dictionary.vala"
		_tmp6_ = _tmp8_;
#line 252 "system-segment-dictionary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1641 "system-segment-dictionary.c"
			goto __catch0_g_error;
		}
#line 252 "system-segment-dictionary.vala"
		_tmp9_ = _tmp6_;
#line 252 "system-segment-dictionary.vala"
		_tmp6_ = NULL;
#line 252 "system-segment-dictionary.vala"
		_g_free0 (_midasi);
#line 252 "system-segment-dictionary.vala"
		_midasi = _tmp9_;
#line 251 "system-segment-dictionary.vala"
		_g_free0 (_tmp6_);
#line 1654 "system-segment-dictionary.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		GeeArrayList* _tmp12_;
		gint _tmp13_ = 0;
		gpointer* _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
#line 251 "system-segment-dictionary.vala"
		e = _inner_error0_;
#line 251 "system-segment-dictionary.vala"
		_inner_error0_ = NULL;
#line 254 "system-segment-dictionary.vala"
		_tmp10_ = e;
#line 254 "system-segment-dictionary.vala"
		_tmp11_ = _tmp10_->message;
#line 254 "system-segment-dictionary.vala"
		g_warning ("system-segment-dictionary.vala:254: can't decode %s: %s", midasi, _tmp11_);
#line 255 "system-segment-dictionary.vala"
		_tmp12_ = completion;
#line 255 "system-segment-dictionary.vala"
		_tmp14_ = gee_collection_to_array ((GeeCollection*) _tmp12_, &_tmp13_);
#line 255 "system-segment-dictionary.vala"
		_tmp15_ = _tmp14_;
#line 255 "system-segment-dictionary.vala"
		_tmp15__length1 = _tmp13_;
#line 255 "system-segment-dictionary.vala"
		if (result_length1) {
#line 255 "system-segment-dictionary.vala"
			*result_length1 = _tmp15__length1;
#line 1689 "system-segment-dictionary.c"
		}
#line 255 "system-segment-dictionary.vala"
		result = _tmp15_;
#line 255 "system-segment-dictionary.vala"
		_g_error_free0 (e);
#line 255 "system-segment-dictionary.vala"
		_g_free0 (_midasi);
#line 255 "system-segment-dictionary.vala"
		_g_object_unref0 (completion);
#line 255 "system-segment-dictionary.vala"
		return result;
#line 1701 "system-segment-dictionary.c"
	}
	__finally0:
#line 251 "system-segment-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "system-segment-dictionary.vala"
		_g_free0 (_midasi);
#line 251 "system-segment-dictionary.vala"
		_g_object_unref0 (completion);
#line 251 "system-segment-dictionary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 251 "system-segment-dictionary.vala"
		g_clear_error (&_inner_error0_);
#line 251 "system-segment-dictionary.vala"
		return NULL;
#line 1716 "system-segment-dictionary.c"
	}
#line 260 "system-segment-dictionary.vala"
	_tmp16_ = _midasi;
#line 260 "system-segment-dictionary.vala"
	_tmp19_ = kkc_system_segment_dictionary_search_pos (self, _tmp16_, start_offset, end_offset, _kkc_system_segment_dictionary_strcmp_prefix_gcompare_func, &_tmp17_, &_tmp18_, 1);
#line 260 "system-segment-dictionary.vala"
	pos = _tmp17_;
#line 260 "system-segment-dictionary.vala"
	_g_free0 (line);
#line 260 "system-segment-dictionary.vala"
	line = _tmp18_;
#line 260 "system-segment-dictionary.vala"
	if (_tmp19_) {
#line 1730 "system-segment-dictionary.c"
		glong _pos = 0L;
		gchar* _line = NULL;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
#line 267 "system-segment-dictionary.vala"
		_pos = pos;
#line 268 "system-segment-dictionary.vala"
		_tmp20_ = line;
#line 268 "system-segment-dictionary.vala"
		_tmp21_ = g_strdup (_tmp20_);
#line 268 "system-segment-dictionary.vala"
		_line = _tmp21_;
#line 1745 "system-segment-dictionary.c"
		{
			gboolean _tmp22_ = FALSE;
#line 271 "system-segment-dictionary.vala"
			_tmp22_ = TRUE;
#line 271 "system-segment-dictionary.vala"
			while (TRUE) {
#line 1752 "system-segment-dictionary.c"
				gint index = 0;
				const gchar* _tmp29_;
#line 271 "system-segment-dictionary.vala"
				if (!_tmp22_) {
#line 1757 "system-segment-dictionary.c"
					gboolean _tmp23_ = FALSE;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					const gchar* _tmp26_;
#line 290 "system-segment-dictionary.vala"
					_tmp24_ = line;
#line 290 "system-segment-dictionary.vala"
					_tmp25_ = kkc_system_segment_dictionary_read_previous_line (self, &pos, _tmp24_);
#line 290 "system-segment-dictionary.vala"
					_g_free0 (line);
#line 290 "system-segment-dictionary.vala"
					line = _tmp25_;
#line 290 "system-segment-dictionary.vala"
					_tmp26_ = line;
#line 290 "system-segment-dictionary.vala"
					if (_tmp26_ != NULL) {
#line 1774 "system-segment-dictionary.c"
						const gchar* _tmp27_;
						const gchar* _tmp28_;
#line 291 "system-segment-dictionary.vala"
						_tmp27_ = line;
#line 291 "system-segment-dictionary.vala"
						_tmp28_ = _midasi;
#line 291 "system-segment-dictionary.vala"
						_tmp23_ = g_str_has_prefix (_tmp27_, _tmp28_);
#line 1783 "system-segment-dictionary.c"
					} else {
#line 290 "system-segment-dictionary.vala"
						_tmp23_ = FALSE;
#line 1787 "system-segment-dictionary.c"
					}
#line 290 "system-segment-dictionary.vala"
					if (!_tmp23_) {
#line 290 "system-segment-dictionary.vala"
						break;
#line 1793 "system-segment-dictionary.c"
					}
				}
#line 271 "system-segment-dictionary.vala"
				_tmp22_ = FALSE;
#line 272 "system-segment-dictionary.vala"
				_tmp29_ = line;
#line 272 "system-segment-dictionary.vala"
				index = string_index_of (_tmp29_, " ", 0);
#line 273 "system-segment-dictionary.vala"
				if (index < 0) {
#line 1804 "system-segment-dictionary.c"
					const gchar* _tmp30_;
#line 274 "system-segment-dictionary.vala"
					_tmp30_ = line;
#line 274 "system-segment-dictionary.vala"
					g_warning ("system-segment-dictionary.vala:274: corrupted dictionary entry: %s", _tmp30_);
#line 1810 "system-segment-dictionary.c"
				} else {
					gchar* completed = NULL;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					gboolean _tmp33_ = FALSE;
					const gchar* _tmp34_;
					const gchar* _tmp35_;
#line 277 "system-segment-dictionary.vala"
					_tmp31_ = line;
#line 277 "system-segment-dictionary.vala"
					_tmp32_ = string_slice (_tmp31_, (glong) 0, (glong) index);
#line 277 "system-segment-dictionary.vala"
					completed = _tmp32_;
#line 279 "system-segment-dictionary.vala"
					_tmp34_ = completed;
#line 279 "system-segment-dictionary.vala"
					_tmp35_ = _midasi;
#line 279 "system-segment-dictionary.vala"
					if (g_strcmp0 (_tmp34_, _tmp35_) != 0) {
#line 1830 "system-segment-dictionary.c"
						const gchar* _tmp36_;
#line 280 "system-segment-dictionary.vala"
						_tmp36_ = completed;
#line 280 "system-segment-dictionary.vala"
						_tmp33_ = !g_str_has_suffix (_tmp36_, ">");
#line 1836 "system-segment-dictionary.c"
					} else {
#line 279 "system-segment-dictionary.vala"
						_tmp33_ = FALSE;
#line 1840 "system-segment-dictionary.c"
					}
#line 279 "system-segment-dictionary.vala"
					if (_tmp33_) {
#line 1844 "system-segment-dictionary.c"
						{
							gchar* decoded = NULL;
							KkcEncodingConverter* _tmp37_;
							const gchar* _tmp38_;
							gchar* _tmp39_;
							GeeArrayList* _tmp40_;
							const gchar* _tmp41_;
#line 282 "system-segment-dictionary.vala"
							_tmp37_ = self->priv->converter;
#line 282 "system-segment-dictionary.vala"
							_tmp38_ = completed;
#line 282 "system-segment-dictionary.vala"
							_tmp39_ = kkc_encoding_converter_decode (_tmp37_, _tmp38_, &_inner_error0_);
#line 282 "system-segment-dictionary.vala"
							decoded = _tmp39_;
#line 282 "system-segment-dictionary.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1862 "system-segment-dictionary.c"
								goto __catch1_g_error;
							}
#line 283 "system-segment-dictionary.vala"
							_tmp40_ = completion;
#line 283 "system-segment-dictionary.vala"
							_tmp41_ = decoded;
#line 283 "system-segment-dictionary.vala"
							gee_abstract_list_insert ((GeeAbstractList*) _tmp40_, 0, _tmp41_);
#line 281 "system-segment-dictionary.vala"
							_g_free0 (decoded);
#line 1873 "system-segment-dictionary.c"
						}
						goto __finally1;
						__catch1_g_error:
						{
							GError* e = NULL;
							const gchar* _tmp42_;
							GError* _tmp43_;
							const gchar* _tmp44_;
#line 281 "system-segment-dictionary.vala"
							e = _inner_error0_;
#line 281 "system-segment-dictionary.vala"
							_inner_error0_ = NULL;
#line 285 "system-segment-dictionary.vala"
							_tmp42_ = line;
#line 285 "system-segment-dictionary.vala"
							_tmp43_ = e;
#line 285 "system-segment-dictionary.vala"
							_tmp44_ = _tmp43_->message;
#line 285 "system-segment-dictionary.vala"
							g_warning ("system-segment-dictionary.vala:285: can't decode line %s: %s", _tmp42_, _tmp44_);
#line 281 "system-segment-dictionary.vala"
							_g_error_free0 (e);
#line 1896 "system-segment-dictionary.c"
						}
						__finally1:
#line 281 "system-segment-dictionary.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 281 "system-segment-dictionary.vala"
							_g_free0 (completed);
#line 281 "system-segment-dictionary.vala"
							_g_free0 (_line);
#line 281 "system-segment-dictionary.vala"
							_g_free0 (line);
#line 281 "system-segment-dictionary.vala"
							_g_free0 (_midasi);
#line 281 "system-segment-dictionary.vala"
							_g_object_unref0 (completion);
#line 281 "system-segment-dictionary.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 281 "system-segment-dictionary.vala"
							g_clear_error (&_inner_error0_);
#line 281 "system-segment-dictionary.vala"
							return NULL;
#line 1917 "system-segment-dictionary.c"
						}
					}
#line 273 "system-segment-dictionary.vala"
					_g_free0 (completed);
#line 1922 "system-segment-dictionary.c"
				}
			}
		}
#line 294 "system-segment-dictionary.vala"
		pos = _pos;
#line 295 "system-segment-dictionary.vala"
		_tmp45_ = _line;
#line 295 "system-segment-dictionary.vala"
		_tmp46_ = g_strdup (_tmp45_);
#line 295 "system-segment-dictionary.vala"
		_g_free0 (line);
#line 295 "system-segment-dictionary.vala"
		line = _tmp46_;
#line 296 "system-segment-dictionary.vala"
		while (TRUE) {
#line 1938 "system-segment-dictionary.c"
			gboolean _tmp47_ = FALSE;
			const gchar* _tmp48_;
			gchar* _tmp49_;
			const gchar* _tmp50_;
			gint index = 0;
			const gchar* _tmp53_;
#line 296 "system-segment-dictionary.vala"
			_tmp48_ = line;
#line 296 "system-segment-dictionary.vala"
			_tmp49_ = kkc_system_segment_dictionary_read_next_line (self, &pos, _tmp48_);
#line 296 "system-segment-dictionary.vala"
			_g_free0 (line);
#line 296 "system-segment-dictionary.vala"
			line = _tmp49_;
#line 296 "system-segment-dictionary.vala"
			_tmp50_ = line;
#line 296 "system-segment-dictionary.vala"
			if (_tmp50_ != NULL) {
#line 1957 "system-segment-dictionary.c"
				const gchar* _tmp51_;
				const gchar* _tmp52_;
#line 297 "system-segment-dictionary.vala"
				_tmp51_ = line;
#line 297 "system-segment-dictionary.vala"
				_tmp52_ = _midasi;
#line 297 "system-segment-dictionary.vala"
				_tmp47_ = g_str_has_prefix (_tmp51_, _tmp52_);
#line 1966 "system-segment-dictionary.c"
			} else {
#line 296 "system-segment-dictionary.vala"
				_tmp47_ = FALSE;
#line 1970 "system-segment-dictionary.c"
			}
#line 296 "system-segment-dictionary.vala"
			if (!_tmp47_) {
#line 296 "system-segment-dictionary.vala"
				break;
#line 1976 "system-segment-dictionary.c"
			}
#line 298 "system-segment-dictionary.vala"
			_tmp53_ = line;
#line 298 "system-segment-dictionary.vala"
			index = string_index_of (_tmp53_, " ", 0);
#line 299 "system-segment-dictionary.vala"
			if (index < 0) {
#line 1984 "system-segment-dictionary.c"
				const gchar* _tmp54_;
#line 300 "system-segment-dictionary.vala"
				_tmp54_ = line;
#line 300 "system-segment-dictionary.vala"
				g_warning ("system-segment-dictionary.vala:300: corrupted dictionary entry: %s", _tmp54_);
#line 1990 "system-segment-dictionary.c"
			} else {
				gchar* completed = NULL;
				const gchar* _tmp55_;
				gchar* _tmp56_;
				gboolean _tmp57_ = FALSE;
				const gchar* _tmp58_;
				const gchar* _tmp59_;
#line 303 "system-segment-dictionary.vala"
				_tmp55_ = line;
#line 303 "system-segment-dictionary.vala"
				_tmp56_ = string_slice (_tmp55_, (glong) 0, (glong) index);
#line 303 "system-segment-dictionary.vala"
				completed = _tmp56_;
#line 305 "system-segment-dictionary.vala"
				_tmp58_ = completed;
#line 305 "system-segment-dictionary.vala"
				_tmp59_ = _midasi;
#line 305 "system-segment-dictionary.vala"
				if (g_strcmp0 (_tmp58_, _tmp59_) != 0) {
#line 2010 "system-segment-dictionary.c"
					const gchar* _tmp60_;
#line 306 "system-segment-dictionary.vala"
					_tmp60_ = completed;
#line 306 "system-segment-dictionary.vala"
					_tmp57_ = !g_str_has_suffix (_tmp60_, ">");
#line 2016 "system-segment-dictionary.c"
				} else {
#line 305 "system-segment-dictionary.vala"
					_tmp57_ = FALSE;
#line 2020 "system-segment-dictionary.c"
				}
#line 305 "system-segment-dictionary.vala"
				if (_tmp57_) {
#line 2024 "system-segment-dictionary.c"
					{
						gchar* decoded = NULL;
						KkcEncodingConverter* _tmp61_;
						const gchar* _tmp62_;
						gchar* _tmp63_;
						GeeArrayList* _tmp64_;
						const gchar* _tmp65_;
#line 308 "system-segment-dictionary.vala"
						_tmp61_ = self->priv->converter;
#line 308 "system-segment-dictionary.vala"
						_tmp62_ = completed;
#line 308 "system-segment-dictionary.vala"
						_tmp63_ = kkc_encoding_converter_decode (_tmp61_, _tmp62_, &_inner_error0_);
#line 308 "system-segment-dictionary.vala"
						decoded = _tmp63_;
#line 308 "system-segment-dictionary.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2042 "system-segment-dictionary.c"
							goto __catch2_g_error;
						}
#line 309 "system-segment-dictionary.vala"
						_tmp64_ = completion;
#line 309 "system-segment-dictionary.vala"
						_tmp65_ = decoded;
#line 309 "system-segment-dictionary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp64_, _tmp65_);
#line 307 "system-segment-dictionary.vala"
						_g_free0 (decoded);
#line 2053 "system-segment-dictionary.c"
					}
					goto __finally2;
					__catch2_g_error:
					{
						GError* e = NULL;
						const gchar* _tmp66_;
						GError* _tmp67_;
						const gchar* _tmp68_;
#line 307 "system-segment-dictionary.vala"
						e = _inner_error0_;
#line 307 "system-segment-dictionary.vala"
						_inner_error0_ = NULL;
#line 311 "system-segment-dictionary.vala"
						_tmp66_ = line;
#line 311 "system-segment-dictionary.vala"
						_tmp67_ = e;
#line 311 "system-segment-dictionary.vala"
						_tmp68_ = _tmp67_->message;
#line 311 "system-segment-dictionary.vala"
						g_warning ("system-segment-dictionary.vala:311: can't decode line %s: %s", _tmp66_, _tmp68_);
#line 307 "system-segment-dictionary.vala"
						_g_error_free0 (e);
#line 2076 "system-segment-dictionary.c"
					}
					__finally2:
#line 307 "system-segment-dictionary.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 307 "system-segment-dictionary.vala"
						_g_free0 (completed);
#line 307 "system-segment-dictionary.vala"
						_g_free0 (_line);
#line 307 "system-segment-dictionary.vala"
						_g_free0 (line);
#line 307 "system-segment-dictionary.vala"
						_g_free0 (_midasi);
#line 307 "system-segment-dictionary.vala"
						_g_object_unref0 (completion);
#line 307 "system-segment-dictionary.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 307 "system-segment-dictionary.vala"
						g_clear_error (&_inner_error0_);
#line 307 "system-segment-dictionary.vala"
						return NULL;
#line 2097 "system-segment-dictionary.c"
					}
				}
#line 299 "system-segment-dictionary.vala"
				_g_free0 (completed);
#line 2102 "system-segment-dictionary.c"
			}
		}
#line 260 "system-segment-dictionary.vala"
		_g_free0 (_line);
#line 2107 "system-segment-dictionary.c"
	}
#line 318 "system-segment-dictionary.vala"
	_tmp69_ = completion;
#line 318 "system-segment-dictionary.vala"
	_tmp71_ = gee_collection_to_array ((GeeCollection*) _tmp69_, &_tmp70_);
#line 318 "system-segment-dictionary.vala"
	_tmp72_ = _tmp71_;
#line 318 "system-segment-dictionary.vala"
	_tmp72__length1 = _tmp70_;
#line 318 "system-segment-dictionary.vala"
	if (result_length1) {
#line 318 "system-segment-dictionary.vala"
		*result_length1 = _tmp72__length1;
#line 2121 "system-segment-dictionary.c"
	}
#line 318 "system-segment-dictionary.vala"
	result = _tmp72_;
#line 318 "system-segment-dictionary.vala"
	_g_free0 (line);
#line 318 "system-segment-dictionary.vala"
	_g_free0 (_midasi);
#line 318 "system-segment-dictionary.vala"
	_g_object_unref0 (completion);
#line 318 "system-segment-dictionary.vala"
	return result;
#line 2133 "system-segment-dictionary.c"
}

/**
         * Create a new SystemSegmentDictionary.
         *
         * @param path a path to the file
         * @param encoding encoding of the file (default EUC-JP)
         *
         * @return a new FileDictionary
         * @throws GLib.Error if opening the file is failed
         */
KkcSystemSegmentDictionary*
kkc_system_segment_dictionary_construct (GType object_type,
                                         const gchar* path,
                                         const gchar* encoding,
                                         GError** error)
{
	KkcSystemSegmentDictionary * self = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	KkcEncodingConverter* _tmp2_ = NULL;
	KkcEncodingConverter* _tmp3_;
	KkcEncodingConverter* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 337 "system-segment-dictionary.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 337 "system-segment-dictionary.vala"
	g_return_val_if_fail (encoding != NULL, NULL);
#line 337 "system-segment-dictionary.vala"
	self = (KkcSystemSegmentDictionary*) g_object_new (object_type, NULL);
#line 340 "system-segment-dictionary.vala"
	_tmp0_ = g_file_new_for_path (path);
#line 340 "system-segment-dictionary.vala"
	_g_object_unref0 (self->priv->file);
#line 340 "system-segment-dictionary.vala"
	self->priv->file = _tmp0_;
#line 341 "system-segment-dictionary.vala"
	_tmp1_ = g_strdup ("");
#line 341 "system-segment-dictionary.vala"
	_g_free0 (self->priv->etag);
#line 341 "system-segment-dictionary.vala"
	self->priv->etag = _tmp1_;
#line 342 "system-segment-dictionary.vala"
	_tmp3_ = kkc_encoding_converter_new (encoding, &_inner_error0_);
#line 342 "system-segment-dictionary.vala"
	_tmp2_ = _tmp3_;
#line 342 "system-segment-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 342 "system-segment-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 342 "system-segment-dictionary.vala"
		_g_object_unref0 (self);
#line 342 "system-segment-dictionary.vala"
		return NULL;
#line 2188 "system-segment-dictionary.c"
	}
#line 342 "system-segment-dictionary.vala"
	_tmp4_ = _tmp2_;
#line 342 "system-segment-dictionary.vala"
	_tmp2_ = NULL;
#line 342 "system-segment-dictionary.vala"
	_g_object_unref0 (self->priv->converter);
#line 342 "system-segment-dictionary.vala"
	self->priv->converter = _tmp4_;
#line 343 "system-segment-dictionary.vala"
	kkc_system_segment_dictionary_load (self, &_inner_error0_);
#line 343 "system-segment-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 343 "system-segment-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 343 "system-segment-dictionary.vala"
		_g_object_unref0 (_tmp2_);
#line 343 "system-segment-dictionary.vala"
		_g_object_unref0 (self);
#line 343 "system-segment-dictionary.vala"
		return NULL;
#line 2210 "system-segment-dictionary.c"
	}
#line 337 "system-segment-dictionary.vala"
	_g_object_unref0 (_tmp2_);
#line 337 "system-segment-dictionary.vala"
	return self;
#line 2216 "system-segment-dictionary.c"
}

KkcSystemSegmentDictionary*
kkc_system_segment_dictionary_new (const gchar* path,
                                   const gchar* encoding,
                                   GError** error)
{
#line 337 "system-segment-dictionary.vala"
	return kkc_system_segment_dictionary_construct (KKC_TYPE_SYSTEM_SEGMENT_DICTIONARY, path, encoding, error);
#line 2226 "system-segment-dictionary.c"
}

static void
kkc_system_segment_dictionary_class_init (KkcSystemSegmentDictionaryClass * klass,
                                          gpointer klass_data)
{
#line 24 "system-segment-dictionary.vala"
	kkc_system_segment_dictionary_parent_class = g_type_class_peek_parent (klass);
#line 24 "system-segment-dictionary.vala"
	g_type_class_adjust_private_offset (klass, &KkcSystemSegmentDictionary_private_offset);
#line 24 "system-segment-dictionary.vala"
	G_OBJECT_CLASS (klass)->finalize = kkc_system_segment_dictionary_finalize;
#line 2239 "system-segment-dictionary.c"
}

static void
kkc_system_segment_dictionary_kkc_dictionary_interface_init (KkcDictionaryIface * iface,
                                                             gpointer iface_data)
{
#line 24 "system-segment-dictionary.vala"
	kkc_system_segment_dictionary_kkc_dictionary_parent_iface = g_type_interface_peek_parent (iface);
#line 24 "system-segment-dictionary.vala"
	iface->reload = (void (*) (KkcDictionary*, GError**)) kkc_system_segment_dictionary_real_reload;
#line 2250 "system-segment-dictionary.c"
}

static void
kkc_system_segment_dictionary_kkc_segment_dictionary_interface_init (KkcSegmentDictionaryIface * iface,
                                                                     gpointer iface_data)
{
#line 24 "system-segment-dictionary.vala"
	kkc_system_segment_dictionary_kkc_segment_dictionary_parent_iface = g_type_interface_peek_parent (iface);
#line 24 "system-segment-dictionary.vala"
	iface->lookup_candidates = (gboolean (*) (KkcSegmentDictionary*, const gchar*, gboolean, KkcCandidate***, gint*)) kkc_system_segment_dictionary_real_lookup_candidates;
#line 24 "system-segment-dictionary.vala"
	iface->complete = (gchar** (*) (KkcSegmentDictionary*, const gchar*, gint*)) kkc_system_segment_dictionary_real_complete;
#line 2263 "system-segment-dictionary.c"
}

static void
kkc_system_segment_dictionary_instance_init (KkcSystemSegmentDictionary * self,
                                             gpointer klass)
{
#line 24 "system-segment-dictionary.vala"
	self->priv = kkc_system_segment_dictionary_get_instance_private (self);
#line 2272 "system-segment-dictionary.c"
}

static void
kkc_system_segment_dictionary_finalize (GObject * obj)
{
	KkcSystemSegmentDictionary * self;
#line 24 "system-segment-dictionary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_SYSTEM_SEGMENT_DICTIONARY, KkcSystemSegmentDictionary);
#line 321 "system-segment-dictionary.vala"
	_g_object_unref0 (self->priv->file);
#line 322 "system-segment-dictionary.vala"
	_g_mapped_file_unref0 (self->priv->mmap);
#line 323 "system-segment-dictionary.vala"
	_g_free0 (self->priv->etag);
#line 324 "system-segment-dictionary.vala"
	_g_object_unref0 (self->priv->converter);
#line 24 "system-segment-dictionary.vala"
	G_OBJECT_CLASS (kkc_system_segment_dictionary_parent_class)->finalize (obj);
#line 2291 "system-segment-dictionary.c"
}

/**
     * Read-only file based implementation of Dictionary.
     */
static GType
kkc_system_segment_dictionary_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KkcSystemSegmentDictionaryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_system_segment_dictionary_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcSystemSegmentDictionary), 0, (GInstanceInitFunc) kkc_system_segment_dictionary_instance_init, NULL };
	static const GInterfaceInfo kkc_dictionary_info = { (GInterfaceInitFunc) kkc_system_segment_dictionary_kkc_dictionary_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo kkc_segment_dictionary_info = { (GInterfaceInitFunc) kkc_system_segment_dictionary_kkc_segment_dictionary_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType kkc_system_segment_dictionary_type_id;
	kkc_system_segment_dictionary_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcSystemSegmentDictionary", &g_define_type_info, 0);
	g_type_add_interface_static (kkc_system_segment_dictionary_type_id, KKC_TYPE_DICTIONARY, &kkc_dictionary_info);
	g_type_add_interface_static (kkc_system_segment_dictionary_type_id, KKC_TYPE_SEGMENT_DICTIONARY, &kkc_segment_dictionary_info);
	KkcSystemSegmentDictionary_private_offset = g_type_add_instance_private (kkc_system_segment_dictionary_type_id, sizeof (KkcSystemSegmentDictionaryPrivate));
	return kkc_system_segment_dictionary_type_id;
}

GType
kkc_system_segment_dictionary_get_type (void)
{
	static volatile gsize kkc_system_segment_dictionary_type_id__once = 0;
	if (g_once_init_enter (&kkc_system_segment_dictionary_type_id__once)) {
		GType kkc_system_segment_dictionary_type_id;
		kkc_system_segment_dictionary_type_id = kkc_system_segment_dictionary_get_type_once ();
		g_once_init_leave (&kkc_system_segment_dictionary_type_id__once, kkc_system_segment_dictionary_type_id);
	}
	return kkc_system_segment_dictionary_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 148 "rule.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2330 "system-segment-dictionary.c"
		gssize i;
#line 148 "rule.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 148 "rule.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 148 "rule.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2338 "system-segment-dictionary.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 148 "rule.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 148 "rule.vala"
	g_free (array);
#line 2353 "system-segment-dictionary.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 148 "rule.vala"
	if (mem && byte_size != 0) {
#line 148 "rule.vala"
		new_mem = g_malloc (byte_size);
#line 148 "rule.vala"
		memcpy (new_mem, mem, byte_size);
#line 2367 "system-segment-dictionary.c"
	} else {
#line 148 "rule.vala"
		new_mem = NULL;
#line 2371 "system-segment-dictionary.c"
	}
#line 148 "rule.vala"
	return new_mem;
#line 2375 "system-segment-dictionary.c"
}

