/* user-dictionary.c generated by valac 0.56.17, the Vala compiler
 * generated from user-dictionary.vala, do not modify */

/*
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libkkc/libkkc.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	KKC_USER_DICTIONARY_0_PROPERTY,
	KKC_USER_DICTIONARY_NUM_PROPERTIES
};
static GParamSpec* kkc_user_dictionary_properties[KKC_USER_DICTIONARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _KkcUserDictionaryPrivate {
	KkcUserSegmentDictionary* segment_dict;
	KkcUserSentenceDictionary* sentence_dict;
};

static gint KkcUserDictionary_private_offset;
static gpointer kkc_user_dictionary_parent_class = NULL;
static KkcDictionaryIface * kkc_user_dictionary_kkc_dictionary_parent_iface = NULL;
static KkcSegmentDictionaryIface * kkc_user_dictionary_kkc_segment_dictionary_parent_iface = NULL;
static KkcSentenceDictionaryIface * kkc_user_dictionary_kkc_sentence_dictionary_parent_iface = NULL;

static void kkc_user_dictionary_real_reload (KkcDictionary* base,
                                      GError** error);
static void kkc_user_dictionary_real_save (KkcDictionary* base,
                                    GError** error);
static gboolean kkc_user_dictionary_real_lookup_candidates (KkcSegmentDictionary* base,
                                                     const gchar* midasi,
                                                     gboolean okuri,
                                                     KkcCandidate*** candidates,
                                                     gint* candidates_length1);
static gchar** kkc_user_dictionary_real_complete (KkcSegmentDictionary* base,
                                           const gchar* midasi,
                                           gint* result_length1);
static gboolean kkc_user_dictionary_real_select_candidate (KkcSegmentDictionary* base,
                                                    KkcCandidate* candidate);
static gboolean kkc_user_dictionary_real_purge_candidate (KkcSegmentDictionary* base,
                                                   KkcCandidate* candidate);
static gboolean kkc_user_dictionary_real_lookup_constraint (KkcSentenceDictionary* base,
                                                     const gchar* input,
                                                     gint** constraint,
                                                     gint* constraint_length1);
static gboolean kkc_user_dictionary_real_lookup_phrase (KkcSentenceDictionary* base,
                                                 gchar** input,
                                                 gint input_length1,
                                                 gchar*** phrase,
                                                 gint* phrase_length1);
static gboolean kkc_user_dictionary_real_select_segments (KkcSentenceDictionary* base,
                                                   KkcSegment** input,
                                                   gint input_length1);
static void kkc_user_dictionary_finalize (GObject * obj);
static GType kkc_user_dictionary_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
kkc_user_dictionary_get_instance_private (KkcUserDictionary* self)
{
	return G_STRUCT_MEMBER_P (self, KkcUserDictionary_private_offset);
}

KkcUserDictionary*
kkc_user_dictionary_construct (GType object_type,
                               const gchar* basedir,
                               GError** error)
{
	KkcUserDictionary * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	KkcUserSegmentDictionary* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	KkcUserSegmentDictionary* _tmp5_;
	KkcUserSegmentDictionary* _tmp6_;
	KkcUserSegmentDictionary* _tmp7_;
	KkcUserSentenceDictionary* _tmp8_ = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	KkcUserSentenceDictionary* _tmp11_;
	KkcUserSentenceDictionary* _tmp12_;
	KkcUserSentenceDictionary* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 31 "user-dictionary.vala"
	g_return_val_if_fail (basedir != NULL, NULL);
#line 31 "user-dictionary.vala"
	self = (KkcUserDictionary*) g_object_new (object_type, NULL);
#line 32 "user-dictionary.vala"
	_tmp0_ = g_path_get_dirname (basedir);
#line 32 "user-dictionary.vala"
	_tmp1_ = _tmp0_;
#line 32 "user-dictionary.vala"
	g_mkdir_with_parents (_tmp1_, 448);
#line 32 "user-dictionary.vala"
	_g_free0 (_tmp1_);
#line 33 "user-dictionary.vala"
	_tmp3_ = g_build_filename (basedir, "segment", NULL);
#line 33 "user-dictionary.vala"
	_tmp4_ = _tmp3_;
#line 33 "user-dictionary.vala"
	_tmp5_ = kkc_user_segment_dictionary_new (_tmp4_, &_inner_error0_);
#line 33 "user-dictionary.vala"
	_tmp6_ = _tmp5_;
#line 33 "user-dictionary.vala"
	_g_free0 (_tmp4_);
#line 33 "user-dictionary.vala"
	_tmp2_ = _tmp6_;
#line 33 "user-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 33 "user-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 33 "user-dictionary.vala"
		_g_object_unref0 (self);
#line 33 "user-dictionary.vala"
		return NULL;
#line 156 "user-dictionary.c"
	}
#line 33 "user-dictionary.vala"
	_tmp7_ = _tmp2_;
#line 33 "user-dictionary.vala"
	_tmp2_ = NULL;
#line 33 "user-dictionary.vala"
	_g_object_unref0 (self->priv->segment_dict);
#line 33 "user-dictionary.vala"
	self->priv->segment_dict = _tmp7_;
#line 35 "user-dictionary.vala"
	_tmp9_ = g_build_filename (basedir, "sentence", NULL);
#line 35 "user-dictionary.vala"
	_tmp10_ = _tmp9_;
#line 35 "user-dictionary.vala"
	_tmp11_ = kkc_user_sentence_dictionary_new (_tmp10_, &_inner_error0_);
#line 35 "user-dictionary.vala"
	_tmp12_ = _tmp11_;
#line 35 "user-dictionary.vala"
	_g_free0 (_tmp10_);
#line 35 "user-dictionary.vala"
	_tmp8_ = _tmp12_;
#line 35 "user-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 35 "user-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 35 "user-dictionary.vala"
		_g_object_unref0 (_tmp2_);
#line 35 "user-dictionary.vala"
		_g_object_unref0 (self);
#line 35 "user-dictionary.vala"
		return NULL;
#line 188 "user-dictionary.c"
	}
#line 35 "user-dictionary.vala"
	_tmp13_ = _tmp8_;
#line 35 "user-dictionary.vala"
	_tmp8_ = NULL;
#line 35 "user-dictionary.vala"
	_g_object_unref0 (self->priv->sentence_dict);
#line 35 "user-dictionary.vala"
	self->priv->sentence_dict = _tmp13_;
#line 31 "user-dictionary.vala"
	_g_object_unref0 (_tmp8_);
#line 31 "user-dictionary.vala"
	_g_object_unref0 (_tmp2_);
#line 31 "user-dictionary.vala"
	return self;
#line 204 "user-dictionary.c"
}

KkcUserDictionary*
kkc_user_dictionary_new (const gchar* basedir,
                         GError** error)
{
#line 31 "user-dictionary.vala"
	return kkc_user_dictionary_construct (KKC_TYPE_USER_DICTIONARY, basedir, error);
#line 213 "user-dictionary.c"
}

/**
         * {@inheritDoc}
         */
static void
kkc_user_dictionary_real_reload (KkcDictionary* base,
                                 GError** error)
{
	KkcUserDictionary * self;
	KkcUserSegmentDictionary* _tmp0_;
	KkcUserSentenceDictionary* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 42 "user-dictionary.vala"
	self = (KkcUserDictionary*) base;
#line 43 "user-dictionary.vala"
	_tmp0_ = self->priv->segment_dict;
#line 43 "user-dictionary.vala"
	kkc_dictionary_reload ((KkcDictionary*) _tmp0_, &_inner_error0_);
#line 43 "user-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "user-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 43 "user-dictionary.vala"
		return;
#line 239 "user-dictionary.c"
	}
#line 44 "user-dictionary.vala"
	_tmp1_ = self->priv->sentence_dict;
#line 44 "user-dictionary.vala"
	kkc_dictionary_reload ((KkcDictionary*) _tmp1_, &_inner_error0_);
#line 44 "user-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 44 "user-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 44 "user-dictionary.vala"
		return;
#line 251 "user-dictionary.c"
	}
}

/**
         * {@inheritDoc}
         */
static void
kkc_user_dictionary_real_save (KkcDictionary* base,
                               GError** error)
{
	KkcUserDictionary * self;
	KkcUserSegmentDictionary* _tmp0_;
	KkcUserSentenceDictionary* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 50 "user-dictionary.vala"
	self = (KkcUserDictionary*) base;
#line 51 "user-dictionary.vala"
	_tmp0_ = self->priv->segment_dict;
#line 51 "user-dictionary.vala"
	kkc_dictionary_save ((KkcDictionary*) _tmp0_, &_inner_error0_);
#line 51 "user-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 51 "user-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 51 "user-dictionary.vala"
		return;
#line 278 "user-dictionary.c"
	}
#line 52 "user-dictionary.vala"
	_tmp1_ = self->priv->sentence_dict;
#line 52 "user-dictionary.vala"
	kkc_dictionary_save ((KkcDictionary*) _tmp1_, &_inner_error0_);
#line 52 "user-dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 52 "user-dictionary.vala"
		g_propagate_error (error, _inner_error0_);
#line 52 "user-dictionary.vala"
		return;
#line 290 "user-dictionary.c"
	}
}

/**
         * {@inheritDoc}
         */
static gboolean
kkc_user_dictionary_real_lookup_candidates (KkcSegmentDictionary* base,
                                            const gchar* midasi,
                                            gboolean okuri,
                                            KkcCandidate*** candidates,
                                            gint* candidates_length1)
{
	KkcUserDictionary * self;
	KkcCandidate** _vala_candidates = NULL;
	gint _vala_candidates_length1 = 0;
	KkcUserSegmentDictionary* _tmp0_;
	KkcCandidate** _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
	gboolean result;
#line 58 "user-dictionary.vala"
	self = (KkcUserDictionary*) base;
#line 58 "user-dictionary.vala"
	g_return_val_if_fail (midasi != NULL, FALSE);
#line 61 "user-dictionary.vala"
	_tmp0_ = self->priv->segment_dict;
#line 61 "user-dictionary.vala"
	_tmp3_ = kkc_segment_dictionary_lookup_candidates ((KkcSegmentDictionary*) _tmp0_, midasi, okuri, &_tmp1_, &_tmp2_);
#line 61 "user-dictionary.vala"
	_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 61 "user-dictionary.vala"
	_vala_candidates = _tmp1_;
#line 61 "user-dictionary.vala"
	_vala_candidates_length1 = _tmp2_;
#line 61 "user-dictionary.vala"
	result = _tmp3_;
#line 61 "user-dictionary.vala"
	if (candidates) {
#line 61 "user-dictionary.vala"
		*candidates = _vala_candidates;
#line 332 "user-dictionary.c"
	} else {
#line 61 "user-dictionary.vala"
		_vala_candidates = (_vala_array_free (_vala_candidates, _vala_candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 336 "user-dictionary.c"
	}
#line 61 "user-dictionary.vala"
	if (candidates_length1) {
#line 61 "user-dictionary.vala"
		*candidates_length1 = _vala_candidates_length1;
#line 342 "user-dictionary.c"
	}
#line 61 "user-dictionary.vala"
	return result;
#line 346 "user-dictionary.c"
}

/**
         * {@inheritDoc}
         */
static gchar**
kkc_user_dictionary_real_complete (KkcSegmentDictionary* base,
                                   const gchar* midasi,
                                   gint* result_length1)
{
	KkcUserDictionary * self;
	KkcUserSegmentDictionary* _tmp0_;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** result;
#line 69 "user-dictionary.vala"
	self = (KkcUserDictionary*) base;
#line 69 "user-dictionary.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 70 "user-dictionary.vala"
	_tmp0_ = self->priv->segment_dict;
#line 70 "user-dictionary.vala"
	_tmp2_ = kkc_segment_dictionary_complete ((KkcSegmentDictionary*) _tmp0_, midasi, &_tmp1_);
#line 70 "user-dictionary.vala"
	_tmp3_ = _tmp2_;
#line 70 "user-dictionary.vala"
	_tmp3__length1 = _tmp1_;
#line 70 "user-dictionary.vala"
	if (result_length1) {
#line 70 "user-dictionary.vala"
		*result_length1 = _tmp3__length1;
#line 380 "user-dictionary.c"
	}
#line 70 "user-dictionary.vala"
	result = _tmp3_;
#line 70 "user-dictionary.vala"
	return result;
#line 386 "user-dictionary.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
kkc_user_dictionary_real_select_candidate (KkcSegmentDictionary* base,
                                           KkcCandidate* candidate)
{
	KkcUserDictionary * self;
	KkcUserSegmentDictionary* _tmp0_;
	gboolean result;
#line 76 "user-dictionary.vala"
	self = (KkcUserDictionary*) base;
#line 76 "user-dictionary.vala"
	g_return_val_if_fail (candidate != NULL, FALSE);
#line 77 "user-dictionary.vala"
	_tmp0_ = self->priv->segment_dict;
#line 77 "user-dictionary.vala"
	result = kkc_segment_dictionary_select_candidate ((KkcSegmentDictionary*) _tmp0_, candidate);
#line 77 "user-dictionary.vala"
	return result;
#line 409 "user-dictionary.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
kkc_user_dictionary_real_purge_candidate (KkcSegmentDictionary* base,
                                          KkcCandidate* candidate)
{
	KkcUserDictionary * self;
	KkcUserSegmentDictionary* _tmp0_;
	gboolean result;
#line 83 "user-dictionary.vala"
	self = (KkcUserDictionary*) base;
#line 83 "user-dictionary.vala"
	g_return_val_if_fail (candidate != NULL, FALSE);
#line 84 "user-dictionary.vala"
	_tmp0_ = self->priv->segment_dict;
#line 84 "user-dictionary.vala"
	result = kkc_segment_dictionary_purge_candidate ((KkcSegmentDictionary*) _tmp0_, candidate);
#line 84 "user-dictionary.vala"
	return result;
#line 432 "user-dictionary.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
kkc_user_dictionary_real_lookup_constraint (KkcSentenceDictionary* base,
                                            const gchar* input,
                                            gint** constraint,
                                            gint* constraint_length1)
{
	KkcUserDictionary * self;
	gint* _vala_constraint = NULL;
	gint _vala_constraint_length1 = 0;
	KkcUserSentenceDictionary* _tmp0_;
	gint* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
	gboolean result;
#line 90 "user-dictionary.vala"
	self = (KkcUserDictionary*) base;
#line 90 "user-dictionary.vala"
	g_return_val_if_fail (input != NULL, FALSE);
#line 92 "user-dictionary.vala"
	_tmp0_ = self->priv->sentence_dict;
#line 92 "user-dictionary.vala"
	_tmp3_ = kkc_sentence_dictionary_lookup_constraint ((KkcSentenceDictionary*) _tmp0_, input, &_tmp1_, &_tmp2_);
#line 92 "user-dictionary.vala"
	_vala_constraint = (g_free (_vala_constraint), NULL);
#line 92 "user-dictionary.vala"
	_vala_constraint = _tmp1_;
#line 92 "user-dictionary.vala"
	_vala_constraint_length1 = _tmp2_;
#line 92 "user-dictionary.vala"
	result = _tmp3_;
#line 92 "user-dictionary.vala"
	if (constraint) {
#line 92 "user-dictionary.vala"
		*constraint = _vala_constraint;
#line 472 "user-dictionary.c"
	} else {
#line 92 "user-dictionary.vala"
		_vala_constraint = (g_free (_vala_constraint), NULL);
#line 476 "user-dictionary.c"
	}
#line 92 "user-dictionary.vala"
	if (constraint_length1) {
#line 92 "user-dictionary.vala"
		*constraint_length1 = _vala_constraint_length1;
#line 482 "user-dictionary.c"
	}
#line 92 "user-dictionary.vala"
	return result;
#line 486 "user-dictionary.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
kkc_user_dictionary_real_lookup_phrase (KkcSentenceDictionary* base,
                                        gchar** input,
                                        gint input_length1,
                                        gchar*** phrase,
                                        gint* phrase_length1)
{
	KkcUserDictionary * self;
	gchar** _vala_phrase = NULL;
	gint _vala_phrase_length1 = 0;
	KkcUserSentenceDictionary* _tmp0_;
	gchar** _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
	gboolean result;
#line 98 "user-dictionary.vala"
	self = (KkcUserDictionary*) base;
#line 100 "user-dictionary.vala"
	_tmp0_ = self->priv->sentence_dict;
#line 100 "user-dictionary.vala"
	_tmp3_ = kkc_sentence_dictionary_lookup_phrase ((KkcSentenceDictionary*) _tmp0_, input, (gint) input_length1, &_tmp1_, &_tmp2_);
#line 100 "user-dictionary.vala"
	_vala_phrase = (_vala_array_free (_vala_phrase, _vala_phrase_length1, (GDestroyNotify) g_free), NULL);
#line 100 "user-dictionary.vala"
	_vala_phrase = _tmp1_;
#line 100 "user-dictionary.vala"
	_vala_phrase_length1 = _tmp2_;
#line 100 "user-dictionary.vala"
	result = _tmp3_;
#line 100 "user-dictionary.vala"
	if (phrase) {
#line 100 "user-dictionary.vala"
		*phrase = _vala_phrase;
#line 525 "user-dictionary.c"
	} else {
#line 100 "user-dictionary.vala"
		_vala_phrase = (_vala_array_free (_vala_phrase, _vala_phrase_length1, (GDestroyNotify) g_free), NULL);
#line 529 "user-dictionary.c"
	}
#line 100 "user-dictionary.vala"
	if (phrase_length1) {
#line 100 "user-dictionary.vala"
		*phrase_length1 = _vala_phrase_length1;
#line 535 "user-dictionary.c"
	}
#line 100 "user-dictionary.vala"
	return result;
#line 539 "user-dictionary.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
kkc_user_dictionary_real_select_segments (KkcSentenceDictionary* base,
                                          KkcSegment** input,
                                          gint input_length1)
{
	KkcUserDictionary * self;
	KkcUserSentenceDictionary* _tmp0_;
	gboolean result;
#line 106 "user-dictionary.vala"
	self = (KkcUserDictionary*) base;
#line 107 "user-dictionary.vala"
	_tmp0_ = self->priv->sentence_dict;
#line 107 "user-dictionary.vala"
	result = kkc_sentence_dictionary_select_segments ((KkcSentenceDictionary*) _tmp0_, input, (gint) input_length1);
#line 107 "user-dictionary.vala"
	return result;
#line 561 "user-dictionary.c"
}

static void
kkc_user_dictionary_class_init (KkcUserDictionaryClass * klass,
                                gpointer klass_data)
{
#line 27 "user-dictionary.vala"
	kkc_user_dictionary_parent_class = g_type_class_peek_parent (klass);
#line 27 "user-dictionary.vala"
	g_type_class_adjust_private_offset (klass, &KkcUserDictionary_private_offset);
#line 27 "user-dictionary.vala"
	G_OBJECT_CLASS (klass)->finalize = kkc_user_dictionary_finalize;
#line 574 "user-dictionary.c"
}

static void
kkc_user_dictionary_kkc_dictionary_interface_init (KkcDictionaryIface * iface,
                                                   gpointer iface_data)
{
#line 27 "user-dictionary.vala"
	kkc_user_dictionary_kkc_dictionary_parent_iface = g_type_interface_peek_parent (iface);
#line 27 "user-dictionary.vala"
	iface->reload = (void (*) (KkcDictionary*, GError**)) kkc_user_dictionary_real_reload;
#line 27 "user-dictionary.vala"
	iface->save = (void (*) (KkcDictionary*, GError**)) kkc_user_dictionary_real_save;
#line 587 "user-dictionary.c"
}

static void
kkc_user_dictionary_kkc_segment_dictionary_interface_init (KkcSegmentDictionaryIface * iface,
                                                           gpointer iface_data)
{
#line 27 "user-dictionary.vala"
	kkc_user_dictionary_kkc_segment_dictionary_parent_iface = g_type_interface_peek_parent (iface);
#line 27 "user-dictionary.vala"
	iface->lookup_candidates = (gboolean (*) (KkcSegmentDictionary*, const gchar*, gboolean, KkcCandidate***, gint*)) kkc_user_dictionary_real_lookup_candidates;
#line 27 "user-dictionary.vala"
	iface->complete = (gchar** (*) (KkcSegmentDictionary*, const gchar*, gint*)) kkc_user_dictionary_real_complete;
#line 27 "user-dictionary.vala"
	iface->select_candidate = (gboolean (*) (KkcSegmentDictionary*, KkcCandidate*)) kkc_user_dictionary_real_select_candidate;
#line 27 "user-dictionary.vala"
	iface->purge_candidate = (gboolean (*) (KkcSegmentDictionary*, KkcCandidate*)) kkc_user_dictionary_real_purge_candidate;
#line 604 "user-dictionary.c"
}

static void
kkc_user_dictionary_kkc_sentence_dictionary_interface_init (KkcSentenceDictionaryIface * iface,
                                                            gpointer iface_data)
{
#line 27 "user-dictionary.vala"
	kkc_user_dictionary_kkc_sentence_dictionary_parent_iface = g_type_interface_peek_parent (iface);
#line 27 "user-dictionary.vala"
	iface->lookup_constraint = (gboolean (*) (KkcSentenceDictionary*, const gchar*, gint**, gint*)) kkc_user_dictionary_real_lookup_constraint;
#line 27 "user-dictionary.vala"
	iface->lookup_phrase = (gboolean (*) (KkcSentenceDictionary*, gchar**, gint, gchar***, gint*)) kkc_user_dictionary_real_lookup_phrase;
#line 27 "user-dictionary.vala"
	iface->select_segments = (gboolean (*) (KkcSentenceDictionary*, KkcSegment**, gint)) kkc_user_dictionary_real_select_segments;
#line 619 "user-dictionary.c"
}

static void
kkc_user_dictionary_instance_init (KkcUserDictionary * self,
                                   gpointer klass)
{
#line 27 "user-dictionary.vala"
	self->priv = kkc_user_dictionary_get_instance_private (self);
#line 628 "user-dictionary.c"
}

static void
kkc_user_dictionary_finalize (GObject * obj)
{
	KkcUserDictionary * self;
#line 27 "user-dictionary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_USER_DICTIONARY, KkcUserDictionary);
#line 28 "user-dictionary.vala"
	_g_object_unref0 (self->priv->segment_dict);
#line 29 "user-dictionary.vala"
	_g_object_unref0 (self->priv->sentence_dict);
#line 27 "user-dictionary.vala"
	G_OBJECT_CLASS (kkc_user_dictionary_parent_class)->finalize (obj);
#line 643 "user-dictionary.c"
}

/**
     * Helper class which can be used as a single user dictionary.
     *
     * It implements both SegmentDictionary and SentenceDictionary,
     * with write access.
     */
static GType
kkc_user_dictionary_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KkcUserDictionaryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_user_dictionary_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcUserDictionary), 0, (GInstanceInitFunc) kkc_user_dictionary_instance_init, NULL };
	static const GInterfaceInfo kkc_dictionary_info = { (GInterfaceInitFunc) kkc_user_dictionary_kkc_dictionary_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo kkc_segment_dictionary_info = { (GInterfaceInitFunc) kkc_user_dictionary_kkc_segment_dictionary_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo kkc_sentence_dictionary_info = { (GInterfaceInitFunc) kkc_user_dictionary_kkc_sentence_dictionary_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType kkc_user_dictionary_type_id;
	kkc_user_dictionary_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcUserDictionary", &g_define_type_info, 0);
	g_type_add_interface_static (kkc_user_dictionary_type_id, KKC_TYPE_DICTIONARY, &kkc_dictionary_info);
	g_type_add_interface_static (kkc_user_dictionary_type_id, KKC_TYPE_SEGMENT_DICTIONARY, &kkc_segment_dictionary_info);
	g_type_add_interface_static (kkc_user_dictionary_type_id, KKC_TYPE_SENTENCE_DICTIONARY, &kkc_sentence_dictionary_info);
	KkcUserDictionary_private_offset = g_type_add_instance_private (kkc_user_dictionary_type_id, sizeof (KkcUserDictionaryPrivate));
	return kkc_user_dictionary_type_id;
}

GType
kkc_user_dictionary_get_type (void)
{
	static volatile gsize kkc_user_dictionary_type_id__once = 0;
	if (g_once_init_enter (&kkc_user_dictionary_type_id__once)) {
		GType kkc_user_dictionary_type_id;
		kkc_user_dictionary_type_id = kkc_user_dictionary_get_type_once ();
		g_once_init_leave (&kkc_user_dictionary_type_id__once, kkc_user_dictionary_type_id);
	}
	return kkc_user_dictionary_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 148 "rule.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 687 "user-dictionary.c"
		gssize i;
#line 148 "rule.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 148 "rule.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 148 "rule.vala"
				destroy_func (((gpointer*) array)[i]);
#line 695 "user-dictionary.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 148 "rule.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 148 "rule.vala"
	g_free (array);
#line 710 "user-dictionary.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 148 "rule.vala"
	if (mem && byte_size != 0) {
#line 148 "rule.vala"
		new_mem = g_malloc (byte_size);
#line 148 "rule.vala"
		memcpy (new_mem, mem, byte_size);
#line 724 "user-dictionary.c"
	} else {
#line 148 "rule.vala"
		new_mem = NULL;
#line 728 "user-dictionary.c"
	}
#line 148 "rule.vala"
	return new_mem;
#line 732 "user-dictionary.c"
}

